###########################################################################
#
# This program is part of Zenoss Core, an open source monitoring platform.
# Copyright (C) 2007, Zenoss Inc.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# For complete information please visit: http://www.zenoss.com/oss/
#
###########################################################################

TIMEOUT_CODE = 2147209215
RPC_ERROR_CODE = 2147023170

ERROR_CODE_MAP = {'0': ('ERROR_SUCCESS', 'The operation completed successfully.'),
 '1': ('ERROR_INVALID_FUNCTION', 'Incorrect function.'),
 '10': ('ERROR_BAD_ENVIRONMENT', 'The environment is incorrect.'),
 '100': ('ERROR_TOO_MANY_SEMAPHORES',
         'Cannot create another system semaphore.'),
 '10004': ('WSAEINTR',
           'A blocking operation was interrupted by a call to WSACancelBlockingCall.'),
 '10009': ('WSAEBADF', 'The file handle supplied is not valid.'),
 '1001': ('ERROR_STACK_OVERFLOW', 'Recursion too deep; the stack overflowed.'),
 '10013': ('WSAEACCES',
           'An attempt was made to access a socket in a way forbidden by its access permissions.'),
 '10014': ('WSAEFAULT',
           'The system detected an invalid pointer address in attempting to use a pointer argument in a call.'),
 '1002': ('ERROR_INVALID_MESSAGE',
          'The window cannot act on the sent message.'),
 '10022': ('WSAEINVAL', 'An invalid argument was supplied.'),
 '10024': ('WSAEMFILE', 'Too many open sockets.'),
 '1003': ('ERROR_CAN_NOT_COMPLETE', 'Cannot complete this function.'),
 '10035': ('WSAEWOULDBLOCK',
           'A non-blocking socket operation could not be completed immediately.'),
 '10036': ('WSAEINPROGRESS', 'A blocking operation is currently executing.'),
 '10037': ('WSAEALREADY',
           'An operation was attempted on a non-blocking socket that already had an operation in progress.'),
 '10038': ('WSAENOTSOCK',
           'An operation was attempted on something that is not a socket.'),
 '10039': ('WSAEDESTADDRREQ',
           'A required address was omitted from an operation on a socket.'),
 '1004': ('ERROR_INVALID_FLAGS', 'Invalid flags.'),
 '10040': ('WSAEMSGSIZE',
           'A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram into was smaller than the datagram itself.'),
 '10041': ('WSAEPROTOTYPE',
           'A protocol was specified in the socket function call that does not support the semantics of the socket type requested.'),
 '10042': ('WSAENOPROTOOPT',
           'An unknown, invalid, or unsupported option or level was specified in a getsockopt or setsockopt call.'),
 '10043': ('WSAEPROTONOSUPPORT',
           'The requested protocol has not been configured into the system, or no implementation for it exists.'),
 '10044': ('WSAESOCKTNOSUPPORT',
           'The support for the specified socket type does not exist in this address family.'),
 '10045': ('WSAEOPNOTSUPP',
           'The attempted operation is not supported for the type of object referenced.'),
 '10046': ('WSAEPFNOSUPPORT',
           'The protocol family has not been configured into the system or no implementation for it exists.'),
 '10047': ('WSAEAFNOSUPPORT',
           'An address incompatible with the requested protocol was used.'),
 '10048': ('WSAEADDRINUSE',
           'Only one usage of each socket address (protocol/network address/port) is normally permitted.'),
 '10049': ('WSAEADDRNOTAVAIL',
           'The requested address is not valid in its context.'),
 '1005': ('ERROR_UNRECOGNIZED_VOLUME',
          'The volume does not contain a recognized file system. Please make sure that all required file system drivers are loaded and that the volume is not corrupted.'),
 '10050': ('WSAENETDOWN', 'A socket operation encountered a dead network.'),
 '10051': ('WSAENETUNREACH',
           'A socket operation was attempted to an unreachable network.'),
 '10052': ('WSAENETRESET',
           'The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress.'),
 '10053': ('WSAECONNABORTED',
           'An established connection was aborted by the software in your host machine.'),
 '10054': ('WSAECONNRESET',
           'An existing connection was forcibly closed by the remote host.'),
 '10055': ('WSAENOBUFS',
           'An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full.'),
 '10056': ('WSAEISCONN',
           'A connect request was made on an already connected socket.'),
 '10057': ('WSAENOTCONN',
           'A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using a sendto call) no address was supplied.'),
 '10058': ('WSAESHUTDOWN',
           'A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call.'),
 '10059': ('WSAETOOMANYREFS', 'Too many references to some kernel object.'),
 '1006': ('ERROR_FILE_INVALID',
          'The volume for a file has been externally altered so that the opened file is no longer valid.'),
 '10060': ('WSAETIMEDOUT',
           'A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond.'),
 '10061': ('WSAECONNREFUSED',
           'No connection could be made because the target machine actively refused it.'),
 '10062': ('WSAELOOP', 'Cannot translate name.'),
 '10063': ('WSAENAMETOOLONG', 'Name component or name was too long.'),
 '10064': ('WSAEHOSTDOWN',
           'A socket operation failed because the destination host was down.'),
 '10065': ('WSAEHOSTUNREACH',
           'A socket operation was attempted to an unreachable host.'),
 '10066': ('WSAENOTEMPTY', 'Cannot remove a directory that is not empty.'),
 '10067': ('WSAEPROCLIM',
           'A Windows Sockets implementation may have a limit on the number of applications that may use it simultaneously.'),
 '10068': ('WSAEUSERS', 'Ran out of quota.'),
 '10069': ('WSAEDQUOT', 'Ran out of disk quota.'),
 '1007': ('ERROR_FULLSCREEN_MODE',
          'The requested operation cannot be performed in full-screen mode.'),
 '10070': ('WSAESTALE', 'File handle reference is no longer available.'),
 '10071': ('WSAEREMOTE', 'Item is not available locally.'),
 '1008': ('ERROR_NO_TOKEN',
          'An attempt was made to reference a token that does not exist.'),
 '1009': ('ERROR_BADDB', 'The configuration registry database is corrupt.'),
 '10091': ('WSASYSNOTREADY',
           'WSAStartup cannot function at this time because the underlying system it uses to provide network services is currently unavailable.'),
 '10092': ('WSAVERNOTSUPPORTED',
           'The Windows Sockets version requested is not supported.'),
 '10093': ('WSANOTINITIALISED',
           'Either the application has not called WSAStartup, or WSAStartup failed.'),
 '101': ('ERROR_EXCL_SEM_ALREADY_OWNED',
         'The exclusive semaphore is owned by another process.'),
 '1010': ('ERROR_BADKEY', 'The configuration registry key is invalid.'),
 '10101': ('WSAEDISCON',
           'Returned by WSARecv or WSARecvFrom to indicate the remote party has initiated a graceful shutdown sequence.'),
 '10102': ('WSAENOMORE',
           'No more results can be returned by WSALookupServiceNext.'),
 '10103': ('WSAECANCELLED',
           'A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled.'),
 '10104': ('WSAEINVALIDPROCTABLE', 'The procedure call table is invalid.'),
 '10105': ('WSAEINVALIDPROVIDER',
           'The requested service provider is invalid.'),
 '10106': ('WSAEPROVIDERFAILEDINIT',
           'The requested service provider could not be loaded or initialized.'),
 '10107': ('WSASYSCALLFAILURE',
           'A system call that should never fail has failed.'),
 '10108': ('WSASERVICE_NOT_FOUND',
           'No such service is known. The service cannot be found in the specified name space.'),
 '10109': ('WSATYPE_NOT_FOUND', 'The specified class was not found.'),
 '1011': ('ERROR_CANTOPEN',
          'The configuration registry key could not be opened.'),
 '10110': ('WSA_E_NO_MORE',
           'No more results can be returned by WSALookupServiceNext.'),
 '10111': ('WSA_E_CANCELLED',
           'A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled.'),
 '10112': ('WSAEREFUSED',
           'A database query failed because it was actively refused.'),
 '1012': ('ERROR_CANTREAD',
          'The configuration registry key could not be read.'),
 '1013': ('ERROR_CANTWRITE',
          'The configuration registry key could not be written.'),
 '1014': ('ERROR_REGISTRY_RECOVERED',
          'One of the files in the registry database had to be recovered by use of a log or alternate copy. The recovery was successful.'),
 '1015': ('ERROR_REGISTRY_CORRUPT',
          "The registry is corrupted. The structure of one of the files containing registry data is corrupted, or the system's memory image of the file is corrupted, or the file could not be recovered because the alternate copy or log was absent or corrupted."),
 '1016': ('ERROR_REGISTRY_IO_FAILED',
          "An I/O operation initiated by the registry failed unrecoverably. The registry could not read in, or write out, or flush, one of the files that contain the system's image of the registry."),
 '1017': ('ERROR_NOT_REGISTRY_FILE',
          'The system has attempted to load or restore a file into the registry, but the specified file is not in a registry file format.'),
 '1018': ('ERROR_KEY_DELETED',
          'Illegal operation attempted on a registry key that has been marked for deletion.'),
 '1019': ('ERROR_NO_LOG_SPACE',
          'System could not allocate the required space in a registry log.'),
 '102': ('ERROR_SEM_IS_SET', 'The semaphore is set and cannot be closed.'),
 '1020': ('ERROR_KEY_HAS_CHILDREN',
          'Cannot create a symbolic link in a registry key that already has subkeys or values.'),
 '1021': ('ERROR_CHILD_MUST_BE_VOLATILE',
          'Cannot create a stable subkey under a volatile parent key.'),
 '1022': ('ERROR_NOTIFY_ENUM_DIR',
          "A notify change request is being completed and the information is not being returned in the caller's buffer. The caller now needs to enumerate the files to find the changes."),
 '103': ('ERROR_TOO_MANY_SEM_REQUESTS', 'The semaphore cannot be set again.'),
 '104': ('ERROR_INVALID_AT_INTERRUPT_TIME',
         'Cannot request exclusive semaphores at interrupt time.'),
 '105': ('ERROR_SEM_OWNER_DIED',
         'The previous ownership of this semaphore has ended.'),
 '1051': ('ERROR_DEPENDENT_SERVICES_RUNNING',
          'A stop control has been sent to a service that other running services are dependent on.'),
 '1052': ('ERROR_INVALID_SERVICE_CONTROL',
          'The requested control is not valid for this service.'),
 '1053': ('ERROR_SERVICE_REQUEST_TIMEOUT',
          'The service did not respond to the start or control request in a timely fashion.'),
 '1054': ('ERROR_SERVICE_NO_THREAD',
          'A thread could not be created for the service.'),
 '1055': ('ERROR_SERVICE_DATABASE_LOCKED', 'The service database is locked.'),
 '1056': ('ERROR_SERVICE_ALREADY_RUNNING',
          'An instance of the service is already running.'),
 '1057': ('ERROR_INVALID_SERVICE_ACCOUNT',
          'The account name is invalid or does not exist, or the password is invalid for the account name specified.'),
 '1058': ('ERROR_SERVICE_DISABLED',
          'The service cannot be started, either because it is disabled or because it has no enabled devices associated with it.'),
 '1059': ('ERROR_CIRCULAR_DEPENDENCY',
          'Circular service dependency was specified.'),
 '106': ('ERROR_SEM_USER_LIMIT', 'Insert the diskette for drive %1.'),
 '1060': ('ERROR_SERVICE_DOES_NOT_EXIST',
          'The specified service does not exist as an installed service.'),
 '1061': ('ERROR_SERVICE_CANNOT_ACCEPT_CTRL',
          'The service cannot accept control messages at this time.'),
 '1062': ('ERROR_SERVICE_NOT_ACTIVE', 'The service has not been started.'),
 '1063': ('ERROR_FAILED_SERVICE_CONTROLLER_CONNECT',
          'The service process could not connect to the service controller.'),
 '1064': ('ERROR_EXCEPTION_IN_SERVICE',
          'An exception occurred in the service when handling the control request.'),
 '1065': ('ERROR_DATABASE_DOES_NOT_EXIST',
          'The database specified does not exist.'),
 '1066': ('ERROR_SERVICE_SPECIFIC_ERROR',
          'The service has returned a service-specific error code.'),
 '1067': ('ERROR_PROCESS_ABORTED', 'The process terminated unexpectedly.'),
 '1068': ('ERROR_SERVICE_DEPENDENCY_FAIL',
          'The dependency service or group failed to start.'),
 '1069': ('ERROR_SERVICE_LOGON_FAILED',
          'The service did not start due to a logon failure.'),
 '107': ('ERROR_DISK_CHANGE',
         'The program stopped because an alternate diskette was not inserted.'),
 '1070': ('ERROR_SERVICE_START_HANG',
          'After starting, the service hung in a start-pending state.'),
 '1071': ('ERROR_INVALID_SERVICE_LOCK',
          'The specified service database lock is invalid.'),
 '1072': ('ERROR_SERVICE_MARKED_FOR_DELETE',
          'The specified service has been marked for deletion.'),
 '1073': ('ERROR_SERVICE_EXISTS', 'The specified service already exists.'),
 '1074': ('ERROR_ALREADY_RUNNING_LKG',
          'The system is currently running with the last-known-good configuration.'),
 '1075': ('ERROR_SERVICE_DEPENDENCY_DELETED',
          'The dependency service does not exist or has been marked for deletion.'),
 '1076': ('ERROR_BOOT_ALREADY_ACCEPTED',
          'The current boot has already been accepted for use as the last-known-good control set.'),
 '1077': ('ERROR_SERVICE_NEVER_STARTED',
          'No attempts to start the service have been made since the last boot.'),
 '1078': ('ERROR_DUPLICATE_SERVICE_NAME',
          'The name is already in use as either a service name or a service display name.'),
 '1079': ('ERROR_DIFFERENT_SERVICE_ACCOUNT',
          'The account specified for this service is different from the account specified for other services running in the same process.'),
 '108': ('ERROR_DRIVE_LOCKED',
         'The disk is in use or locked by another process.'),
 '1080': ('ERROR_CANNOT_DETECT_DRIVER_FAILURE',
          'Failure actions can only be set for Win32 services, not for drivers.'),
 '1081': ('ERROR_CANNOT_DETECT_PROCESS_ABORT',
          "This service runs in the same process as the service control manager. Therefore, the service control manager cannot take action if this service's process terminates unexpectedly."),
 '1082': ('ERROR_NO_RECOVERY_PROGRAM',
          'No recovery program has been configured for this service.'),
 '1083': ('ERROR_SERVICE_NOT_IN_EXE',
          'The executable program that this service is configured to run in does not implement the service.'),
 '1084': ('ERROR_NOT_SAFEBOOT_SERVICE',
          'This service cannot be started in Safe Mode'),
 '109': ('ERROR_BROKEN_PIPE', 'The pipe has been ended.'),
 '11': ('ERROR_BAD_FORMAT',
        'An attempt was made to load a program with an incorrect format.'),
 '110': ('ERROR_OPEN_FAILED',
         'The system cannot open the device or file specified.'),
 '1100': ('ERROR_END_OF_MEDIA',
          'The physical end of the tape has been reached.'),
 '11001': ('WSAHOST_NOT_FOUND', 'No such host is known.'),
 '11002': ('WSATRY_AGAIN',
           'This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server.'),
 '11003': ('WSANO_RECOVERY',
           'A non-recoverable error occurred during a database lookup.'),
 '11004': ('WSANO_DATA',
           'The requested name is valid, but no data of the requested type was found.'),
 '11005': ('WSA_QOS_RECEIVERS', 'At least one reserve has arrived.'),
 '11006': ('WSA_QOS_SENDERS', 'At least one path has arrived.'),
 '11007': ('WSA_QOS_NO_SENDERS', 'There are no senders.'),
 '11008': ('WSA_QOS_NO_RECEIVERS', 'There are no receivers.'),
 '11009': ('WSA_QOS_REQUEST_CONFIRMED', 'Reserve has been confirmed.'),
 '1101': ('ERROR_FILEMARK_DETECTED', 'A tape access reached a filemark.'),
 '11010': ('WSA_QOS_ADMISSION_FAILURE', 'Error due to lack of resources.'),
 '11011': ('WSA_QOS_POLICY_FAILURE',
           'Rejected for administrative reasons - bad credentials.'),
 '11012': ('WSA_QOS_BAD_STYLE', 'Unknown or conflicting style.'),
 '11013': ('WSA_QOS_BAD_OBJECT',
           'Problem with some part of the filterspec or providerspecific buffer in general.'),
 '11014': ('WSA_QOS_TRAFFIC_CTRL_ERROR',
           'Problem with some part of the flowspec.'),
 '11015': ('WSA_QOS_GENERIC_ERROR', 'General QOS error.'),
 '11016': ('WSA_QOS_ESERVICETYPE',
           'An invalid or unrecognized service type was found in the flowspec.'),
 '11017': ('WSA_QOS_EFLOWSPEC',
           'An invalid or inconsistent flowspec was found in the QOS structure.'),
 '11018': ('WSA_QOS_EPROVSPECBUF', 'Invalid QOS provider-specific buffer.'),
 '11019': ('WSA_QOS_EFILTERSTYLE', 'An invalid QOS filter style was used.'),
 '1102': ('ERROR_BEGINNING_OF_MEDIA',
          'The beginning of the tape or a partition was encountered.'),
 '11020': ('WSA_QOS_EFILTERTYPE', 'An invalid QOS filter type was used.'),
 '11021': ('WSA_QOS_EFILTERCOUNT',
           'An incorrect number of QOS FILTERSPECs were specified in the FLOWDESCRIPTOR.'),
 '11022': ('WSA_QOS_EOBJLENGTH',
           'An object with an invalid ObjectLength field was specified in the QOS provider-specific buffer.'),
 '11023': ('WSA_QOS_EFLOWCOUNT',
           'An incorrect number of flow descriptors was specified in the QOS structure.'),
 '11024': ('WSA_QOS_EUNKOWNPSOBJ',
           'An unrecognized object was found in the QOS provider-specific buffer.'),
 '11025': ('WSA_QOS_EPOLICYOBJ',
           'An invalid policy object was found in the QOS provider-specific buffer.'),
 '11026': ('WSA_QOS_EFLOWDESC',
           'An invalid QOS flow descriptor was found in the flow descriptor list.'),
 '11027': ('WSA_QOS_EPSFLOWSPEC',
           'An invalid or inconsistent flowspec was found in the QOS provider specific buffer.'),
 '11028': ('WSA_QOS_EPSFILTERSPEC',
           'An invalid FILTERSPEC was found in the QOS provider-specific buffer.'),
 '11029': ('WSA_QOS_ESDMODEOBJ',
           'An invalid shape discard mode object was found in the QOS provider specific buffer.'),
 '1103': ('ERROR_SETMARK_DETECTED',
          'A tape access reached the end of a set of files.'),
 '11030': ('WSA_QOS_ESHAPERATEOBJ',
           'An invalid shaping rate object was found in the QOS provider-specific buffer.'),
 '11031': ('WSA_QOS_RESERVED_PETYPE',
           'A reserved policy element was found in the QOS provider-specific buffer.'),
 '1104': ('ERROR_NO_DATA_DETECTED', 'No more data is on the tape.'),
 '1105': ('ERROR_PARTITION_FAILURE', 'Tape could not be partitioned.'),
 '1106': ('ERROR_INVALID_BLOCK_LENGTH',
          'When accessing a new tape of a multivolume partition, the current block size is incorrect.'),
 '1107': ('ERROR_DEVICE_NOT_PARTITIONED',
          'Tape partition information could not be found when loading a tape.'),
 '1108': ('ERROR_UNABLE_TO_LOCK_MEDIA',
          'Unable to lock the media eject mechanism.'),
 '1109': ('ERROR_UNABLE_TO_UNLOAD_MEDIA', 'Unable to unload the media.'),
 '111': ('ERROR_BUFFER_OVERFLOW', 'The file name is too long.'),
 '1110': ('ERROR_MEDIA_CHANGED', 'The media in the drive may have changed.'),
 '1111': ('ERROR_BUS_RESET', 'The I/O bus was reset.'),
 '1112': ('ERROR_NO_MEDIA_IN_DRIVE', 'No media in drive.'),
 '1113': ('ERROR_NO_UNICODE_TRANSLATION',
          'No mapping for the Unicode character exists in the target multi-byte code page.'),
 '1114': ('ERROR_DLL_INIT_FAILED',
          'A dynamic link library (DLL) initialization routine failed.'),
 '1115': ('ERROR_SHUTDOWN_IN_PROGRESS', 'A system shutdown is in progress.'),
 '1116': ('ERROR_NO_SHUTDOWN_IN_PROGRESS',
          'Unable to abort the system shutdown because no shutdown was in progress.'),
 '1117': ('ERROR_IO_DEVICE',
          'The request could not be performed because of an I/O device error.'),
 '1118': ('ERROR_SERIAL_NO_DEVICE',
          'No serial device was successfully initialized. The serial driver will unload.'),
 '1119': ('ERROR_IRQ_BUSY',
          'Unable to open a device that was sharing an interrupt request (IRQ) with other devices. At least one other device that uses that IRQ was already opened.'),
 '112': ('ERROR_DISK_FULL', 'There is not enough space on the disk.'),
 '1120': ('ERROR_MORE_WRITES',
          'A serial I/O operation was completed by another write to the serial port. The IOCTL_SERIAL_XOFF_COUNTER reached zero.)'),
 '1121': ('ERROR_COUNTER_TIMEOUT',
          'A serial I/O operation completed because the timeout period expired. The IOCTL_SERIAL_XOFF_COUNTER did not reach zero.)'),
 '1122': ('ERROR_FLOPPY_ID_MARK_NOT_FOUND',
          'No ID address mark was found on the floppy disk.'),
 '1123': ('ERROR_FLOPPY_WRONG_CYLINDER',
          'Mismatch between the floppy disk sector ID field and the floppy disk controller track address.'),
 '1124': ('ERROR_FLOPPY_UNKNOWN_ERROR',
          'The floppy disk controller reported an error that is not recognized by the floppy disk driver.'),
 '1125': ('ERROR_FLOPPY_BAD_REGISTERS',
          'The floppy disk controller returned inconsistent results in its registers.'),
 '1126': ('ERROR_DISK_RECALIBRATE_FAILED',
          'While accessing the hard disk, a recalibrate operation failed, even after retries.'),
 '1127': ('ERROR_DISK_OPERATION_FAILED',
          'While accessing the hard disk, a disk operation failed even after retries.'),
 '1128': ('ERROR_DISK_RESET_FAILED',
          'While accessing the hard disk, a disk controller reset was needed, but even that failed.'),
 '1129': ('ERROR_EOM_OVERFLOW', 'Physical end of tape encountered.'),
 '113': ('ERROR_NO_MORE_SEARCH_HANDLES',
         'No more internal file identifiers available.'),
 '1130': ('ERROR_NOT_ENOUGH_SERVER_MEMORY',
          'Not enough server storage is available to process this command.'),
 '1131': ('ERROR_POSSIBLE_DEADLOCK',
          'A potential deadlock condition has been detected.'),
 '1132': ('ERROR_MAPPED_ALIGNMENT',
          'The base address or the file offset specified does not have the proper alignment.'),
 '114': ('ERROR_INVALID_TARGET_HANDLE',
         'The target internal file identifier is incorrect.'),
 '1140': ('ERROR_SET_POWER_STATE_VETOED',
          'An attempt to change the system power state was vetoed by another application or driver.'),
 '1141': ('ERROR_SET_POWER_STATE_FAILED',
          'The system BIOS failed an attempt to change the system power state.'),
 '1142': ('ERROR_TOO_MANY_LINKS',
          'An attempt was made to create more links on a file than the file system supports.'),
 '1150': ('ERROR_OLD_WIN_VERSION',
          'The specified program requires a newer version of Windows.'),
 '1151': ('ERROR_APP_WRONG_OS',
          'The specified program is not a Windows or MS-DOS program.'),
 '1152': ('ERROR_SINGLE_INSTANCE_APP',
          'Cannot start more than one instance of the specified program.'),
 '1153': ('ERROR_RMODE_APP',
          'The specified program was written for an earlier version of Windows.'),
 '1154': ('ERROR_INVALID_DLL',
          'One of the library files needed to run this application is damaged.'),
 '1155': ('ERROR_NO_ASSOCIATION',
          'No application is associated with the specified file for this operation.'),
 '1156': ('ERROR_DDE_FAIL',
          'An error occurred in sending the command to the application.'),
 '1157': ('ERROR_DLL_NOT_FOUND',
          'One of the library files needed to run this application cannot be found.'),
 '1158': ('ERROR_NO_MORE_USER_HANDLES',
          'The current process has used all of its system allowance of handles for Window Manager objects.'),
 '1159': ('ERROR_MESSAGE_SYNC_ONLY',
          'The message can be used only with synchronous operations.'),
 '1160': ('ERROR_SOURCE_ELEMENT_EMPTY',
          'The indicated source element has no media.'),
 '1161': ('ERROR_DESTINATION_ELEMENT_FULL',
          'The indicated destination element already contains media.'),
 '1162': ('ERROR_ILLEGAL_ELEMENT_ADDRESS',
          'The indicated element does not exist.'),
 '1163': ('ERROR_MAGAZINE_NOT_PRESENT',
          'The indicated element is part of a magazine that is not present.'),
 '1164': ('ERROR_DEVICE_REINITIALIZATION_NEEDED',
          'The indicated device requires reinitialization due to hardware errors.'),
 '1165': ('ERROR_DEVICE_REQUIRES_CLEANING',
          'The device has indicated that cleaning is required before further operations are attempted.'),
 '1166': ('ERROR_DEVICE_DOOR_OPEN',
          'The device has indicated that its door is open.'),
 '1167': ('ERROR_DEVICE_NOT_CONNECTED', 'The device is not connected.'),
 '1168': ('ERROR_NOT_FOUND', 'Element not found.'),
 '1169': ('ERROR_NO_MATCH',
          'There was no match for the specified key in the index.'),
 '117': ('ERROR_INVALID_CATEGORY',
         'The IOCTL call made by the application program is not correct.'),
 '1170': ('ERROR_SET_NOT_FOUND',
          'The property set specified does not exist on the object.'),
 '1171': ('ERROR_POINT_NOT_FOUND',
          'The point passed to GetMouseMovePoints is not in the buffer.'),
 '1172': ('ERROR_NO_TRACKING_SERVICE',
          'The tracking (workstation) service is not running.'),
 '1173': ('ERROR_NO_VOLUME_ID', 'The Volume ID could not be found.'),
 '1175': ('ERROR_UNABLE_TO_REMOVE_REPLACED',
          'Unable to remove the file to be replaced.'),
 '1176': ('ERROR_UNABLE_TO_MOVE_REPLACEMENT',
          'Unable to move the replacement file to the file to be replaced. The file to be replaced has retained its original name.'),
 '1177': ('ERROR_UNABLE_TO_MOVE_REPLACEMENT_2',
          'Unable to move the replacement file to the file to be replaced. The file to be replaced has been renamed using the backup name.'),
 '1178': ('ERROR_JOURNAL_DELETE_IN_PROGRESS',
          'The volume change journal is being deleted.'),
 '1179': ('ERROR_JOURNAL_NOT_ACTIVE',
          'The volume change journal is not active.'),
 '118': ('ERROR_INVALID_VERIFY_SWITCH',
         'The verify-on-write switch parameter value is not correct.'),
 '1180': ('ERROR_POTENTIAL_FILE_FOUND',
          'A file was found, but it may not be the correct file.'),
 '1181': ('ERROR_JOURNAL_ENTRY_DELETED',
          'The journal entry has been deleted from the journal.'),
 '119': ('ERROR_BAD_DRIVER_LEVEL',
         'The system does not support the command requested.'),
 '1190': ('ERROR_SHUTDOWN_IS_SCHEDULED',
          'A system shutdown has already been scheduled.'),
 '1191': ('ERROR_SHUTDOWN_USERS_LOGGED_ON',
          'The system shutdown cannot be initiated because there are other users logged on to the computer.'),
 '12': ('ERROR_INVALID_ACCESS', 'The access code is invalid.'),
 '120': ('ERROR_CALL_NOT_IMPLEMENTED',
         'This function is not supported on this system.'),
 '1200': ('ERROR_BAD_DEVICE', 'The specified device name is invalid.'),
 '1201': ('ERROR_CONNECTION_UNAVAIL',
          'The device is not currently connected but it is a remembered connection.'),
 '1202': ('ERROR_DEVICE_ALREADY_REMEMBERED',
          'The local device name has a remembered connection to another network resource.'),
 '1203': ('ERROR_NO_NET_OR_BAD_PATH',
          'The network path was either typed incorrectly, does not exist, or the network provider is not currently available. Please try retyping the path or contact your network administrator.'),
 '1204': ('ERROR_BAD_PROVIDER',
          'The specified network provider name is invalid.'),
 '1205': ('ERROR_CANNOT_OPEN_PROFILE',
          'Unable to open the network connection profile.'),
 '1206': ('ERROR_BAD_PROFILE', 'The network connection profile is corrupted.'),
 '1207': ('ERROR_NOT_CONTAINER', 'Cannot enumerate a noncontainer.'),
 '1208': ('ERROR_EXTENDED_ERROR', 'An extended error has occurred.'),
 '1209': ('ERROR_INVALID_GROUPNAME',
          'The format of the specified group name is invalid.'),
 '121': ('ERROR_SEM_TIMEOUT', 'The semaphore timeout period has expired.'),
 '1210': ('ERROR_INVALID_COMPUTERNAME',
          'The format of the specified computer name is invalid.'),
 '1211': ('ERROR_INVALID_EVENTNAME',
          'The format of the specified event name is invalid.'),
 '1212': ('ERROR_INVALID_DOMAINNAME',
          'The format of the specified domain name is invalid.'),
 '1213': ('ERROR_INVALID_SERVICENAME',
          'The format of the specified service name is invalid.'),
 '1214': ('ERROR_INVALID_NETNAME',
          'The format of the specified network name is invalid.'),
 '1215': ('ERROR_INVALID_SHARENAME',
          'The format of the specified share name is invalid.'),
 '1216': ('ERROR_INVALID_PASSWORDNAME',
          'The format of the specified password is invalid.'),
 '1217': ('ERROR_INVALID_MESSAGENAME',
          'The format of the specified message name is invalid.'),
 '1218': ('ERROR_INVALID_MESSAGEDEST',
          'The format of the specified message destination is invalid.'),
 '1219': ('ERROR_SESSION_CREDENTIAL_CONFLICT',
          'Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed. Disconnect all previous connections to the server or shared resource and try again.'),
 '122': ('ERROR_INSUFFICIENT_BUFFER',
         'The data area passed to a system call is too small.'),
 '1220': ('ERROR_REMOTE_SESSION_LIMIT_EXCEEDED',
          'An attempt was made to establish a session to a network server, but there are already too many sessions established to that server.'),
 '1221': ('ERROR_DUP_DOMAINNAME',
          'The workgroup or domain name is already in use by another computer on the network.'),
 '1222': ('ERROR_NO_NETWORK', 'The network is not present or not started.'),
 '1223': ('ERROR_CANCELLED', 'The operation was canceled by the user.'),
 '1224': ('ERROR_USER_MAPPED_FILE',
          'The requested operation cannot be performed on a file with a user-mapped section open.'),
 '1225': ('ERROR_CONNECTION_REFUSED',
          'The remote computer refused the network connection.'),
 '1226': ('ERROR_GRACEFUL_DISCONNECT',
          'The network connection was gracefully closed.'),
 '1227': ('ERROR_ADDRESS_ALREADY_ASSOCIATED',
          'The network transport endpoint already has an address associated with it.'),
 '1228': ('ERROR_ADDRESS_NOT_ASSOCIATED',
          'An address has not yet been associated with the network endpoint.'),
 '1229': ('ERROR_CONNECTION_INVALID',
          'An operation was attempted on a nonexistent network connection.'),
 '123': ('ERROR_INVALID_NAME',
         'The filename, directory name, or volume label syntax is incorrect.'),
 '1230': ('ERROR_CONNECTION_ACTIVE',
          'An invalid operation was attempted on an active network connection.'),
 '1231': ('ERROR_NETWORK_UNREACHABLE',
          'The network location cannot be reached. For information about network troubleshooting, see Windows Help.'),
 '1232': ('ERROR_HOST_UNREACHABLE',
          'The network location cannot be reached. For information about network troubleshooting, see Windows Help.'),
 '1233': ('ERROR_PROTOCOL_UNREACHABLE',
          'The network location cannot be reached. For information about network troubleshooting, see Windows Help.'),
 '1234': ('ERROR_PORT_UNREACHABLE',
          'No service is operating at the destination network endpoint on the remote system.'),
 '1235': ('ERROR_REQUEST_ABORTED', 'The request was aborted.'),
 '1236': ('ERROR_CONNECTION_ABORTED',
          'The network connection was aborted by the local system.'),
 '1237': ('ERROR_RETRY',
          'The operation could not be completed. A retry should be performed.'),
 '1238': ('ERROR_CONNECTION_COUNT_LIMIT',
          'A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached.'),
 '1239': ('ERROR_LOGIN_TIME_RESTRICTION',
          'Attempting to log in during an unauthorized time of day for this account.'),
 '124': ('ERROR_INVALID_LEVEL', 'The system call level is not correct.'),
 '1240': ('ERROR_LOGIN_WKSTA_RESTRICTION',
          'The account is not authorized to log in from this station.'),
 '1241': ('ERROR_INCORRECT_ADDRESS',
          'The network address could not be used for the operation requested.'),
 '1242': ('ERROR_ALREADY_REGISTERED', 'The service is already registered.'),
 '1243': ('ERROR_SERVICE_NOT_FOUND', 'The specified service does not exist.'),
 '1244': ('ERROR_NOT_AUTHENTICATED',
          'The operation being requested was not performed because the user has not been authenticated.'),
 '1245': ('ERROR_NOT_LOGGED_ON',
          'The operation being requested was not performed because the user has not logged on to the network. The specified service does not exist.'),
 '1246': ('ERROR_CONTINUE', 'Continue with work in progress.'),
 '1247': ('ERROR_ALREADY_INITIALIZED',
          'An attempt was made to perform an initialization operation when initialization has already been completed.'),
 '1248': ('ERROR_NO_MORE_DEVICES', 'No more local devices.'),
 '1249': ('ERROR_NO_SUCH_SITE', 'The specified site does not exist.'),
 '125': ('ERROR_NO_VOLUME_LABEL', 'The disk has no volume label.'),
 '1250': ('ERROR_DOMAIN_CONTROLLER_EXISTS',
          'A domain controller with the specified name already exists.'),
 '1251': ('ERROR_ONLY_IF_CONNECTED',
          'This operation is supported only when you are connected to the server.'),
 '1252': ('ERROR_OVERRIDE_NOCHANGES',
          'The group policy framework should call the extension even if there are no changes.'),
 '1253': ('ERROR_BAD_USER_PROFILE',
          'The specified user does not have a valid profile.'),
 '1254': ('ERROR_NOT_SUPPORTED_ON_SBS',
          'This operation is not supported on a computer running Windows Server 2003 for Small Business Server'),
 '1255': ('ERROR_SERVER_SHUTDOWN_IN_PROGRESS',
          'The server machine is shutting down.'),
 '1256': ('ERROR_HOST_DOWN',
          'The remote system is not available. For information about network troubleshooting, see Windows Help.'),
 '1257': ('ERROR_NON_ACCOUNT_SID',
          'The security identifier provided is not from an account domain.'),
 '1258': ('ERROR_NON_DOMAIN_SID',
          'The security identifier provided does not have a domain component.'),
 '1259': ('ERROR_APPHELP_BLOCK',
          'AppHelp dialog canceled thus preventing the application from starting.'),
 '126': ('ERROR_MOD_NOT_FOUND', 'The specified module could not be found.'),
 '1260': ('ERROR_ACCESS_DISABLED_BY_POLICY',
          'This program is blocked by group policy. For more information, contact your system administrator.'),
 '1261': ('ERROR_REG_NAT_CONSUMPTION',
          'A program attempt to use an invalid register value. Normally caused by an uninitialized register. This error is Itanium specific.'),
 '1262': ('ERROR_CSCSHARE_OFFLINE',
          'The share is currently offline or does not exist.'),
 '1263': ('ERROR_PKINIT_FAILURE',
          'The Kerberos protocol encountered an error while validating the KDC certificate during smartcard logon. There is more information in the system event log.'),
 '1264': ('ERROR_SMARTCARD_SUBSYSTEM_FAILURE',
          'The Kerberos protocol encountered an error while attempting to utilize the smartcard subsystem.'),
 '1265': ('ERROR_DOWNGRADE_DETECTED',
          'The system detected a possible attempt to compromise security. Please ensure that you can contact the server that authenticated you.'),
 '127': ('ERROR_PROC_NOT_FOUND',
         'The specified procedure could not be found.'),
 '1271': ('ERROR_MACHINE_LOCKED',
          'The machine is locked and cannot be shut down without the force option.'),
 '1273': ('ERROR_CALLBACK_SUPPLIED_INVALID_DATA',
          'An application-defined callback gave invalid data when called.'),
 '1274': ('ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED',
          'The group policy framework should call the extension in the synchronous foreground policy refresh.'),
 '1275': ('ERROR_DRIVER_BLOCKED', 'This driver has been blocked from loading'),
 '1276': ('ERROR_INVALID_IMPORT_OF_NON_DLL',
          "A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image."),
 '1277': ('ERROR_ACCESS_DISABLED_WEBBLADE',
          'Windows cannot open this program since it has been disabled.'),
 '1278': ('ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER',
          'Windows cannot open this program because the license enforcement system has been tampered with or become corrupted.'),
 '1279': ('ERROR_RECOVERY_FAILURE', 'A transaction recover failed.'),
 '128': ('ERROR_WAIT_NO_CHILDREN',
         'There are no child processes to wait for.'),
 '1280': ('ERROR_ALREADY_FIBER',
          'The current thread has already been converted to a fiber.'),
 '1281': ('ERROR_ALREADY_THREAD',
          'The current thread has already been converted from a fiber.'),
 '1282': ('ERROR_STACK_BUFFER_OVERRUN',
          'The system detected an overrun of a stack-based buffer in this application. This overrun could potentially allow a malicious user to gain control of this application.'),
 '1283': ('ERROR_PARAMETER_QUOTA_EXCEEDED',
          'Data present in one of the parameters is more than the function can operate on.'),
 '1284': ('ERROR_DEBUGGER_INACTIVE',
          'An attempt to do an operation on a debug object failed because the object is in the process of being deleted.'),
 '1285': ('ERROR_DELAY_LOAD_FAILED',
          'An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed.'),
 '1286': ('ERROR_VDM_DISALLOWED',
          '%1 is a 16-bit application. You do not have permissions to execute 16-bit applications. Check your permissions with your system administrator.'),
 '1287': ('ERROR_UNIDENTIFIED_ERROR',
          'Insufficient information exists to identify the cause of failure.'),
 '1288': ('ERROR_INVALID_CRUNTIME_PARAMETER',
          'The parameter passed to a C runtime function is incorrect.'),
 '1289': ('ERROR_BEYOND_VDL',
          'The operation occurred beyond the valid data length of the file.'),
 '129': ('ERROR_CHILD_NOT_COMPLETE',
         'The %1 application cannot be run in Win32 mode.'),
 '1290': ('ERROR_INCOMPATIBLE_SERVICE_SID_TYPE',
          'The service start failed since one or more services in the same process have an incompatible service SID type setting. A service with restricted service SID type can only coexist in the same process with other services with a restricted SID type. If the service SID type for this service was just configured, the hosting process must be restarted in order to start this service.'),
 '1291': ('ERROR_DRIVER_PROCESS_TERMINATED',
          'The process hosting the driver for this device has been terminated.'),
 '1292': ('ERROR_IMPLEMENTATION_LIMIT',
          'An operation attempted to exceed an implementation-defined limit.'),
 '1293': ('ERROR_PROCESS_IS_PROTECTED',
          "Either the target process, or the target thread's containing process, is a protected process."),
 '1294': ('ERROR_SERVICE_NOTIFY_CLIENT_LAGGING',
          'The service notification client is lagging too far behind the current state of services in the machine.'),
 '1295': ('ERROR_DISK_QUOTA_EXCEEDED',
          'The requested file operation failed because the storage quota was exceeded. To free up disk space, move files to a different location or delete unnecessary files. For more information, contact your system administrator.'),
 '1296': ('ERROR_CONTENT_BLOCKED',
          'The requested files operation failed because the storage policy blocks that type of file. For more information, contact your system administrator.'),
 '1297': ('ERROR_INCOMPATIBLE_SERVICE_PRIVILEGE',
          'A privilege that the service requires to function properly does not exist in the service account configuration. You may use the Services Microsoft Management Console (MMC) snap-in (services.msc) and the Local Security Settings MMC snap-in (secpol.msc) to view the service configuration and the account configuration.'),
 '1299': ('ERROR_INVALID_LABEL',
          'Indicates a particular Security ID may not be assigned as the label of an object.'),
 '13': ('ERROR_INVALID_DATA', 'The data is invalid.'),
 '130': ('ERROR_DIRECT_ACCESS_HANDLE',
         'Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O.'),
 '1300': ('ERROR_NOT_ALL_ASSIGNED',
          'Not all privileges or groups referenced are assigned to the caller.'),
 '13000': ('ERROR_IPSEC_QM_POLICY_EXISTS',
           'The specified quick mode policy already exists.'),
 '13001': ('ERROR_IPSEC_QM_POLICY_NOT_FOUND',
           'The specified quick mode policy was not found.'),
 '13002': ('ERROR_IPSEC_QM_POLICY_IN_USE',
           'The specified quick mode policy is being used.'),
 '13003': ('ERROR_IPSEC_MM_POLICY_EXISTS',
           'The specified main mode policy already exists.'),
 '13004': ('ERROR_IPSEC_MM_POLICY_NOT_FOUND',
           'The specified main mode policy was not found'),
 '13005': ('ERROR_IPSEC_MM_POLICY_IN_USE',
           'The specified main mode policy is being used.'),
 '13006': ('ERROR_IPSEC_MM_FILTER_EXISTS',
           'The specified main mode filter already exists.'),
 '13007': ('ERROR_IPSEC_MM_FILTER_NOT_FOUND',
           'The specified main mode filter was not found.'),
 '13008': ('ERROR_IPSEC_TRANSPORT_FILTER_EXISTS',
           'The specified transport mode filter already exists.'),
 '13009': ('ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND',
           'The specified transport mode filter does not exist.'),
 '1301': ('ERROR_SOME_NOT_MAPPED',
          'Some mapping between account names and security IDs was not done.'),
 '13010': ('ERROR_IPSEC_MM_AUTH_EXISTS',
           'The specified main mode authentication list exists.'),
 '13011': ('ERROR_IPSEC_MM_AUTH_NOT_FOUND',
           'The specified main mode authentication list was not found.'),
 '13012': ('ERROR_IPSEC_MM_AUTH_IN_USE',
           'The specified main mode authentication list is being used.'),
 '13013': ('ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND',
           'The specified default main mode policy was not found.'),
 '13014': ('ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND',
           'The specified default main mode authentication list was not found.'),
 '13015': ('ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND',
           'The specified default quick mode policy was not found.'),
 '13016': ('ERROR_IPSEC_TUNNEL_FILTER_EXISTS',
           'The specified tunnel mode filter exists.'),
 '13017': ('ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND',
           'The specified tunnel mode filter was not found.'),
 '13018': ('ERROR_IPSEC_MM_FILTER_PENDING_DELETION',
           'The Main Mode filter is pending deletion.'),
 '13019': ('ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION',
           'The transport filter is pending deletion.'),
 '1302': ('ERROR_NO_QUOTAS_FOR_ACCOUNT',
          'No system quota limits are specifically set for this account.'),
 '13020': ('ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION',
           'The tunnel filter is pending deletion.'),
 '13021': ('ERROR_IPSEC_MM_POLICY_PENDING_DELETION',
           'The Main Mode policy is pending deletion.'),
 '13022': ('ERROR_IPSEC_MM_AUTH_PENDING_DELETION',
           'The Main Mode authentication bundle is pending deletion.'),
 '13023': ('ERROR_IPSEC_QM_POLICY_PENDING_DELETION',
           'The Quick Mode policy is pending deletion.'),
 '13024': ('WARNING_IPSEC_MM_POLICY_PRUNED',
           'The Main Mode policy was successfully added, but some of the requested offers are not supported.'),
 '13025': ('WARNING_IPSEC_QM_POLICY_PRUNED',
           'The Quick Mode policy was successfully added, but some of the requested offers are not supported.'),
 '1303': ('ERROR_LOCAL_USER_SESSION_KEY',
          'No encryption key is available. A well-known encryption key was returned.'),
 '1304': ('ERROR_NULL_LM_PASSWORD',
          'The password is too complex to be converted to a LAN Manager password. The LAN Manager password returned is a NULL string.'),
 '1305': ('ERROR_UNKNOWN_REVISION', 'The revision level is unknown.'),
 '1306': ('ERROR_REVISION_MISMATCH',
          'Indicates two revision levels are incompatible.'),
 '1307': ('ERROR_INVALID_OWNER',
          'This security ID may not be assigned as the owner of this object.'),
 '1308': ('ERROR_INVALID_PRIMARY_GROUP',
          'This security ID may not be assigned as the primary group of an object.'),
 '1309': ('ERROR_NO_IMPERSONATION_TOKEN',
          'An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client.'),
 '131': ('ERROR_NEGATIVE_SEEK',
         'An attempt was made to move the file pointer before the beginning of the file.'),
 '1310': ('ERROR_CANT_DISABLE_MANDATORY', 'The group may not be disabled.'),
 '1311': ('ERROR_NO_LOGON_SERVERS',
          'There are currently no logon servers available to service the logon request.'),
 '1312': ('ERROR_NO_SUCH_LOGON_SESSION',
          'A specified logon session does not exist. It may already have been terminated.'),
 '1313': ('ERROR_NO_SUCH_PRIVILEGE', 'A specified privilege does not exist.'),
 '1314': ('ERROR_PRIVILEGE_NOT_HELD',
          'A required privilege is not held by the client.'),
 '1315': ('ERROR_INVALID_ACCOUNT_NAME',
          'The name provided is not a properly formed account name.'),
 '1316': ('ERROR_USER_EXISTS', 'The specified account already exists.'),
 '1317': ('ERROR_NO_SUCH_USER', 'The specified account does not exist.'),
 '1318': ('ERROR_GROUP_EXISTS', 'The specified group already exists.'),
 '1319': ('ERROR_NO_SUCH_GROUP', 'The specified group does not exist.'),
 '132': ('ERROR_SEEK_ON_DEVICE',
         'The file pointer cannot be set on the specified device or file.'),
 '1320': ('ERROR_MEMBER_IN_GROUP',
          'Either the specified user account is already a member of the specified group, or the specified group cannot be deleted because it contains a member.'),
 '1321': ('ERROR_MEMBER_NOT_IN_GROUP',
          'The specified user account is not a member of the specified group account.'),
 '1322': ('ERROR_LAST_ADMIN',
          'The last remaining administration account cannot be disabled or deleted.'),
 '1323': ('ERROR_WRONG_PASSWORD',
          'Unable to update the password. The value provided as the current password is incorrect.'),
 '1324': ('ERROR_ILL_FORMED_PASSWORD',
          'Unable to update the password. The value provided for the new password contains values that are not allowed in passwords.'),
 '1325': ('ERROR_PASSWORD_RESTRICTION',
          'Unable to update the password. The value provided for the new password does not meet the length, complexity, or history requirements of the domain.'),
 '1326': ('ERROR_LOGON_FAILURE',
          'Logon failure: unknown user name or bad password.'),
 '1327': ('ERROR_ACCOUNT_RESTRICTION',
          'Logon failure: user account restriction. Possible reasons are blank passwords not allowed, logon hour restrictions, or a policy restriction has been enforced.'),
 '1328': ('ERROR_INVALID_LOGON_HOURS',
          'Logon failure: account logon time restriction violation.'),
 '1329': ('ERROR_INVALID_WORKSTATION',
          'Logon failure: user not allowed to log on to this computer.'),
 '133': ('ERROR_IS_JOIN_TARGET',
         'A JOIN or SUBST command cannot be used for a drive that contains previously joined drives.'),
 '1330': ('ERROR_PASSWORD_EXPIRED',
          'Logon failure: the specified account password has expired.'),
 '1331': ('ERROR_ACCOUNT_DISABLED',
          'Logon failure: account currently disabled.'),
 '1332': ('ERROR_NONE_MAPPED',
          'No mapping between account names and security IDs was done.'),
 '1333': ('ERROR_TOO_MANY_LUIDS_REQUESTED',
          'Too many local user identifiers (LUIDs) were requested at one time.'),
 '1334': ('ERROR_LUIDS_EXHAUSTED',
          'No more local user identifiers (LUIDs) are available.'),
 '1335': ('ERROR_INVALID_SUB_AUTHORITY',
          'The subauthority part of a security ID is invalid for this particular use.'),
 '1336': ('ERROR_INVALID_ACL',
          'The access control list (ACL) structure is invalid.'),
 '1337': ('ERROR_INVALID_SID', 'The security ID structure is invalid.'),
 '1338': ('ERROR_INVALID_SECURITY_DESCR',
          'The security descriptor structure is invalid.'),
 '134': ('ERROR_IS_JOINED',
         'An attempt was made to use a JOIN or SUBST command on a drive that has already been joined.'),
 '1340': ('ERROR_BAD_INHERITANCE_ACL',
          'The inherited access control list (ACL) or access control entry (ACE) could not be built.'),
 '1341': ('ERROR_SERVER_DISABLED', 'The server is currently disabled.'),
 '1342': ('ERROR_SERVER_NOT_DISABLED', 'The server is currently enabled.'),
 '1343': ('ERROR_INVALID_ID_AUTHORITY',
          'The value provided was an invalid value for an identifier authority.'),
 '1344': ('ERROR_ALLOTTED_SPACE_EXCEEDED',
          'No more memory is available for security information updates.'),
 '1345': ('ERROR_INVALID_GROUP_ATTRIBUTES',
          'The specified attributes are invalid, or incompatible with the attributes for the group as a whole.'),
 '1346': ('ERROR_BAD_IMPERSONATION_LEVEL',
          'Either a required impersonation level was not provided, or the provided impersonation level is invalid.'),
 '1347': ('ERROR_CANT_OPEN_ANONYMOUS',
          'Cannot open an anonymous level security token.'),
 '1348': ('ERROR_BAD_VALIDATION_CLASS',
          'The validation information class requested was invalid.'),
 '1349': ('ERROR_BAD_TOKEN_TYPE',
          'The type of the token is inappropriate for its attempted use.'),
 '135': ('ERROR_IS_SUBSTED',
         'An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted.'),
 '1350': ('ERROR_NO_SECURITY_ON_OBJECT',
          'Unable to perform a security operation on an object that has no associated security.'),
 '1351': ('ERROR_CANT_ACCESS_DOMAIN_INFO',
          'Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied.'),
 '1352': ('ERROR_INVALID_SERVER_STATE',
          'The security account manager (SAM) or local security authority (LSA) server was in the wrong state to perform the security operation.'),
 '1353': ('ERROR_INVALID_DOMAIN_STATE',
          'The domain was in the wrong state to perform the security operation.'),
 '1354': ('ERROR_INVALID_DOMAIN_ROLE',
          'This operation is only allowed for the Primary Domain Controller of the domain.'),
 '1355': ('ERROR_NO_SUCH_DOMAIN',
          'The specified domain either does not exist or could not be contacted.'),
 '1356': ('ERROR_DOMAIN_EXISTS', 'The specified domain already exists.'),
 '1357': ('ERROR_DOMAIN_LIMIT_EXCEEDED',
          'An attempt was made to exceed the limit on the number of domains per server.'),
 '1358': ('ERROR_INTERNAL_DB_CORRUPTION',
          'Unable to complete the requested operation because of either a catastrophic media failure or a data structure corruption on the disk.'),
 '1359': ('ERROR_INTERNAL_ERROR', 'An internal error occurred.'),
 '136': ('ERROR_NOT_JOINED',
         'The system tried to delete the JOIN of a drive that is not joined.'),
 '1360': ('ERROR_GENERIC_NOT_MAPPED',
          'Generic access types were contained in an access mask which should already be mapped to nongeneric types.'),
 '1361': ('ERROR_BAD_DESCRIPTOR_FORMAT',
          'A security descriptor is not in the right format (absolute or self-relative).'),
 '1362': ('ERROR_NOT_LOGON_PROCESS',
          'The requested action is restricted for use by logon processes only. The calling process has not registered as a logon process.'),
 '1363': ('ERROR_LOGON_SESSION_EXISTS',
          'Cannot start a new logon session with an ID that is already in use.'),
 '1364': ('ERROR_NO_SUCH_PACKAGE',
          'A specified authentication package is unknown.'),
 '1365': ('ERROR_BAD_LOGON_SESSION_STATE',
          'The logon session is not in a state that is consistent with the requested operation.'),
 '1366': ('ERROR_LOGON_SESSION_COLLISION',
          'The logon session ID is already in use.'),
 '1367': ('ERROR_INVALID_LOGON_TYPE',
          'A logon request contained an invalid logon type value.'),
 '1368': ('ERROR_CANNOT_IMPERSONATE',
          'Unable to impersonate using a named pipe until data has been read from that pipe.'),
 '1369': ('ERROR_RXACT_INVALID_STATE',
          'The transaction state of a registry subtree is incompatible with the requested operation.'),
 '137': ('ERROR_NOT_SUBSTED',
         'The system tried to delete the substitution of a drive that is not substituted.'),
 '1370': ('ERROR_RXACT_COMMIT_FAILURE',
          'An internal security database corruption has been encountered.'),
 '1371': ('ERROR_SPECIAL_ACCOUNT',
          'Cannot perform this operation on built-in accounts.'),
 '1372': ('ERROR_SPECIAL_GROUP',
          'Cannot perform this operation on this built-in special group.'),
 '1373': ('ERROR_SPECIAL_USER',
          'Cannot perform this operation on this built-in special user.'),
 '1374': ('ERROR_MEMBERS_PRIMARY_GROUP',
          "The user cannot be removed from a group because the group is currently the user's primary group."),
 '1375': ('ERROR_TOKEN_ALREADY_IN_USE',
          'The token is already in use as a primary token.'),
 '1376': ('ERROR_NO_SUCH_ALIAS', 'The specified local group does not exist.'),
 '1377': ('ERROR_MEMBER_NOT_IN_ALIAS',
          'The specified account name is not a member of the group.'),
 '1378': ('ERROR_MEMBER_IN_ALIAS',
          'The specified account name is already a member of the group.'),
 '1379': ('ERROR_ALIAS_EXISTS', 'The specified local group already exists.'),
 '138': ('ERROR_JOIN_TO_JOIN',
         'The system tried to join a drive to a directory on a joined drive.'),
 '1380': ('ERROR_LOGON_NOT_GRANTED',
          'Logon failure: the user has not been granted the requested logon type at this computer.'),
 '13800': ('ERROR_IPSEC_IKE_NEG_STATUS_BEGIN',
           'ERROR_IPSEC_IKE_NEG_STATUS_BEGIN'),
 '13801': ('ERROR_IPSEC_IKE_AUTH_FAIL',
           'IKE authentication credentials are unacceptable'),
 '13802': ('ERROR_IPSEC_IKE_ATTRIB_FAIL',
           'IKE security attributes are unacceptable'),
 '13803': ('ERROR_IPSEC_IKE_NEGOTIATION_PENDING',
           'IKE Negotiation in progress'),
 '13804': ('ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR',
           'General processing error'),
 '13805': ('ERROR_IPSEC_IKE_TIMED_OUT', 'Negotiation timed out'),
 '13806': ('ERROR_IPSEC_IKE_NO_CERT',
           'IKE failed to find valid machine certificate. Contact your Network Security Administrator about installing a valid certificate in the appropriate Certificate Store.'),
 '13807': ('ERROR_IPSEC_IKE_SA_DELETED',
           'IKE SA deleted by peer before establishment completed'),
 '13808': ('ERROR_IPSEC_IKE_SA_REAPED',
           'IKE SA deleted before establishment completed'),
 '13809': ('ERROR_IPSEC_IKE_MM_ACQUIRE_DROP',
           'Negotiation request sat in Queue too long'),
 '1381': ('ERROR_TOO_MANY_SECRETS',
          'The maximum number of secrets that may be stored in a single system has been exceeded.'),
 '13810': ('ERROR_IPSEC_IKE_QM_ACQUIRE_DROP',
           'Negotiation request sat in Queue too long'),
 '13811': ('ERROR_IPSEC_IKE_QUEUE_DROP_MM',
           'Negotiation request sat in Queue too long'),
 '13812': ('ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM',
           'Negotiation request sat in Queue too long'),
 '13813': ('ERROR_IPSEC_IKE_DROP_NO_RESPONSE', 'No response from peer'),
 '13814': ('ERROR_IPSEC_IKE_MM_DELAY_DROP', 'Negotiation took too long'),
 '13815': ('ERROR_IPSEC_IKE_QM_DELAY_DROP', 'Negotiation took too long'),
 '13816': ('ERROR_IPSEC_IKE_ERROR', 'Unknown error occurred'),
 '13817': ('ERROR_IPSEC_IKE_CRL_FAILED',
           'Certificate Revocation Check failed'),
 '13818': ('ERROR_IPSEC_IKE_INVALID_KEY_USAGE',
           'Invalid certificate key usage'),
 '13819': ('ERROR_IPSEC_IKE_INVALID_CERT_TYPE', 'Invalid certificate type'),
 '1382': ('ERROR_SECRET_TOO_LONG',
          'The length of a secret exceeds the maximum length allowed.'),
 '13820': ('ERROR_IPSEC_IKE_NO_PRIVATE_KEY',
           'IKE negotiation failed because the machine certificate used does not have a private key. IPsec certificates require a private key. Contact your Network Security administrator about replacing with a certificate that has a private key.'),
 '13822': ('ERROR_IPSEC_IKE_DH_FAIL', 'Failure in Diffie-Hellman computation'),
 '13824': ('ERROR_IPSEC_IKE_INVALID_HEADER', 'Invalid header'),
 '13825': ('ERROR_IPSEC_IKE_NO_POLICY', 'No policy configured'),
 '13826': ('ERROR_IPSEC_IKE_INVALID_SIGNATURE', 'Failed to verify signature'),
 '13827': ('ERROR_IPSEC_IKE_KERBEROS_ERROR',
           'Failed to authenticate using Kerberos'),
 '13828': ('ERROR_IPSEC_IKE_NO_PUBLIC_KEY',
           "Peer's certificate did not have a public key"),
 '13829': ('ERROR_IPSEC_IKE_PROCESS_ERR', 'Error processing error payload'),
 '1383': ('ERROR_INTERNAL_DB_ERROR',
          'The local security authority database contains an internal inconsistency.'),
 '13830': ('ERROR_IPSEC_IKE_PROCESS_ERR_SA', 'Error processing SA payload'),
 '13831': ('ERROR_IPSEC_IKE_PROCESS_ERR_PROP',
           'Error processing Proposal payload'),
 '13832': ('ERROR_IPSEC_IKE_PROCESS_ERR_TRANS',
           'Error processing Transform payload'),
 '13833': ('ERROR_IPSEC_IKE_PROCESS_ERR_KE', 'Error processing KE payload'),
 '13834': ('ERROR_IPSEC_IKE_PROCESS_ERR_ID', 'Error processing ID payload'),
 '13835': ('ERROR_IPSEC_IKE_PROCESS_ERR_CERT',
           'Error processing Cert payload'),
 '13836': ('ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ',
           'Error processing Certificate Request payload'),
 '13837': ('ERROR_IPSEC_IKE_PROCESS_ERR_HASH',
           'Error processing Hash payload'),
 '13838': ('ERROR_IPSEC_IKE_PROCESS_ERR_SIG',
           'Error processing Signature payload'),
 '13839': ('ERROR_IPSEC_IKE_PROCESS_ERR_NONCE',
           'Error processing Nonce payload'),
 '1384': ('ERROR_TOO_MANY_CONTEXT_IDS',
          "During a logon attempt, the user's security context accumulated too many security IDs."),
 '13840': ('ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY',
           'Error processing Notify payload'),
 '13841': ('ERROR_IPSEC_IKE_PROCESS_ERR_DELETE',
           'Error processing Delete Payload'),
 '13842': ('ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR',
           'Error processing VendorId payload'),
 '13843': ('ERROR_IPSEC_IKE_INVALID_PAYLOAD', 'Invalid payload received'),
 '13844': ('ERROR_IPSEC_IKE_LOAD_SOFT_SA', 'Soft SA loaded'),
 '13845': ('ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN', 'Soft SA torn down'),
 '13846': ('ERROR_IPSEC_IKE_INVALID_COOKIE', 'Invalid cookie received.'),
 '13847': ('ERROR_IPSEC_IKE_NO_PEER_CERT',
           'Peer failed to send valid machine certificate'),
 '13848': ('ERROR_IPSEC_IKE_PEER_CRL_FAILED',
           "Certification Revocation check of peer's certificate failed"),
 '13849': ('ERROR_IPSEC_IKE_POLICY_CHANGE',
           'New policy invalidated SAs formed with old policy'),
 '1385': ('ERROR_LOGON_TYPE_NOT_GRANTED',
          'Logon failure: the user has not been granted the requested logon type at this computer.'),
 '13850': ('ERROR_IPSEC_IKE_NO_MM_POLICY',
           'There is no available Main Mode IKE policy.'),
 '13851': ('ERROR_IPSEC_IKE_NOTCBPRIV', 'Failed to enabled TCB privilege.'),
 '13852': ('ERROR_IPSEC_IKE_SECLOADFAIL', 'Failed to load SECURITY.DLL.'),
 '13853': ('ERROR_IPSEC_IKE_FAILSSPINIT',
           'Failed to obtain security function table dispatch address from SSPI.'),
 '13854': ('ERROR_IPSEC_IKE_FAILQUERYSSP',
           'Failed to query Kerberos package to obtain max token size.'),
 '13855': ('ERROR_IPSEC_IKE_SRVACQFAIL',
           'Failed to obtain Kerberos server credentials for ISAKMP/ERROR_IPSEC_IKE service. Kerberos authentication will not function. The most likely reason for this is lack of domain membership. This is normal if your computer is a member of a workgroup.'),
 '13856': ('ERROR_IPSEC_IKE_SRVQUERYCRED',
           'Failed to determine SSPI principal name for ISAKMP/ERROR_IPSEC_IKE service (QueryCredentialsAttributes).'),
 '13857': ('ERROR_IPSEC_IKE_GETSPIFAIL',
           'Failed to obtain new SPI for the inbound SA from Ipsec driver. The most common cause for this is that the driver does not have the correct filter. Check your policy to verify the filters.'),
 '13858': ('ERROR_IPSEC_IKE_INVALID_FILTER', 'Given filter is invalid'),
 '13859': ('ERROR_IPSEC_IKE_OUT_OF_MEMORY', 'Memory allocation failed.'),
 '1386': ('ERROR_NT_CROSS_ENCRYPTION_REQUIRED',
          'A cross-encrypted password is necessary to change a user password.'),
 '13860': ('ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED',
           'Failed to add Security Association to IPSec Driver. The most common cause for this is if the IKE negotiation took too long to complete. If the problem persists, reduce the load on the faulting machine.'),
 '13861': ('ERROR_IPSEC_IKE_INVALID_POLICY', 'Invalid policy'),
 '13862': ('ERROR_IPSEC_IKE_UNKNOWN_DOI', 'Invalid DOI'),
 '13863': ('ERROR_IPSEC_IKE_INVALID_SITUATION', 'Invalid situation'),
 '13864': ('ERROR_IPSEC_IKE_DH_FAILURE', 'Diffie-Hellman failure'),
 '13865': ('ERROR_IPSEC_IKE_INVALID_GROUP', 'Invalid Diffie-Hellman group'),
 '13866': ('ERROR_IPSEC_IKE_ENCRYPT', 'Error encrypting payload'),
 '13867': ('ERROR_IPSEC_IKE_DECRYPT', 'Error decrypting payload'),
 '13868': ('ERROR_IPSEC_IKE_POLICY_MATCH', 'Policy match error'),
 '13869': ('ERROR_IPSEC_IKE_UNSUPPORTED_ID', 'Unsupported ID'),
 '1387': ('ERROR_NO_SUCH_MEMBER',
          'A member could not be added to or removed from the local group because the member does not exist.'),
 '13870': ('ERROR_IPSEC_IKE_INVALID_HASH', 'Hash verification failed'),
 '13871': ('ERROR_IPSEC_IKE_INVALID_HASH_ALG', 'Invalid hash algorithm'),
 '13872': ('ERROR_IPSEC_IKE_INVALID_HASH_SIZE', 'Invalid hash size'),
 '13873': ('ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG',
           'Invalid encryption algorithm'),
 '13874': ('ERROR_IPSEC_IKE_INVALID_AUTH_ALG',
           'Invalid authentication algorithm'),
 '13875': ('ERROR_IPSEC_IKE_INVALID_SIG', 'Invalid certificate signature'),
 '13876': ('ERROR_IPSEC_IKE_LOAD_FAILED', 'Load failed'),
 '13877': ('ERROR_IPSEC_IKE_RPC_DELETE', 'Deleted via RPC call'),
 '13878': ('ERROR_IPSEC_IKE_BENIGN_REINIT',
           'Temporary state created to perform reinit. This is not a real failure.'),
 '13879': ('ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY',
           'The lifetime value received in the Responder Lifetime Notify is below the Windows 2000 configured minimum value. Please fix the policy on the peer machine.'),
 '1388': ('ERROR_INVALID_MEMBER',
          'A new member could not be added to a local group because the member has the wrong account type.'),
 '13881': ('ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN',
           'Key length in certificate is too small for configured security requirements.'),
 '13882': ('ERROR_IPSEC_IKE_MM_LIMIT',
           'Max number of established MM SAs to peer exceeded.'),
 '13883': ('ERROR_IPSEC_IKE_NEGOTIATION_DISABLED',
           'IKE received a policy that disables negotiation.'),
 '13884': ('ERROR_IPSEC_IKE_QM_LIMIT',
           'Reached maximum quick mode limit for the main mode. New main mode will be started.'),
 '13885': ('ERROR_IPSEC_IKE_MM_EXPIRED',
           'Main mode SA lifetime expired or peer sent a main mode delete.'),
 '13886': ('ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID',
           'Main mode SA assumed to be invalid because peer stopped responding.'),
 '13887': ('ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH',
           "Certificate doesn't chain to a trusted root in IPsec policy."),
 '13888': ('ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID',
           'Received unexpected message ID.'),
 '13889': ('ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD',
           'Received invalid authentication offers.'),
 '1389': ('ERROR_TOO_MANY_SIDS', 'Too many security IDs have been specified.'),
 '13890': ('ERROR_IPSEC_IKE_DOS_COOKIE_SENT',
           'Sent DOS cookie notify to initiator.'),
 '13891': ('ERROR_IPSEC_IKE_SHUTTING_DOWN', 'IKE service is shutting down.'),
 '13892': ('ERROR_IPSEC_IKE_CGA_AUTH_FAILED',
           'Could not verify binding between CGA address and certificate.'),
 '13893': ('ERROR_IPSEC_IKE_PROCESS_ERR_NATOA',
           'Error processing NatOA payload.'),
 '13894': ('ERROR_IPSEC_IKE_INVALID_MM_FOR_QM',
           'Parameters of the main mode are invalid for this quick mode.'),
 '13895': ('ERROR_IPSEC_IKE_QM_EXPIRED',
           'Quick mode SA was expired by IPsec driver.'),
 '13896': ('ERROR_IPSEC_IKE_TOO_MANY_FILTERS',
           'Too many dynamically added IKEEXT filters were detected.'),
 '139': ('ERROR_SUBST_TO_SUBST',
         'The system tried to substitute a drive to a directory on a substituted drive.'),
 '1390': ('ERROR_LM_CROSS_ENCRYPTION_REQUIRED',
          'A cross-encrypted password is necessary to change this user password.'),
 '1391': ('ERROR_NO_INHERITANCE',
          'Indicates an ACL contains no inheritable components.'),
 '13910': ('ERROR_IPSEC_BAD_SPI',
           'The SPI in the packet does not match a valid IPsec SA.'),
 '13911': ('ERROR_IPSEC_SA_LIFETIME_EXPIRED',
           'Packet was received on an IPsec SA whose lifetime has expired.'),
 '13912': ('ERROR_IPSEC_WRONG_SA',
           "Packet was received on an IPsec SA that doesn't match the packet characteristics."),
 '13913': ('ERROR_IPSEC_REPLAY_CHECK_FAILED',
           'Packet sequence number replay check failed.'),
 '13914': ('ERROR_IPSEC_INVALID_PACKET',
           'IPsec header and/or trailer in the packet is invalid.'),
 '13915': ('ERROR_IPSEC_INTEGRITY_CHECK_FAILED',
           'IPsec integrity check failed.'),
 '13916': ('ERROR_IPSEC_CLEAR_TEXT_DROP',
           'IPsec dropped a clear text packet.'),
 '1392': ('ERROR_FILE_CORRUPT',
          'The file or directory is corrupted and unreadable.'),
 '1393': ('ERROR_DISK_CORRUPT',
          'The disk structure is corrupted and unreadable.'),
 '1394': ('ERROR_NO_USER_SESSION_KEY',
          'There is no user session key for the specified logon session.'),
 '1395': ('ERROR_LICENSE_QUOTA_EXCEEDED',
          'The service being accessed is licensed for a particular number of connections. No more connections can be made to the service at this time because there are already as many connections as the service can accept.'),
 '1396': ('ERROR_WRONG_TARGET_NAME',
          'Logon Failure: The target account name is incorrect.'),
 '1397': ('ERROR_MUTUAL_AUTH_FAILED',
          "Mutual Authentication failed. The server's password is out of date at the domain controller."),
 '1398': ('ERROR_TIME_SKEW',
          'There is a time and/or date difference between the client and server.'),
 '1399': ('ERROR_CURRENT_DOMAIN_NOT_ALLOWED',
          'This operation cannot be performed on the current domain.'),
 '14': ('ERROR_OUTOFMEMORY',
        'Not enough storage is available to complete this operation.'),
 '140': ('ERROR_JOIN_TO_SUBST',
         'The system tried to join a drive to a directory on a substituted drive.'),
 '1400': ('ERROR_INVALID_WINDOW_HANDLE', 'Invalid window handle.'),
 '14000': ('ERROR_SXS_SECTION_NOT_FOUND',
           'The requested section was not present in the activation context.'),
 '14001': ('ERROR_SXS_CANT_GEN_ACTCTX',
           'The application has failed to start because its side-by-side configuration is incorrect. Please see the application event log for more detail.'),
 '14002': ('ERROR_SXS_INVALID_ACTCTXDATA_FORMAT',
           'The application binding data format is invalid.'),
 '14003': ('ERROR_SXS_ASSEMBLY_NOT_FOUND',
           'The referenced assembly is not installed on your system.'),
 '14004': ('ERROR_SXS_MANIFEST_FORMAT_ERROR',
           'The manifest file does not begin with the required tag and format information.'),
 '14005': ('ERROR_SXS_MANIFEST_PARSE_ERROR',
           'The manifest file contains one or more syntax errors.'),
 '14006': ('ERROR_SXS_ACTIVATION_CONTEXT_DISABLED',
           'The application attempted to activate a disabled activation context.'),
 '14007': ('ERROR_SXS_KEY_NOT_FOUND',
           'The requested lookup key was not found in any active activation context.'),
 '14008': ('ERROR_SXS_VERSION_CONFLICT',
           'A component version required by the application conflicts with another component version already active.'),
 '14009': ('ERROR_SXS_WRONG_SECTION_TYPE',
           'The type requested activation context section does not match the query API used.'),
 '1401': ('ERROR_INVALID_MENU_HANDLE', 'Invalid menu handle.'),
 '14010': ('ERROR_SXS_THREAD_QUERIES_DISABLED',
           'Lack of system resources has required isolated activation to be disabled for the current thread of execution.'),
 '14011': ('ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET',
           'An attempt to set the process default activation context failed because the process default activation context was already set.'),
 '14012': ('ERROR_SXS_UNKNOWN_ENCODING_GROUP',
           'The encoding group identifier specified is not recognized.'),
 '14013': ('ERROR_SXS_UNKNOWN_ENCODING',
           'The encoding requested is not recognized.'),
 '14014': ('ERROR_SXS_INVALID_XML_NAMESPACE_URI',
           'The manifest contains a reference to an invalid URI.'),
 '14015': ('ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED',
           'The application manifest contains a reference to a dependent assembly which is not installed'),
 '14016': ('ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED',
           'The manifest for an assembly used by the application has a reference to a dependent assembly which is not installed'),
 '14017': ('ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE',
           'The manifest contains an attribute for the assembly identity which is not valid.'),
 '14018': ('ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE',
           'The manifest is missing the required default namespace specification on the assembly element.'),
 '14019': ('ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE',
           'The manifest has a default namespace specified on the assembly element but its value is not "urn:schemas-microsoft-com:asm.v1".'),
 '1402': ('ERROR_INVALID_CURSOR_HANDLE', 'Invalid cursor handle.'),
 '14020': ('ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT',
           'The private manifest probed has crossed reparse-point-associated path'),
 '14021': ('ERROR_SXS_DUPLICATE_DLL_NAME',
           'Two or more components referenced directly or indirectly by the application manifest have files by the same name.'),
 '14022': ('ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME',
           'Two or more components referenced directly or indirectly by the application manifest have window classes with the same name.'),
 '14023': ('ERROR_SXS_DUPLICATE_CLSID',
           'Two or more components referenced directly or indirectly by the application manifest have the same COM server CLSIDs.'),
 '14024': ('ERROR_SXS_DUPLICATE_IID',
           'Two or more components referenced directly or indirectly by the application manifest have proxies for the same COM interface IIDs.'),
 '14025': ('ERROR_SXS_DUPLICATE_TLBID',
           'Two or more components referenced directly or indirectly by the application manifest have the same COM type library TLBIDs.'),
 '14026': ('ERROR_SXS_DUPLICATE_PROGID',
           'Two or more components referenced directly or indirectly by the application manifest have the same COM ProgIDs.'),
 '14027': ('ERROR_SXS_DUPLICATE_ASSEMBLY_NAME',
           'Two or more components referenced directly or indirectly by the application manifest are different versions of the same component which is not permitted.'),
 '14028': ('ERROR_SXS_FILE_HASH_MISMATCH',
           "A component's file does not match the verification information present in the component manifest."),
 '14029': ('ERROR_SXS_POLICY_PARSE_ERROR',
           'The policy manifest contains one or more syntax errors.'),
 '1403': ('ERROR_INVALID_ACCEL_HANDLE', 'Invalid accelerator table handle.'),
 '14030': ('ERROR_SXS_XML_E_MISSINGQUOTE',
           'Manifest Parse Error : A string literal was expected, but no opening quote character was found.'),
 '14031': ('ERROR_SXS_XML_E_COMMENTSYNTAX',
           'Manifest Parse Error : Incorrect syntax was used in a comment.'),
 '14032': ('ERROR_SXS_XML_E_BADSTARTNAMECHAR',
           'Manifest Parse Error : A name was started with an invalid character.'),
 '14033': ('ERROR_SXS_XML_E_BADNAMECHAR',
           'Manifest Parse Error : A name contained an invalid character.'),
 '14034': ('ERROR_SXS_XML_E_BADCHARINSTRING',
           'Manifest Parse Error : A string literal contained an invalid character.'),
 '14035': ('ERROR_SXS_XML_E_XMLDECLSYNTAX',
           'Manifest Parse Error : Invalid syntax for an xml declaration.'),
 '14036': ('ERROR_SXS_XML_E_BADCHARDATA',
           'Manifest Parse Error : An Invalid character was found in text content.'),
 '14037': ('ERROR_SXS_XML_E_MISSINGWHITESPACE',
           'Manifest Parse Error : Required white space was missing.'),
 '14038': ('ERROR_SXS_XML_E_EXPECTINGTAGEND',
           "Manifest Parse Error : The character '>' was expected."),
 '14039': ('ERROR_SXS_XML_E_MISSINGSEMICOLON',
           'Manifest Parse Error : A semi colon character was expected.'),
 '1404': ('ERROR_INVALID_HOOK_HANDLE', 'Invalid hook handle.'),
 '14040': ('ERROR_SXS_XML_E_UNBALANCEDPAREN',
           'Manifest Parse Error : Unbalanced parentheses.'),
 '14041': ('ERROR_SXS_XML_E_INTERNALERROR',
           'Manifest Parse Error : Internal error.'),
 '14042': ('ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE',
           'Manifest Parse Error : Whitespace is not allowed at this location.'),
 '14043': ('ERROR_SXS_XML_E_INCOMPLETE_ENCODING',
           'Manifest Parse Error : End of file reached in invalid state for current encoding.'),
 '14044': ('ERROR_SXS_XML_E_MISSING_PAREN',
           'Manifest Parse Error : Missing parenthesis.'),
 '14045': ('ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE',
           'Manifest Parse Error : A single or double closing quote character (\\\' or \\") is missing.'),
 '14046': ('ERROR_SXS_XML_E_MULTIPLE_COLONS',
           'Manifest Parse Error : Multiple colons are not allowed in a name.'),
 '14047': ('ERROR_SXS_XML_E_INVALID_DECIMAL',
           'Manifest Parse Error : Invalid character for decimal digit.'),
 '14048': ('ERROR_SXS_XML_E_INVALID_HEXIDECIMAL',
           'Manifest Parse Error : Invalid character for hexadecimal digit.'),
 '14049': ('ERROR_SXS_XML_E_INVALID_UNICODE',
           'Manifest Parse Error : Invalid unicode character value for this platform.'),
 '1405': ('ERROR_INVALID_DWP_HANDLE',
          'Invalid handle to a multiple-window position structure.'),
 '14050': ('ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK',
           "Manifest Parse Error : Expecting whitespace or '?'."),
 '14051': ('ERROR_SXS_XML_E_UNEXPECTEDENDTAG',
           'Manifest Parse Error : End tag was not expected at this location.'),
 '14052': ('ERROR_SXS_XML_E_UNCLOSEDTAG',
           'Manifest Parse Error : The following tags were not closed: %1.'),
 '14053': ('ERROR_SXS_XML_E_DUPLICATEATTRIBUTE',
           'Manifest Parse Error : Duplicate attribute.'),
 '14054': ('ERROR_SXS_XML_E_MULTIPLEROOTS',
           'Manifest Parse Error : Only one top level element is allowed in an XML document.'),
 '14055': ('ERROR_SXS_XML_E_INVALIDATROOTLEVEL',
           'Manifest Parse Error : Invalid at the top level of the document.'),
 '14056': ('ERROR_SXS_XML_E_BADXMLDECL',
           'Manifest Parse Error : Invalid xml declaration.'),
 '14057': ('ERROR_SXS_XML_E_MISSINGROOT',
           'Manifest Parse Error : XML document must have a top level element.'),
 '14058': ('ERROR_SXS_XML_E_UNEXPECTEDEOF',
           'Manifest Parse Error : Unexpected end of file.'),
 '14059': ('ERROR_SXS_XML_E_BADPEREFINSUBSET',
           'Manifest Parse Error : Parameter entities cannot be used inside markup declarations in an internal subset.'),
 '1406': ('ERROR_TLW_WITH_WSCHILD', 'Cannot create a top-level child window.'),
 '14060': ('ERROR_SXS_XML_E_UNCLOSEDSTARTTAG',
           'Manifest Parse Error : Element was not closed.'),
 '14061': ('ERROR_SXS_XML_E_UNCLOSEDENDTAG',
           "Manifest Parse Error : End element was missing the character '>'."),
 '14062': ('ERROR_SXS_XML_E_UNCLOSEDSTRING',
           'Manifest Parse Error : A string literal was not closed.'),
 '14063': ('ERROR_SXS_XML_E_UNCLOSEDCOMMENT',
           'Manifest Parse Error : A comment was not closed.'),
 '14064': ('ERROR_SXS_XML_E_UNCLOSEDDECL',
           'Manifest Parse Error : A declaration was not closed.'),
 '14065': ('ERROR_SXS_XML_E_UNCLOSEDCDATA',
           'Manifest Parse Error : A CDATA section was not closed.'),
 '14066': ('ERROR_SXS_XML_E_RESERVEDNAMESPACE',
           'Manifest Parse Error : The namespace prefix is not allowed to start with the reserved string "xml".'),
 '14067': ('ERROR_SXS_XML_E_INVALIDENCODING',
           'Manifest Parse Error : System does not support the specified encoding.'),
 '14068': ('ERROR_SXS_XML_E_INVALIDSWITCH',
           'Manifest Parse Error : Switch from current encoding to specified encoding not supported.'),
 '14069': ('ERROR_SXS_XML_E_BADXMLCASE',
           "Manifest Parse Error : The name 'xml' is reserved and must be lower case."),
 '1407': ('ERROR_CANNOT_FIND_WND_CLASS', 'Cannot find window class.'),
 '14070': ('ERROR_SXS_XML_E_INVALID_STANDALONE',
           "Manifest Parse Error : The standalone attribute must have the value 'yes' or 'no'."),
 '14071': ('ERROR_SXS_XML_E_UNEXPECTED_STANDALONE',
           'Manifest Parse Error : The standalone attribute cannot be used in external entities.'),
 '14072': ('ERROR_SXS_XML_E_INVALID_VERSION',
           'Manifest Parse Error : Invalid version number.'),
 '14073': ('ERROR_SXS_XML_E_MISSINGEQUALS',
           'Manifest Parse Error : Missing equals sign between attribute and attribute value.'),
 '14074': ('ERROR_SXS_PROTECTION_RECOVERY_FAILED',
           'Assembly Protection Error : Unable to recover the specified assembly.'),
 '14075': ('ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT',
           'Assembly Protection Error : The public key for an assembly was too short to be allowed.'),
 '14076': ('ERROR_SXS_PROTECTION_CATALOG_NOT_VALID',
           "Assembly Protection Error : The catalog for an assembly is not valid, or does not match the assembly's manifest."),
 '14077': ('ERROR_SXS_UNTRANSLATABLE_HRESULT',
           'An HRESULT could not be translated to a corresponding Win32 error code.'),
 '14078': ('ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING',
           'Assembly Protection Error : The catalog for an assembly is missing.'),
 '14079': ('ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE',
           'The supplied assembly identity is missing one or more attributes which must be present in this context.'),
 '1408': ('ERROR_WINDOW_OF_OTHER_THREAD',
          'Invalid window; it belongs to other thread.'),
 '14080': ('ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME',
           'The supplied assembly identity has one or more attribute names that contain characters not permitted in XML names.'),
 '14081': ('ERROR_SXS_ASSEMBLY_MISSING',
           'The referenced assembly could not be found.'),
 '14082': ('ERROR_SXS_CORRUPT_ACTIVATION_STACK',
           'The activation context activation stack for the running thread of execution is corrupt.'),
 '14083': ('ERROR_SXS_CORRUPTION',
           'The application isolation metadata for this process or thread has become corrupt.'),
 '14084': ('ERROR_SXS_EARLY_DEACTIVATION',
           'The activation context being deactivated is not the most recently activated one.'),
 '14085': ('ERROR_SXS_INVALID_DEACTIVATION',
           'The activation context being deactivated is not active for the current thread of execution.'),
 '14086': ('ERROR_SXS_MULTIPLE_DEACTIVATION',
           'The activation context being deactivated has already been deactivated.'),
 '14087': ('ERROR_SXS_PROCESS_TERMINATION_REQUESTED',
           'A component used by the isolation facility has requested to terminate the process.'),
 '14088': ('ERROR_SXS_RELEASE_ACTIVATION_CONTEXT',
           'A kernel mode component is releasing a reference on an activation context.'),
 '14089': ('ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY',
           'The activation context of system default assembly could not be generated.'),
 '1409': ('ERROR_HOTKEY_ALREADY_REGISTERED', 'Hot key is already registered.'),
 '14090': ('ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE',
           'The value of an attribute in an identity is not within the legal range.'),
 '14091': ('ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME',
           'The name of an attribute in an identity is not within the legal range.'),
 '14092': ('ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE',
           'An identity contains two definitions for the same attribute.'),
 '14093': ('ERROR_SXS_IDENTITY_PARSE_ERROR',
           'The identity string is malformed. This may be due to a trailing comma, more than two unnamed attributes, missing attribute name or missing attribute value.'),
 '14094': ('ERROR_MALFORMED_SUBSTITUTION_STRING',
           "A string containing localized substitutable content was malformed. Either a dollar sign ($) was followed by something other than a left parenthesis or another dollar sign or an substitution's right parenthesis was not found."),
 '14095': ('ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN',
           'The public key token does not correspond to the public key specified.'),
 '14096': ('ERROR_UNMAPPED_SUBSTITUTION_STRING',
           'A substitution string had no mapping.'),
 '14097': ('ERROR_SXS_ASSEMBLY_NOT_LOCKED',
           'The component must be locked before making the request.'),
 '14098': ('ERROR_SXS_COMPONENT_STORE_CORRUPT',
           'The component store has been corrupted.'),
 '14099': ('ERROR_ADVANCED_INSTALLER_FAILED',
           'An advanced installer failed during setup or servicing.'),
 '141': ('ERROR_SUBST_TO_JOIN',
         'The system tried to SUBST a drive to a directory on a joined drive.'),
 '1410': ('ERROR_CLASS_ALREADY_EXISTS', 'Class already exists.'),
 '14100': ('ERROR_XML_ENCODING_MISMATCH',
           'The character encoding in the XML declaration did not match the encoding used in the document.'),
 '14101': ('ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT',
           'The identities of the manifests are identical but their contents are different.'),
 '14102': ('ERROR_SXS_IDENTITIES_DIFFERENT',
           'The component identities are different.'),
 '14103': ('ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT',
           'The assembly is not a deployment.'),
 '14104': ('ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY',
           'The file is not a part of the assembly.'),
 '14105': ('ERROR_SXS_MANIFEST_TOO_BIG',
           'The size of the manifest exceeds the maximum allowed.'),
 '14106': ('ERROR_SXS_SETTING_NOT_REGISTERED',
           'The setting is not registered.'),
 '14107': ('ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE',
           'One or more required members of the transaction are not present.'),
 '14108': ('ERROR_SMI_PRIMITIVE_INSTALLER_FAILED',
           'The SMI primitive installer failed during setup or servicing.'),
 '14109': ('ERROR_GENERIC_COMMAND_FAILED',
           'A generic command executable returned a result that indicates failure.'),
 '1411': ('ERROR_CLASS_DOES_NOT_EXIST', 'Class does not exist.'),
 '14110': ('ERROR_SXS_FILE_HASH_MISSING',
           'A component is missing file verification information in its manifest.'),
 '1412': ('ERROR_CLASS_HAS_WINDOWS', 'Class still has open windows.'),
 '1413': ('ERROR_INVALID_INDEX', 'Invalid index.'),
 '1414': ('ERROR_INVALID_ICON_HANDLE', 'Invalid icon handle.'),
 '1415': ('ERROR_PRIVATE_DIALOG_INDEX', 'Using private DIALOG window words.'),
 '1416': ('ERROR_LISTBOX_ID_NOT_FOUND',
          'The list box identifier was not found.'),
 '1417': ('ERROR_NO_WILDCARD_CHARACTERS', 'No wildcards were found.'),
 '1418': ('ERROR_CLIPBOARD_NOT_OPEN',
          'Thread does not have a clipboard open.'),
 '1419': ('ERROR_HOTKEY_NOT_REGISTERED', 'Hot key is not registered.'),
 '142': ('ERROR_BUSY_DRIVE',
         'The system cannot perform a JOIN or SUBST at this time.'),
 '1420': ('ERROR_WINDOW_NOT_DIALOG',
          'The window is not a valid dialog window.'),
 '1421': ('ERROR_CONTROL_ID_NOT_FOUND', 'Control ID not found.'),
 '1422': ('ERROR_INVALID_COMBOBOX_MESSAGE',
          'Invalid message for a combo box because it does not have an edit control.'),
 '1423': ('ERROR_WINDOW_NOT_COMBOBOX', 'The window is not a combo box.'),
 '1424': ('ERROR_INVALID_EDIT_HEIGHT', 'Height must be less than 256.'),
 '1425': ('ERROR_DC_NOT_FOUND', 'Invalid device context (DC) handle.'),
 '1426': ('ERROR_INVALID_HOOK_FILTER', 'Invalid hook procedure type.'),
 '1427': ('ERROR_INVALID_FILTER_PROC', 'Invalid hook procedure.'),
 '1428': ('ERROR_HOOK_NEEDS_HMOD',
          'Cannot set nonlocal hook without a module handle.'),
 '1429': ('ERROR_GLOBAL_ONLY_HOOK',
          'This hook procedure can only be set globally.'),
 '143': ('ERROR_SAME_DRIVE',
         'The system cannot join or substitute a drive to or for a directory on the same drive.'),
 '1430': ('ERROR_JOURNAL_HOOK_SET',
          'The journal hook procedure is already installed.'),
 '1431': ('ERROR_HOOK_NOT_INSTALLED', 'The hook procedure is not installed.'),
 '1432': ('ERROR_INVALID_LB_MESSAGE',
          'Invalid message for single-selection list box.'),
 '1433': ('ERROR_SETCOUNT_ON_BAD_LB',
          'LB_SETCOUNT sent to non-lazy list box.'),
 '1434': ('ERROR_LB_WITHOUT_TABSTOPS',
          'This list box does not support tab stops.'),
 '1435': ('ERROR_DESTROY_OBJECT_OF_OTHER_THREAD',
          'Cannot destroy object created by another thread.'),
 '1436': ('ERROR_CHILD_WINDOW_MENU', 'Child windows cannot have menus.'),
 '1437': ('ERROR_NO_SYSTEM_MENU', 'The window does not have a system menu.'),
 '1438': ('ERROR_INVALID_MSGBOX_STYLE', 'Invalid message box style.'),
 '1439': ('ERROR_INVALID_SPI_VALUE', 'Invalid system-wide (SPI_*) parameter.'),
 '144': ('ERROR_DIR_NOT_ROOT',
         'The directory is not a subdirectory of the root directory.'),
 '1440': ('ERROR_SCREEN_ALREADY_LOCKED', 'Screen already locked.'),
 '1441': ('ERROR_HWNDS_HAVE_DIFF_PARENT',
          'All handles to windows in a multiple-window position structure must have the same parent.'),
 '1442': ('ERROR_NOT_CHILD_WINDOW', 'The window is not a child window.'),
 '1443': ('ERROR_INVALID_GW_COMMAND', 'Invalid GW_* command.'),
 '1444': ('ERROR_INVALID_THREAD_ID', 'Invalid thread identifier.'),
 '1445': ('ERROR_NON_MDICHILD_WINDOW',
          'Cannot process a message from a window that is not a multiple document interface (MDI) window.'),
 '1446': ('ERROR_POPUP_ALREADY_ACTIVE', 'Popup menu already active.'),
 '1447': ('ERROR_NO_SCROLLBARS', 'The window does not have scroll bars.'),
 '1448': ('ERROR_INVALID_SCROLLBAR_RANGE',
          'Scroll bar range cannot be greater than MAXLONG.'),
 '1449': ('ERROR_INVALID_SHOWWIN_COMMAND',
          'Cannot show or remove the window in the way specified.'),
 '145': ('ERROR_DIR_NOT_EMPTY', 'The directory is not empty.'),
 '1450': ('ERROR_NO_SYSTEM_RESOURCES',
          'Insufficient system resources exist to complete the requested service.'),
 '1451': ('ERROR_NONPAGED_SYSTEM_RESOURCES',
          'Insufficient system resources exist to complete the requested service.'),
 '1452': ('ERROR_PAGED_SYSTEM_RESOURCES',
          'Insufficient system resources exist to complete the requested service.'),
 '1453': ('ERROR_WORKING_SET_QUOTA',
          'Insufficient quota to complete the requested service.'),
 '1454': ('ERROR_PAGEFILE_QUOTA',
          'Insufficient quota to complete the requested service.'),
 '1455': ('ERROR_COMMITMENT_LIMIT',
          'The paging file is too small for this operation to complete.'),
 '1456': ('ERROR_MENU_ITEM_NOT_FOUND', 'A menu item was not found.'),
 '1457': ('ERROR_INVALID_KEYBOARD_HANDLE', 'Invalid keyboard layout handle.'),
 '1458': ('ERROR_HOOK_TYPE_NOT_ALLOWED', 'Hook type not allowed.'),
 '1459': ('ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION',
          'This operation requires an interactive window station.'),
 '146': ('ERROR_IS_SUBST_PATH',
         'The path specified is being used in a substitute.'),
 '1460': ('ERROR_TIMEOUT',
          'This operation returned because the timeout period expired.'),
 '1461': ('ERROR_INVALID_MONITOR_HANDLE', 'Invalid monitor handle.'),
 '1462': ('ERROR_INCORRECT_SIZE', 'Incorrect size argument.'),
 '1463': ('ERROR_SYMLINK_CLASS_DISABLED',
          'The symbolic link cannot be followed because its type is disabled.'),
 '1464': ('ERROR_SYMLINK_NOT_SUPPORTED',
          'This application does not support the current operation on symbolic links.'),
 '1465': ('ERROR_XML_PARSE_ERROR',
          'Windows was unable to parse the requested XML data.'),
 '1466': ('ERROR_XMLDSIG_ERROR',
          'An error was encountered while processing an XML digital signature.'),
 '1467': ('ERROR_RESTART_APPLICATION', 'This application must be restarted.'),
 '1468': ('ERROR_WRONG_COMPARTMENT',
          'The caller made the connection request in the wrong routing compartment.'),
 '1469': ('ERROR_AUTHIP_FAILURE',
          'There was an AuthIP failure when attempting to connect to the remote host.'),
 '147': ('ERROR_IS_JOIN_PATH',
         'Not enough resources are available to process this command.'),
 '148': ('ERROR_PATH_BUSY', 'The path specified cannot be used at this time.'),
 '149': ('ERROR_IS_SUBST_TARGET',
         'An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute.'),
 '15': ('ERROR_INVALID_DRIVE', 'The system cannot find the drive specified.'),
 '150': ('ERROR_SYSTEM_TRACE',
         'System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed.'),
 '1500': ('ERROR_EVENTLOG_FILE_CORRUPT', 'The event log file is corrupted.'),
 '15000': ('ERROR_EVT_INVALID_CHANNEL_PATH',
           'The specified channel path is invalid.'),
 '15001': ('ERROR_EVT_INVALID_QUERY', 'The specified query is invalid.'),
 '15002': ('ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND',
           'The publisher metadata cannot be found in the resource.'),
 '15003': ('ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND',
           'The template for an event definition cannot be found in the resource (error = %1).'),
 '15004': ('ERROR_EVT_INVALID_PUBLISHER_NAME',
           'The specified publisher name is invalid.'),
 '15005': ('ERROR_EVT_INVALID_EVENT_DATA',
           "The event data raised by the publisher is not compatible with the event template definition in the publisher's manifest"),
 '15007': ('ERROR_EVT_CHANNEL_NOT_FOUND',
           'The specified channel could not be found. Check channel configuration.'),
 '15008': ('ERROR_EVT_MALFORMED_XML_TEXT',
           'The specified xml text was not well-formed. See Extended Error for more details.'),
 '15009': ('ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL',
           'The caller is trying to subscribe to a direct channel which is not allowed. The events for a direct channel go directly to a logfile and cannot be subscribed to.'),
 '1501': ('ERROR_EVENTLOG_CANT_START',
          'No event log file could be opened, so the event logging service did not start.'),
 '15010': ('ERROR_EVT_CONFIGURATION_ERROR', 'Configuration error.'),
 '15011': ('ERROR_EVT_QUERY_RESULT_STALE',
           'The query result is stale / invalid. This may be due to the log being cleared or rolling over after the query result was created. Users should handle this code by releasing the query result object and reissuing the query.'),
 '15012': ('ERROR_EVT_QUERY_RESULT_INVALID_POSITION',
           'Query result is currently at an invalid position.'),
 '15013': ('ERROR_EVT_NON_VALIDATING_MSXML',
           "Registered MSXML doesn't support validation."),
 '15014': ('ERROR_EVT_FILTER_ALREADYSCOPED',
           'An expression can only be followed by a change of scope operation if it itself evaluates to a node set and is not already part of some other change of scope operation.'),
 '15015': ('ERROR_EVT_FILTER_NOTELTSET',
           "Can't perform a step operation from a term that does not represent an element set."),
 '15016': ('ERROR_EVT_FILTER_INVARG',
           'Left hand side arguments to binary operators must be either attributes, nodes or variables and right hand side arguments must be constants.'),
 '15017': ('ERROR_EVT_FILTER_INVTEST',
           'A step operation must involve either a node test or, in the case of a predicate, an algebraic expression against which to test each node in the node set identified by the preceding node set can be evaluated.'),
 '15018': ('ERROR_EVT_FILTER_INVTYPE',
           'This data type is currently unsupported.'),
 '15019': ('ERROR_EVT_FILTER_PARSEERR',
           'A syntax error occurred at position %1!d!'),
 '1502': ('ERROR_LOG_FILE_FULL', 'The event log file is full.'),
 '15020': ('ERROR_EVT_FILTER_UNSUPPORTEDOP',
           'This operator is unsupported by this implementation of the filter.'),
 '15021': ('ERROR_EVT_FILTER_UNEXPECTEDTOKEN',
           'The token encountered was unexpected.'),
 '15022': ('ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL',
           'The requested operation cannot be performed over an enabled direct channel. The channel must first be disabled before performing the requested operation.'),
 '15023': ('ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE',
           "Channel property %1!s! contains invalid value. The value has invalid type, is outside of valid range, can't be updated or is not supported by this type of channel."),
 '15024': ('ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE',
           "Publisher property %1!s! contains invalid value. The value has invalid type, is outside of valid range, can't be updated or is not supported by this type of publisher."),
 '15025': ('ERROR_EVT_CHANNEL_CANNOT_ACTIVATE',
           'The channel fails to activate.'),
 '15026': ('ERROR_EVT_FILTER_TOO_COMPLEX',
           'The xpath expression exceeded supported complexity. Please simplify it or split it into two or more simple expressions.'),
 '15027': ('ERROR_EVT_MESSAGE_NOT_FOUND',
           'The message resource is present but the message is not found in the string/message table.'),
 '15028': ('ERROR_EVT_MESSAGE_ID_NOT_FOUND',
           'The message identifier for the desired message could not be found.'),
 '15029': ('ERROR_EVT_UNRESOLVED_VALUE_INSERT',
           'The substitution string for insert index (%1) could not be found.'),
 '1503': ('ERROR_EVENTLOG_FILE_CHANGED',
          'The event log file has changed between read operations.'),
 '15030': ('ERROR_EVT_UNRESOLVED_PARAMETER_INSERT',
           'The description string for parameter reference (%1) could not be found.'),
 '15031': ('ERROR_EVT_MAX_INSERTS_REACHED',
           'The maximum number of replacements has been reached.'),
 '15032': ('ERROR_EVT_EVENT_DEFINITION_NOT_FOUND',
           'The event definition could not be found for the event identifier (%1).'),
 '15033': ('ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND',
           'The locale specific resource for the desired message is not present.'),
 '15034': ('ERROR_EVT_VERSION_TOO_OLD',
           'The resource is too old to be compatible.'),
 '15035': ('ERROR_EVT_VERSION_TOO_NEW',
           'The resource is too new to be compatible.'),
 '15036': ('ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY',
           'The channel at index %1!d! of the query cannot be opened.'),
 '15037': ('ERROR_EVT_PUBLISHER_DISABLED',
           'The publisher has been disabled and its resource is not available. This usually occurs when the publisher is in the process of being uninstalled or upgraded.'),
 '15038': ('ERROR_EVT_FILTER_OUT_OF_RANGE',
           'Attempted to create a numeric type that is outside of its valid range.'),
 '15080': ('ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE',
           'The subscription fails to activate.'),
 '15081': ('ERROR_EC_LOG_DISABLED',
           'The log of the subscription is in disabled state, and cannot be used to forward events. The log must first be enabled before the subscription can be activated.'),
 '15082': ('ERROR_EC_CIRCULAR_FORWARDING',
           "When forwarding events from local machine to itself, the query of the subscription can't contain target log of the subscription."),
 '15083': ('ERROR_EC_CREDSTORE_FULL',
           'The credential store that is used to save credentials is full.'),
 '15084': ('ERROR_EC_CRED_NOT_FOUND',
           "The credential used by this subscription can't be found in credential store."),
 '15085': ('ERROR_EC_NO_ACTIVE_CHANNEL',
           'No active channel is found for the query.'),
 '151': ('ERROR_INVALID_EVENT_COUNT',
         'The number of specified semaphore events for DosMuxSemWait is not correct.'),
 '15100': ('ERROR_MUI_FILE_NOT_FOUND',
           'The resource loader failed to find MUI file.'),
 '15101': ('ERROR_MUI_INVALID_FILE',
           'The resource loader failed to load MUI file because the file fail to pass validation.'),
 '15102': ('ERROR_MUI_INVALID_RC_CONFIG',
           'The RC Manifest is corrupted with garbage data or unsupported version or missing required item.'),
 '15103': ('ERROR_MUI_INVALID_LOCALE_NAME',
           'The RC Manifest has invalid culture name.'),
 '15104': ('ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME',
           'The RC Manifest has invalid ultimatefallback name.'),
 '15105': ('ERROR_MUI_FILE_NOT_LOADED',
           "The resource loader cache doesn't have loaded MUI entry."),
 '15106': ('ERROR_RESOURCE_ENUM_USER_STOP', 'User stop resource enumeration.'),
 '15107': ('ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED',
           'UI language installation failed.'),
 '15108': ('ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME',
           'Locale installation failed.'),
 '152': ('ERROR_TOO_MANY_MUXWAITERS',
         'DosMuxSemWait did not execute; too many semaphores are already set.'),
 '15200': ('ERROR_MCA_INVALID_CAPABILITIES_STRING',
           'The monitor returned a DDC/CI capabilities string that did not comply with the ACCESS.bus 3.0, DDC/CI 1.1, or MCCS 2 Revision 1 specification.'),
 '15201': ('ERROR_MCA_INVALID_VCP_VERSION',
           "The monitor's VCP Version (0xDF) VCP code returned an invalid version value."),
 '15202': ('ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION',
           'The monitor does not comply with the MCCS specification it claims to supports.'),
 '15203': ('ERROR_MCA_MCCS_VERSION_MISMATCH',
           "The MCCS version in a monitor's mccs_ver capability does not match the MCCS version the monitor reports when the VCP Version (0xDF) VCP code is used."),
 '15204': ('ERROR_MCA_UNSUPPORTED_MCCS_VERSION',
           'The Monitor Configuration API only works with monitors that support the MCCS 1.0 specification, MCCS 2.0 specification, or the MCCS 2.0 Revision 1 specification.'),
 '15205': ('ERROR_MCA_INTERNAL_ERROR',
           'An internal Monitor Configuration API error occurred.'),
 '15206': ('ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED',
           'The monitor returned an invalid monitor technology type. CRT, Plasma, and LCD (TFT) are examples of monitor technology types. This error implies that the monitor violated the MCCS 2.0 or the MCCS 2.0 Revision 1 specification.'),
 '15207': ('ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE',
           'The caller of SetMonitorColorTemperature specified a color temperature that the current monitor did not support. This error implies that the monitor violated the MCCS 2.0 or the MCCS 2.0 Revision 1 specification.'),
 '15250': ('ERROR_AMBIGUOUS_SYSTEM_DEVICE',
           'The requested system device cannot be identified due to multiple indistinguishable devices potentially matching the identification criteria.'),
 '15299': ('ERROR_SYSTEM_DEVICE_NOT_FOUND',
           'The requested system device cannot be found.'),
 '153': ('ERROR_INVALID_LIST_FORMAT',
         'The DosMuxSemWait list is not correct.'),
 '154': ('ERROR_LABEL_TOO_LONG',
         'The volume label you entered exceeds the label character limit of the target file system.'),
 '155': ('ERROR_TOO_MANY_TCBS', 'Cannot create another thread.'),
 '1550': ('ERROR_INVALID_TASK_NAME', 'The specified task name is invalid.'),
 '1551': ('ERROR_INVALID_TASK_INDEX', 'The specified task index is invalid.'),
 '1552': ('ERROR_THREAD_ALREADY_IN_TASK',
          'The specified thread is already joining a task.'),
 '156': ('ERROR_SIGNAL_REFUSED',
         'The recipient process has refused the signal.'),
 '157': ('ERROR_DISCARDED',
         'The segment is already discarded and cannot be locked.'),
 '158': ('ERROR_NOT_LOCKED', 'The segment is already unlocked.'),
 '159': ('ERROR_BAD_THREADID_ADDR',
         'The address for the thread ID is not correct.'),
 '16': ('ERROR_CURRENT_DIRECTORY', 'The directory cannot be removed.'),
 '160': ('ERROR_BAD_ARGUMENTS', 'One or more arguments are not correct.'),
 '1601': ('ERROR_INSTALL_SERVICE_FAILURE',
          'The Windows Installer Service could not be accessed. This can occur if the Windows Installer is not correctly installed. Contact your support personnel for assistance.'),
 '1602': ('ERROR_INSTALL_USEREXIT', 'User canceled installation.'),
 '1603': ('ERROR_INSTALL_FAILURE', 'Fatal error during installation.'),
 '1604': ('ERROR_INSTALL_SUSPEND', 'Installation suspended, incomplete.'),
 '1605': ('ERROR_UNKNOWN_PRODUCT',
          'This action is only valid for products that are currently installed.'),
 '1606': ('ERROR_UNKNOWN_FEATURE', 'Feature ID not registered.'),
 '1607': ('ERROR_UNKNOWN_COMPONENT', 'Component ID not registered.'),
 '1608': ('ERROR_UNKNOWN_PROPERTY', 'Unknown property.'),
 '1609': ('ERROR_INVALID_HANDLE_STATE', 'A handle is in an invalid state.'),
 '161': ('ERROR_BAD_PATHNAME', 'The specified path is invalid.'),
 '1610': ('ERROR_BAD_CONFIGURATION',
          'The configuration data for this product is corrupt. Contact your support personnel.'),
 '1611': ('ERROR_INDEX_ABSENT', 'Component qualifier not present.'),
 '1612': ('ERROR_INSTALL_SOURCE_ABSENT',
          'The installation source for this product is not available. Verify that the source exists and that you can access it.'),
 '1613': ('ERROR_INSTALL_PACKAGE_VERSION',
          'This installation package cannot be installed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service.'),
 '1614': ('ERROR_PRODUCT_UNINSTALLED', 'Product is uninstalled.'),
 '1615': ('ERROR_BAD_QUERY_SYNTAX',
          'SQL query syntax invalid or unsupported.'),
 '1616': ('ERROR_INVALID_FIELD', 'Record field does not exist.'),
 '1617': ('ERROR_DEVICE_REMOVED', 'The device has been removed.'),
 '1618': ('ERROR_INSTALL_ALREADY_RUNNING',
          'Another installation is already in progress. Complete that installation before proceeding with this install.'),
 '1619': ('ERROR_INSTALL_PACKAGE_OPEN_FAILED',
          'This installation package could not be opened. Verify that the package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer package.'),
 '162': ('ERROR_SIGNAL_PENDING', 'A signal is already pending.'),
 '1620': ('ERROR_INSTALL_PACKAGE_INVALID',
          'This installation package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer package.'),
 '1621': ('ERROR_INSTALL_UI_FAILURE',
          'There was an error starting the Windows Installer service user interface. Contact your support personnel.'),
 '1622': ('ERROR_INSTALL_LOG_FAILURE',
          'Error opening installation log file. Verify that the specified log file location exists and that you can write to it.'),
 '1623': ('ERROR_INSTALL_LANGUAGE_UNSUPPORTED',
          'The language of this installation package is not supported by your system.'),
 '1624': ('ERROR_INSTALL_TRANSFORM_FAILURE',
          'Error applying transforms. Verify that the specified transform paths are valid.'),
 '1625': ('ERROR_INSTALL_PACKAGE_REJECTED',
          'This installation is forbidden by system policy. Contact your system administrator.'),
 '1626': ('ERROR_FUNCTION_NOT_CALLED', 'Function could not be executed.'),
 '1627': ('ERROR_FUNCTION_FAILED', 'Function failed during execution.'),
 '1628': ('ERROR_INVALID_TABLE', 'Invalid or unknown table specified.'),
 '1629': ('ERROR_DATATYPE_MISMATCH', 'Data supplied is of wrong type.'),
 '1630': ('ERROR_UNSUPPORTED_TYPE', 'Data of this type is not supported.'),
 '1631': ('ERROR_CREATE_FAILED',
          'The Windows Installer service failed to start. Contact your support personnel.'),
 '1632': ('ERROR_INSTALL_TEMP_UNWRITABLE',
          'The Temp folder is on a drive that is full or is inaccessible. Free up space on the drive or verify that you have write permission on the Temp folder.'),
 '1633': ('ERROR_INSTALL_PLATFORM_UNSUPPORTED',
          'This installation package is not supported by this processor type. Contact your product vendor.'),
 '1634': ('ERROR_INSTALL_NOTUSED', 'Component not used on this computer.'),
 '1635': ('ERROR_PATCH_PACKAGE_OPEN_FAILED',
          'This update package could not be opened. Verify that the update package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer update package.'),
 '1636': ('ERROR_PATCH_PACKAGE_INVALID',
          'This update package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer update package.'),
 '1637': ('ERROR_PATCH_PACKAGE_UNSUPPORTED',
          'This update package cannot be processed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service.'),
 '1638': ('ERROR_PRODUCT_VERSION',
          'Another version of this product is already installed. Installation of this version cannot continue. To configure or remove the existing version of this product, use Add/Remove Programs on the Control Panel.'),
 '1639': ('ERROR_INVALID_COMMAND_LINE',
          'Invalid command line argument. Consult the Windows Installer SDK for detailed command line help.'),
 '164': ('ERROR_MAX_THRDS_REACHED',
         'No more threads can be created in the system.'),
 '1640': ('ERROR_INSTALL_REMOTE_DISALLOWED',
          'Only administrators have permission to add, remove, or configure server software during a Terminal services remote session. If you want to install or configure software on the server, contact your network administrator.'),
 '1641': ('ERROR_SUCCESS_REBOOT_INITIATED',
          'The requested operation completed successfully. The system will be restarted so the changes can take effect.'),
 '1642': ('ERROR_PATCH_TARGET_NOT_FOUND',
          'The upgrade cannot be installed by the Windows Installer service because the program to be upgraded may be missing, or the upgrade may update a different version of the program. Verify that the program to be upgraded exists on your computer and that you have the correct upgrade.'),
 '1643': ('ERROR_PATCH_PACKAGE_REJECTED',
          'The update package is not permitted by software restriction policy.'),
 '1644': ('ERROR_INSTALL_TRANSFORM_REJECTED',
          'One or more customizations are not permitted by software restriction policy.'),
 '1645': ('ERROR_INSTALL_REMOTE_PROHIBITED',
          'The Windows Installer does not permit installation from a Remote Desktop Connection.'),
 '1646': ('ERROR_PATCH_REMOVAL_UNSUPPORTED',
          'Uninstallation of the update package is not supported.'),
 '1647': ('ERROR_UNKNOWN_PATCH', 'The update is not applied to this product.'),
 '1648': ('ERROR_PATCH_NO_SEQUENCE',
          'No valid sequence could be found for the set of updates.'),
 '1649': ('ERROR_PATCH_REMOVAL_DISALLOWED',
          'Update removal was disallowed by policy.'),
 '1650': ('ERROR_INVALID_PATCH_XML', 'The XML update data is invalid.'),
 '1651': ('ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT',
          'Windows Installer does not permit updating of managed advertised products. At least one feature of the product must be installed before applying the update.'),
 '1652': ('ERROR_INSTALL_SERVICE_SAFEBOOT',
          'The Windows Installer service is not accessible in Safe Mode. Please try again when your computer is not in Safe Mode or you can use System Restore to return your machine to a previous good state.'),
 '167': ('ERROR_LOCK_FAILED', 'Unable to lock a region of a file.'),
 '17': ('ERROR_NOT_SAME_DEVICE',
        'The system cannot move the file to a different disk drive.'),
 '170': ('ERROR_BUSY', 'The requested resource is in use.'),
 '1700': ('RPC_S_INVALID_STRING_BINDING', 'The string binding is invalid.'),
 '1701': ('RPC_S_WRONG_KIND_OF_BINDING',
          'The binding handle is not the correct type.'),
 '1702': ('RPC_S_INVALID_BINDING', 'The binding handle is invalid.'),
 '1703': ('RPC_S_PROTSEQ_NOT_SUPPORTED',
          'The RPC protocol sequence is not supported.'),
 '1704': ('RPC_S_INVALID_RPC_PROTSEQ',
          'The RPC protocol sequence is invalid.'),
 '1705': ('RPC_S_INVALID_STRING_UUID',
          'The string universal unique identifier (UUID) is invalid.'),
 '1706': ('RPC_S_INVALID_ENDPOINT_FORMAT', 'The endpoint format is invalid.'),
 '1707': ('RPC_S_INVALID_NET_ADDR', 'The network address is invalid.'),
 '1708': ('RPC_S_NO_ENDPOINT_FOUND', 'No endpoint was found.'),
 '1709': ('RPC_S_INVALID_TIMEOUT', 'The timeout value is invalid.'),
 '1710': ('RPC_S_OBJECT_NOT_FOUND',
          'The object universal unique identifier (UUID) was not found.'),
 '1711': ('RPC_S_ALREADY_REGISTERED',
          'The object universal unique identifier (UUID) has already been registered.'),
 '1712': ('RPC_S_TYPE_ALREADY_REGISTERED',
          'The type universal unique identifier (UUID) has already been registered.'),
 '1713': ('RPC_S_ALREADY_LISTENING', 'The RPC server is already listening.'),
 '1714': ('RPC_S_NO_PROTSEQS_REGISTERED',
          'No protocol sequences have been registered.'),
 '1715': ('RPC_S_NOT_LISTENING', 'The RPC server is not listening.'),
 '1716': ('RPC_S_UNKNOWN_MGR_TYPE', 'The manager type is unknown.'),
 '1717': ('RPC_S_UNKNOWN_IF', 'The interface is unknown.'),
 '1718': ('RPC_S_NO_BINDINGS', 'There are no bindings.'),
 '1719': ('RPC_S_NO_PROTSEQS', 'There are no protocol sequences.'),
 '1720': ('RPC_S_CANT_CREATE_ENDPOINT', 'The endpoint cannot be created.'),
 '1721': ('RPC_S_OUT_OF_RESOURCES',
          'Not enough resources are available to complete this operation.'),
 '1722': ('RPC_S_SERVER_UNAVAILABLE', 'The RPC server is unavailable.'),
 '1723': ('RPC_S_SERVER_TOO_BUSY',
          'The RPC server is too busy to complete this operation.'),
 '1724': ('RPC_S_INVALID_NETWORK_OPTIONS', 'The network options are invalid.'),
 '1725': ('RPC_S_NO_CALL_ACTIVE',
          'There are no remote procedure calls active on this thread.'),
 '1726': ('RPC_S_CALL_FAILED', 'The remote procedure call failed.'),
 '1727': ('RPC_S_CALL_FAILED_DNE',
          'The remote procedure call failed and did not execute.'),
 '1728': ('RPC_S_PROTOCOL_ERROR',
          'A remote procedure call (RPC) protocol error occurred.'),
 '1729': ('RPC_S_PROXY_ACCESS_DENIED', 'Access to the HTTP proxy is denied.'),
 '173': ('ERROR_CANCEL_VIOLATION',
         'A lock request was not outstanding for the supplied cancel region.'),
 '1730': ('RPC_S_UNSUPPORTED_TRANS_SYN',
          'The transfer syntax is not supported by the RPC server.'),
 '1732': ('RPC_S_UNSUPPORTED_TYPE',
          'The universal unique identifier (UUID) type is not supported.'),
 '1733': ('RPC_S_INVALID_TAG', 'The tag is invalid.'),
 '1734': ('RPC_S_INVALID_BOUND', 'The array bounds are invalid.'),
 '1735': ('RPC_S_NO_ENTRY_NAME',
          'The binding does not contain an entry name.'),
 '1736': ('RPC_S_INVALID_NAME_SYNTAX', 'The name syntax is invalid.'),
 '1737': ('RPC_S_UNSUPPORTED_NAME_SYNTAX',
          'The name syntax is not supported.'),
 '1739': ('RPC_S_UUID_NO_ADDRESS',
          'No network address is available to use to construct a universal unique identifier (UUID).'),
 '174': ('ERROR_ATOMIC_LOCKS_NOT_SUPPORTED',
         'The file system does not support atomic changes to the lock type.'),
 '1740': ('RPC_S_DUPLICATE_ENDPOINT', 'The endpoint is a duplicate.'),
 '1741': ('RPC_S_UNKNOWN_AUTHN_TYPE', 'The authentication type is unknown.'),
 '1742': ('RPC_S_MAX_CALLS_TOO_SMALL',
          'The maximum number of calls is too small.'),
 '1743': ('RPC_S_STRING_TOO_LONG', 'The string is too long.'),
 '1744': ('RPC_S_PROTSEQ_NOT_FOUND',
          'The RPC protocol sequence was not found.'),
 '1745': ('RPC_S_PROCNUM_OUT_OF_RANGE',
          'The procedure number is out of range.'),
 '1746': ('RPC_S_BINDING_HAS_NO_AUTH',
          'The binding does not contain any authentication information.'),
 '1747': ('RPC_S_UNKNOWN_AUTHN_SERVICE',
          'The authentication service is unknown.'),
 '1748': ('RPC_S_UNKNOWN_AUTHN_LEVEL', 'The authentication level is unknown.'),
 '1749': ('RPC_S_INVALID_AUTH_IDENTITY', 'The security context is invalid.'),
 '1750': ('RPC_S_UNKNOWN_AUTHZ_SERVICE',
          'The authorization service is unknown.'),
 '1751': ('EPT_S_INVALID_ENTRY', 'The entry is invalid.'),
 '1752': ('EPT_S_CANT_PERFORM_OP',
          'The server endpoint cannot perform the operation.'),
 '1753': ('EPT_S_NOT_REGISTERED',
          'There are no more endpoints available from the endpoint mapper.'),
 '1754': ('RPC_S_NOTHING_TO_EXPORT', 'No interfaces have been exported.'),
 '1755': ('RPC_S_INCOMPLETE_NAME', 'The entry name is incomplete.'),
 '1756': ('RPC_S_INVALID_VERS_OPTION', 'The version option is invalid.'),
 '1757': ('RPC_S_NO_MORE_MEMBERS', 'There are no more members.'),
 '1758': ('RPC_S_NOT_ALL_OBJS_UNEXPORTED', 'There is nothing to unexport.'),
 '1759': ('RPC_S_INTERFACE_NOT_FOUND', 'The interface was not found.'),
 '1760': ('RPC_S_ENTRY_ALREADY_EXISTS', 'The entry already exists.'),
 '1761': ('RPC_S_ENTRY_NOT_FOUND', 'The entry is not found.'),
 '1762': ('RPC_S_NAME_SERVICE_UNAVAILABLE',
          'The name service is unavailable.'),
 '1763': ('RPC_S_INVALID_NAF_ID', 'The network address family is invalid.'),
 '1764': ('RPC_S_CANNOT_SUPPORT', 'The requested operation is not supported.'),
 '1765': ('RPC_S_NO_CONTEXT_AVAILABLE',
          'No security context is available to allow impersonation.'),
 '1766': ('RPC_S_INTERNAL_ERROR',
          'An internal error occurred in a remote procedure call (RPC).'),
 '1767': ('RPC_S_ZERO_DIVIDE',
          'The RPC server attempted an integer division by zero.'),
 '1768': ('RPC_S_ADDRESS_ERROR',
          'An addressing error occurred in the RPC server.'),
 '1769': ('RPC_S_FP_DIV_ZERO',
          'A floating-point operation at the RPC server caused a division by zero.'),
 '1770': ('RPC_S_FP_UNDERFLOW',
          'A floating-point underflow occurred at the RPC server.'),
 '1771': ('RPC_S_FP_OVERFLOW',
          'A floating-point overflow occurred at the RPC server.'),
 '1772': ('RPC_X_NO_MORE_ENTRIES',
          'The list of RPC servers available for the binding of auto handles has been exhausted.'),
 '1773': ('RPC_X_SS_CHAR_TRANS_OPEN_FAIL',
          'Unable to open the character translation table file.'),
 '1774': ('RPC_X_SS_CHAR_TRANS_SHORT_FILE',
          'The file containing the character translation table has fewer than 512 bytes.'),
 '1775': ('RPC_X_SS_IN_NULL_CONTEXT',
          'A null context handle was passed from the client to the host during a remote procedure call.'),
 '1777': ('RPC_X_SS_CONTEXT_DAMAGED',
          'The context handle changed during a remote procedure call.'),
 '1778': ('RPC_X_SS_HANDLES_MISMATCH',
          'The binding handles passed to a remote procedure call do not match.'),
 '1779': ('RPC_X_SS_CANNOT_GET_CALL_HANDLE',
          'The stub is unable to get the remote procedure call handle.'),
 '1780': ('RPC_X_NULL_REF_POINTER',
          'A null reference pointer was passed to the stub.'),
 '1781': ('RPC_X_ENUM_VALUE_OUT_OF_RANGE',
          'The enumeration value is out of range.'),
 '1782': ('RPC_X_BYTE_COUNT_TOO_SMALL', 'The byte count is too small.'),
 '1783': ('RPC_X_BAD_STUB_DATA', 'The stub received bad data.'),
 '1784': ('ERROR_INVALID_USER_BUFFER',
          'The supplied user buffer is not valid for the requested operation.'),
 '1785': ('ERROR_UNRECOGNIZED_MEDIA',
          'The disk media is not recognized. It may not be formatted.'),
 '1786': ('ERROR_NO_TRUST_LSA_SECRET',
          'The workstation does not have a trust secret.'),
 '1787': ('ERROR_NO_TRUST_SAM_ACCOUNT',
          'The security database on the server does not have a computer account for this workstation trust relationship.'),
 '1788': ('ERROR_TRUSTED_DOMAIN_FAILURE',
          'The trust relationship between the primary domain and the trusted domain failed.'),
 '1789': ('ERROR_TRUSTED_RELATIONSHIP_FAILURE',
          'The trust relationship between this workstation and the primary domain failed.'),
 '1790': ('ERROR_TRUST_FAILURE', 'The network logon failed.'),
 '1791': ('RPC_S_CALL_IN_PROGRESS',
          'A remote procedure call is already in progress for this thread.'),
 '1792': ('ERROR_NETLOGON_NOT_STARTED',
          'An attempt was made to logon, but the network logon service was not started.'),
 '1793': ('ERROR_ACCOUNT_EXPIRED', "The user's account has expired."),
 '1794': ('ERROR_REDIRECTOR_HAS_OPEN_HANDLES',
          'The redirector is in use and cannot be unloaded.'),
 '1795': ('ERROR_PRINTER_DRIVER_ALREADY_INSTALLED',
          'The specified printer driver is already installed.'),
 '1796': ('ERROR_UNKNOWN_PORT', 'The specified port is unknown.'),
 '1797': ('ERROR_UNKNOWN_PRINTER_DRIVER', 'The printer driver is unknown.'),
 '1798': ('ERROR_UNKNOWN_PRINTPROCESSOR', 'The print processor is unknown.'),
 '1799': ('ERROR_INVALID_SEPARATOR_FILE',
          'The specified separator file is invalid.'),
 '18': ('ERROR_NO_MORE_FILES', 'There are no more files.'),
 '180': ('ERROR_INVALID_SEGMENT_NUMBER',
         'The system detected a segment number that was not correct.'),
 '1800': ('ERROR_INVALID_PRIORITY', 'The specified priority is invalid.'),
 '1801': ('ERROR_INVALID_PRINTER_NAME', 'The printer name is invalid.'),
 '1802': ('ERROR_PRINTER_ALREADY_EXISTS', 'The printer already exists.'),
 '1803': ('ERROR_INVALID_PRINTER_COMMAND', 'The printer command is invalid.'),
 '1804': ('ERROR_INVALID_DATATYPE', 'The specified datatype is invalid.'),
 '1805': ('ERROR_INVALID_ENVIRONMENT',
          'The environment specified is invalid.'),
 '1806': ('RPC_S_NO_MORE_BINDINGS', 'There are no more bindings.'),
 '1807': ('ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT',
          'The account used is an interdomain trust account. Use your global user account or local user account to access this server.'),
 '1808': ('ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT',
          'The account used is a computer account. Use your global user account or local user account to access this server.'),
 '1809': ('ERROR_NOLOGON_SERVER_TRUST_ACCOUNT',
          'The account used is a server trust account. Use your global user account or local user account to access this server.'),
 '1810': ('ERROR_DOMAIN_TRUST_INCONSISTENT',
          'The name or security ID (SID) of the domain specified is inconsistent with the trust information for that domain.'),
 '1811': ('ERROR_SERVER_HAS_OPEN_HANDLES',
          'The server is in use and cannot be unloaded.'),
 '1812': ('ERROR_RESOURCE_DATA_NOT_FOUND',
          'The specified image file did not contain a resource section.'),
 '1813': ('ERROR_RESOURCE_TYPE_NOT_FOUND',
          'The specified resource type cannot be found in the image file.'),
 '1814': ('ERROR_RESOURCE_NAME_NOT_FOUND',
          'The specified resource name cannot be found in the image file.'),
 '1815': ('ERROR_RESOURCE_LANG_NOT_FOUND',
          'The specified resource language ID cannot be found in the image file.'),
 '1816': ('ERROR_NOT_ENOUGH_QUOTA',
          'Not enough quota is available to process this command.'),
 '1817': ('RPC_S_NO_INTERFACES', 'No interfaces have been registered.'),
 '1818': ('RPC_S_CALL_CANCELLED', 'The remote procedure call was canceled.'),
 '1819': ('RPC_S_BINDING_INCOMPLETE',
          'The binding handle does not contain all required information.'),
 '182': ('ERROR_INVALID_ORDINAL', 'The operating system cannot run %1.'),
 '1820': ('RPC_S_COMM_FAILURE',
          'A communications failure occurred during a remote procedure call.'),
 '1821': ('RPC_S_UNSUPPORTED_AUTHN_LEVEL',
          'The requested authentication level is not supported.'),
 '1822': ('RPC_S_NO_PRINC_NAME', 'No principal name registered.'),
 '1823': ('RPC_S_NOT_RPC_ERROR',
          'The error specified is not a valid Windows RPC error code.'),
 '1824': ('RPC_S_UUID_LOCAL_ONLY',
          'A UUID that is valid only on this computer has been allocated.'),
 '1825': ('RPC_S_SEC_PKG_ERROR',
          'A security package specific error occurred.'),
 '1826': ('RPC_S_NOT_CANCELLED', 'Thread is not canceled.'),
 '1827': ('RPC_X_INVALID_ES_ACTION',
          'Invalid operation on the encoding/decoding handle.'),
 '1828': ('RPC_X_WRONG_ES_VERSION',
          'Incompatible version of the serializing package.'),
 '1829': ('RPC_X_WRONG_STUB_VERSION', 'Incompatible version of the RPC stub.'),
 '183': ('ERROR_ALREADY_EXISTS',
         'Cannot create a file when that file already exists.'),
 '1830': ('RPC_X_INVALID_PIPE_OBJECT',
          'The RPC pipe object is invalid or corrupted.'),
 '1831': ('RPC_X_WRONG_PIPE_ORDER',
          'An invalid operation was attempted on an RPC pipe object.'),
 '1832': ('RPC_X_WRONG_PIPE_VERSION', 'Unsupported RPC pipe version.'),
 '1833': ('RPC_S_COOKIE_AUTH_FAILED',
          'HTTP proxy server rejected the connection because the cookie authentication failed.'),
 '186': ('ERROR_INVALID_FLAG_NUMBER', 'The flag passed is not correct.'),
 '187': ('ERROR_SEM_NOT_FOUND',
         'The specified system semaphore name was not found.'),
 '188': ('ERROR_INVALID_STARTING_CODESEG',
         'The operating system cannot run %1.'),
 '189': ('ERROR_INVALID_STACKSEG', 'The operating system cannot run %1.'),
 '1898': ('RPC_S_GROUP_MEMBER_NOT_FOUND', 'The group member was not found.'),
 '1899': ('EPT_S_CANT_CREATE',
          'The endpoint mapper database entry could not be created.'),
 '19': ('ERROR_WRITE_PROTECT', 'The media is write protected.'),
 '190': ('ERROR_INVALID_MODULETYPE', 'The operating system cannot run %1.'),
 '1900': ('RPC_S_INVALID_OBJECT',
          'The object universal unique identifier (UUID) is the nil UUID.'),
 '1901': ('ERROR_INVALID_TIME', 'The specified time is invalid.'),
 '1902': ('ERROR_INVALID_FORM_NAME', 'The specified form name is invalid.'),
 '1903': ('ERROR_INVALID_FORM_SIZE', 'The specified form size is invalid.'),
 '1904': ('ERROR_ALREADY_WAITING',
          'The specified printer handle is already being waited on'),
 '1905': ('ERROR_PRINTER_DELETED', 'The specified printer has been deleted.'),
 '1906': ('ERROR_INVALID_PRINTER_STATE',
          'The state of the printer is invalid.'),
 '1907': ('ERROR_PASSWORD_MUST_CHANGE',
          "The user's password must be changed before logging on the first time."),
 '1908': ('ERROR_DOMAIN_CONTROLLER_NOT_FOUND',
          'Could not find the domain controller for this domain.'),
 '1909': ('ERROR_ACCOUNT_LOCKED_OUT',
          'The referenced account is currently locked out and may not be logged on to.'),
 '191': ('ERROR_INVALID_EXE_SIGNATURE', 'Cannot run %1 in Win32 mode.'),
 '1910': ('OR_INVALID_OXID', 'The object exporter specified was not found.'),
 '1911': ('OR_INVALID_OID', 'The object specified was not found.'),
 '1912': ('OR_INVALID_SET',
          'The object resolver set specified was not found.'),
 '1913': ('RPC_S_SEND_INCOMPLETE',
          'Some data remains to be sent in the request buffer.'),
 '1914': ('RPC_S_INVALID_ASYNC_HANDLE',
          'Invalid asynchronous remote procedure call handle.'),
 '1915': ('RPC_S_INVALID_ASYNC_CALL',
          'Invalid asynchronous RPC call handle for this operation.'),
 '1916': ('RPC_X_PIPE_CLOSED', 'The RPC pipe object has already been closed.'),
 '1917': ('RPC_X_PIPE_DISCIPLINE_ERROR',
          'The RPC call completed before all pipes were processed.'),
 '1918': ('RPC_X_PIPE_EMPTY', 'No more data is available from the RPC pipe.'),
 '1919': ('ERROR_NO_SITENAME', 'No site name is available for this machine.'),
 '192': ('ERROR_EXE_MARKED_INVALID', 'The operating system cannot run %1.'),
 '1920': ('ERROR_CANT_ACCESS_FILE',
          'The file cannot be accessed by the system.'),
 '1921': ('ERROR_CANT_RESOLVE_FILENAME',
          'The name of the file cannot be resolved by the system.'),
 '1922': ('RPC_S_ENTRY_TYPE_MISMATCH',
          'The entry is not of the expected type.'),
 '1923': ('RPC_S_NOT_ALL_OBJS_EXPORTED',
          'Not all object UUIDs could be exported to the specified entry.'),
 '1924': ('RPC_S_INTERFACE_NOT_EXPORTED',
          'Interface could not be exported to the specified entry.'),
 '1925': ('RPC_S_PROFILE_NOT_ADDED',
          'The specified profile entry could not be added.'),
 '1926': ('RPC_S_PRF_ELT_NOT_ADDED',
          'The specified profile element could not be added.'),
 '1927': ('RPC_S_PRF_ELT_NOT_REMOVED',
          'The specified profile element could not be removed.'),
 '1928': ('RPC_S_GRP_ELT_NOT_ADDED', 'The group element could not be added.'),
 '1929': ('RPC_S_GRP_ELT_NOT_REMOVED',
          'The group element could not be removed.'),
 '193': ('ERROR_BAD_EXE_FORMAT', '%1 is not a valid Win32 application.'),
 '1930': ('ERROR_KM_DRIVER_BLOCKED',
          'The printer driver is not compatible with a policy enabled on your computer that blocks NT 4.0 drivers.'),
 '1931': ('ERROR_CONTEXT_EXPIRED',
          'The context has expired and can no longer be used.'),
 '1932': ('ERROR_PER_USER_TRUST_QUOTA_EXCEEDED',
          "The current user's delegated trust creation quota has been exceeded."),
 '1933': ('ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED',
          'The total delegated trust creation quota has been exceeded.'),
 '1934': ('ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED',
          "The current user's delegated trust deletion quota has been exceeded."),
 '1935': ('ERROR_AUTHENTICATION_FIREWALL_FAILED',
          'Logon Failure: The machine you are logging onto is protected by an authentication firewall. The specified account is not allowed to authenticate to the machine.'),
 '1936': ('ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED',
          'Remote connections to the Print Spooler are blocked by a policy set on your machine.'),
 '1937': ('ERROR_NTLM_BLOCKED',
          'Authentication failed because NTLM authentication has been disabled.'),
 '194': ('ERROR_ITERATED_DATA_EXCEEDS_64k',
         'The operating system cannot run %1.'),
 '195': ('ERROR_INVALID_MINALLOCSIZE', 'The operating system cannot run %1.'),
 '196': ('ERROR_DYNLINK_FROM_INVALID_RING',
         'The operating system cannot run this application program.'),
 '197': ('ERROR_IOPL_NOT_ENABLED',
         'The operating system is not presently configured to run this application.'),
 '198': ('ERROR_INVALID_SEGDPL', 'The operating system cannot run %1.'),
 '199': ('ERROR_AUTODATASEG_EXCEEDS_64k',
         'The operating system cannot run this application program.'),
 '2': ('ERROR_FILE_NOT_FOUND', 'The system cannot find the file specified.'),
 '20': ('ERROR_BAD_UNIT', 'The system cannot find the device specified.'),
 '200': ('ERROR_RING2SEG_MUST_BE_MOVABLE',
         'The code segment cannot be greater than or equal to 64K.'),
 '2000': ('ERROR_INVALID_PIXEL_FORMAT', 'The pixel format is invalid.'),
 '2001': ('ERROR_BAD_DRIVER', 'The specified driver is invalid.'),
 '2002': ('ERROR_INVALID_WINDOW_STYLE',
          'The window style or class attribute is invalid for this operation.'),
 '2003': ('ERROR_METAFILE_NOT_SUPPORTED',
          'The requested metafile operation is not supported.'),
 '2004': ('ERROR_TRANSFORM_NOT_SUPPORTED',
          'The requested transformation operation is not supported.'),
 '2005': ('ERROR_CLIPPING_NOT_SUPPORTED',
          'The requested clipping operation is not supported.'),
 '201': ('ERROR_RELOC_CHAIN_XEEDS_SEGLIM',
         'The operating system cannot run %1.'),
 '2010': ('ERROR_INVALID_CMM',
          'The specified color management module is invalid.'),
 '2011': ('ERROR_INVALID_PROFILE', 'The specified color profile is invalid.'),
 '2012': ('ERROR_TAG_NOT_FOUND', 'The specified tag was not found.'),
 '2013': ('ERROR_TAG_NOT_PRESENT', 'A required tag is not present.'),
 '2014': ('ERROR_DUPLICATE_TAG', 'The specified tag is already present.'),
 '2015': ('ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE',
          'The specified color profile is not associated with the specified device.'),
 '2016': ('ERROR_PROFILE_NOT_FOUND',
          'The specified color profile was not found.'),
 '2017': ('ERROR_INVALID_COLORSPACE', 'The specified color space is invalid.'),
 '2018': ('ERROR_ICM_NOT_ENABLED', 'Image Color Management is not enabled.'),
 '2019': ('ERROR_DELETING_ICM_XFORM',
          'There was an error while deleting the color transform.'),
 '202': ('ERROR_INFLOOP_IN_RELOC_CHAIN',
         'The operating system cannot run %1.'),
 '2020': ('ERROR_INVALID_TRANSFORM',
          'The specified color transform is invalid.'),
 '2021': ('ERROR_COLORSPACE_MISMATCH',
          "The specified transform does not match the bitmap's color space."),
 '2022': ('ERROR_INVALID_COLORINDEX',
          'The specified named color index is not present in the profile.'),
 '2023': ('ERROR_PROFILE_DOES_NOT_MATCH_DEVICE',
          'The specified profile is intended for a device of a different type than the specified device.'),
 '203': ('ERROR_ENVVAR_NOT_FOUND',
         'The system could not find the environment option that was entered.'),
 '205': ('ERROR_NO_SIGNAL_SENT',
         'No process in the command subtree has a signal handler.'),
 '206': ('ERROR_FILENAME_EXCED_RANGE',
         'The filename or extension is too long.'),
 '207': ('ERROR_RING2_STACK_IN_USE', 'The ring 2 stack is in use.'),
 '208': ('ERROR_META_EXPANSION_TOO_LONG',
         'The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified.'),
 '209': ('ERROR_INVALID_SIGNAL_NUMBER',
         'The signal being posted is not correct.'),
 '21': ('ERROR_NOT_READY', 'The device is not ready.'),
 '210': ('ERROR_THREAD_1_INACTIVE', 'The signal handler cannot be set.'),
 '2108': ('ERROR_CONNECTED_OTHER_PASSWORD',
          'The network connection was made successfully, but the user had to be prompted for a password other than the one originally specified.'),
 '2109': ('ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT',
          'The network connection was made successfully using default credentials.'),
 '212': ('ERROR_LOCKED', 'The segment is locked and cannot be reallocated.'),
 '214': ('ERROR_TOO_MANY_MODULES',
         'Too many dynamic-link modules are attached to this program or dynamic-link module.'),
 '215': ('ERROR_NESTING_NOT_ALLOWED', 'Cannot nest calls to LoadModule.'),
 '216': ('ERROR_EXE_MACHINE_TYPE_MISMATCH',
         "The version of %1 is not compatible with the version you're running. Check your computer's system information to see whether you need a x86 (32-bit) or x64 (64-bit) version of the program, and then contact the software publisher."),
 '217': ('ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY',
         'The image file %1 is signed, unable to modify.'),
 '218': ('ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY',
         'The image file %1 is strong signed, unable to modify.'),
 '22': ('ERROR_BAD_COMMAND', 'The device does not recognize the command.'),
 '220': ('ERROR_FILE_CHECKED_OUT',
         'This file is checked out or locked for editing by another user.'),
 '2202': ('ERROR_BAD_USERNAME', 'The specified username is invalid.'),
 '221': ('ERROR_CHECKOUT_REQUIRED',
         'The file must be checked out before saving changes.'),
 '222': ('ERROR_BAD_FILE_TYPE',
         'The file type being saved or retrieved has been blocked.'),
 '223': ('ERROR_FILE_TOO_LARGE',
         'The file size exceeds the limit allowed and cannot be saved.'),
 '224': ('ERROR_FORMS_AUTH_REQUIRED',
         'Access Denied. Before opening files in this location, you must first add the web site to your trusted sites list, browse to the web site, and select the option to login automatically.'),
 '225': ('ERROR_VIRUS_INFECTED',
         'Operation did not complete successfully because the file contains a virus.'),
 '2250': ('ERROR_NOT_CONNECTED', 'This network connection does not exist.'),
 '226': ('ERROR_VIRUS_DELETED',
         'This file contains a virus and cannot be opened. Due to the nature of this virus, the file has been removed from this location.'),
 '229': ('ERROR_PIPE_LOCAL', 'The pipe is local.'),
 '23': ('ERROR_CRC', 'Data error (cyclic redundancy check).'),
 '230': ('ERROR_BAD_PIPE', 'The pipe state is invalid.'),
 '231': ('ERROR_PIPE_BUSY', 'All pipe instances are busy.'),
 '232': ('ERROR_NO_DATA', 'The pipe is being closed.'),
 '233': ('ERROR_PIPE_NOT_CONNECTED',
         'No process is on the other end of the pipe.'),
 '234': ('ERROR_MORE_DATA', 'More data is available.'),
 '24': ('ERROR_BAD_LENGTH',
        'The program issued a command but the command length is incorrect.'),
 '240': ('ERROR_VC_DISCONNECTED', 'The session was canceled.'),
 '2401': ('ERROR_OPEN_FILES',
          'This network connection has files open or requests pending.'),
 '2402': ('ERROR_ACTIVE_CONNECTIONS', 'Active connections still exist.'),
 '2404': ('ERROR_DEVICE_IN_USE',
          'The device is in use by an active process and cannot be disconnected.'),
 '25': ('ERROR_SEEK',
        'The drive cannot locate a specific area or track on the disk.'),
 '254': ('ERROR_INVALID_EA_NAME',
         'The specified extended attribute name was invalid.'),
 '255': ('ERROR_EA_LIST_INCONSISTENT',
         'The extended attributes are inconsistent.'),
 '258': ('WAIT_TIMEOUT', 'The wait operation timed out.'),
 '259': ('ERROR_NO_MORE_ITEMS', 'No more data is available.'),
 '26': ('ERROR_NOT_DOS_DISK',
        'The specified disk or diskette cannot be accessed.'),
 '266': ('ERROR_CANNOT_COPY', 'The copy functions cannot be used.'),
 '267': ('ERROR_DIRECTORY', 'The directory name is invalid.'),
 '27': ('ERROR_SECTOR_NOT_FOUND',
        'The drive cannot find the sector requested.'),
 '275': ('ERROR_EAS_DIDNT_FIT',
         'The extended attributes did not fit in the buffer.'),
 '276': ('ERROR_EA_FILE_CORRUPT',
         'The extended attribute file on the mounted file system is corrupt.'),
 '277': ('ERROR_EA_TABLE_FULL', 'The extended attribute table file is full.'),
 '278': ('ERROR_INVALID_EA_HANDLE',
         'The specified extended attribute handle is invalid.'),
 '28': ('ERROR_OUT_OF_PAPER', 'The printer is out of paper.'),
 '282': ('ERROR_EAS_NOT_SUPPORTED',
         'The mounted file system does not support extended attributes.'),
 '288': ('ERROR_NOT_OWNER', 'Attempt to release mutex not owned by caller.'),
 '29': ('ERROR_WRITE_FAULT',
        'The system cannot write to the specified device.'),
 '298': ('ERROR_TOO_MANY_POSTS', 'Too many posts were made to a semaphore.'),
 '299': ('ERROR_PARTIAL_COPY',
         'Only part of a ReadProcessMemory or WriteProcessMemory request was completed.'),
 '3': ('ERROR_PATH_NOT_FOUND', 'The system cannot find the path specified.'),
 '30': ('ERROR_READ_FAULT',
        'The system cannot read from the specified device.'),
 '300': ('ERROR_OPLOCK_NOT_GRANTED', 'The oplock request is denied.'),
 '3000': ('ERROR_UNKNOWN_PRINT_MONITOR',
          'The specified print monitor is unknown.'),
 '3001': ('ERROR_PRINTER_DRIVER_IN_USE',
          'The specified printer driver is currently in use.'),
 '3002': ('ERROR_SPOOL_FILE_NOT_FOUND', 'The spool file was not found.'),
 '3003': ('ERROR_SPL_NO_STARTDOC', 'A StartDocPrinter call was not issued.'),
 '3004': ('ERROR_SPL_NO_ADDJOB', 'An AddJob call was not issued.'),
 '3005': ('ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED',
          'The specified print processor has already been installed.'),
 '3006': ('ERROR_PRINT_MONITOR_ALREADY_INSTALLED',
          'The specified print monitor has already been installed.'),
 '3007': ('ERROR_INVALID_PRINT_MONITOR',
          'The specified print monitor does not have the required functions.'),
 '3008': ('ERROR_PRINT_MONITOR_IN_USE',
          'The specified print monitor is currently in use.'),
 '3009': ('ERROR_PRINTER_HAS_JOBS_QUEUED',
          'The requested operation is not allowed when there are jobs queued to the printer.'),
 '301': ('ERROR_INVALID_OPLOCK_PROTOCOL',
         'An invalid oplock acknowledgment was received by the system.'),
 '3010': ('ERROR_SUCCESS_REBOOT_REQUIRED',
          'The requested operation is successful. Changes will not be effective until the system is rebooted.'),
 '3011': ('ERROR_SUCCESS_RESTART_REQUIRED',
          'The requested operation is successful. Changes will not be effective until the service is restarted.'),
 '3012': ('ERROR_PRINTER_NOT_FOUND', 'No printers were found.'),
 '3013': ('ERROR_PRINTER_DRIVER_WARNED',
          'The printer driver is known to be unreliable.'),
 '3014': ('ERROR_PRINTER_DRIVER_BLOCKED',
          'The printer driver is known to harm the system.'),
 '3015': ('ERROR_PRINTER_DRIVER_PACKAGE_IN_USE',
          'The specified printer driver package is currently in use.'),
 '3016': ('ERROR_CORE_DRIVER_PACKAGE_NOT_FOUND',
          'Unable to find a core driver package that is required by the printer driver package.'),
 '3017': ('ERROR_FAIL_REBOOT_REQUIRED',
          'The requested operation failed. A system reboot is required to roll back changes made.'),
 '3018': ('ERROR_FAIL_REBOOT_INITIATED',
          'The requested operation failed. A system reboot has been initiated to roll back changes made.'),
 '3019': ('ERROR_PRINTER_DRIVER_DOWNLOAD_NEEDED',
          'The specified printer driver was not found on the system and needs to be downloaded.'),
 '302': ('ERROR_DISK_TOO_FRAGMENTED',
         'The volume is too fragmented to complete this operation.'),
 '3020': ('ERROR_PRINT_JOB_RESTART_REQUIRED',
          'The requested print job has failed to print. A print system update requires the job to be resubmitted.'),
 '303': ('ERROR_DELETE_PENDING',
         'The file cannot be opened because it is in the process of being deleted.'),
 '31': ('ERROR_GEN_FAILURE',
        'A device attached to the system is not functioning.'),
 '317': ('ERROR_MR_MID_NOT_FOUND',
         'The system cannot find message text for message number 0x%1 in the message file for %2.'),
 '318': ('ERROR_SCOPE_NOT_FOUND', 'The scope specified was not found.'),
 '32': ('ERROR_SHARING_VIOLATION',
        'The process cannot access the file because it is being used by another process.'),
 '33': ('ERROR_LOCK_VIOLATION',
        'The process cannot access the file because another process has locked a portion of the file.'),
 '34': ('ERROR_WRONG_DISK',
        'The wrong diskette is in the drive. Insert %2 (Volume Serial Number: %3) into drive %1.'),
 '350': ('ERROR_FAIL_NOACTION_REBOOT',
         'No action was taken as a system reboot is required.'),
 '351': ('ERROR_FAIL_SHUTDOWN', 'The shutdown operation failed.'),
 '352': ('ERROR_FAIL_RESTART', 'The restart operation failed.'),
 '353': ('ERROR_MAX_SESSIONS_REACHED',
         'The maximum number of sessions has been reached.'),
 '36': ('ERROR_SHARING_BUFFER_EXCEEDED', 'Too many files opened for sharing.'),
 '38': ('ERROR_HANDLE_EOF', 'Reached the end of the file.'),
 '39': ('ERROR_HANDLE_DISK_FULL', 'The disk is full.'),
 '3950': ('ERROR_IO_REISSUE_AS_CACHED',
          'Reissue the given operation as a cached I/O operation.'),
 '4': ('ERROR_TOO_MANY_OPEN_FILES', 'The system cannot open the file.'),
 '400': ('ERROR_THREAD_MODE_ALREADY_BACKGROUND',
         'The thread is already in background processing mode.'),
 '4000': ('ERROR_WINS_INTERNAL',
          'WINS encountered an error while processing the command.'),
 '4001': ('ERROR_CAN_NOT_DEL_LOCAL_WINS', 'The local WINS cannot be deleted.'),
 '4002': ('ERROR_STATIC_INIT', 'The importation from the file failed.'),
 '4003': ('ERROR_INC_BACKUP',
          'The backup failed. Was a full backup done before?'),
 '4004': ('ERROR_FULL_BACKUP',
          'The backup failed. Check the directory to which you are backing the database.'),
 '4005': ('ERROR_REC_NON_EXISTENT',
          'The name does not exist in the WINS database.'),
 '4006': ('ERROR_RPL_NOT_ALLOWED',
          'Replication with a nonconfigured partner is not allowed.'),
 '401': ('ERROR_THREAD_MODE_NOT_BACKGROUND',
         'The thread is not in background processing mode.'),
 '402': ('ERROR_PROCESS_MODE_ALREADY_BACKGROUND',
         'The process is already in background processing mode.'),
 '403': ('ERROR_PROCESS_MODE_NOT_BACKGROUND',
         'The process is not in background processing mode.'),
 '4100': ('ERROR_DHCP_ADDRESS_CONFLICT',
          'The DHCP client has obtained an IP address that is already in use on the network. The local interface will be disabled until the DHCP client can obtain a new address.'),
 '4200': ('ERROR_WMI_GUID_NOT_FOUND',
          'The GUID passed was not recognized as valid by a WMI data provider.'),
 '4201': ('ERROR_WMI_INSTANCE_NOT_FOUND',
          'The instance name passed was not recognized as valid by a WMI data provider.'),
 '4202': ('ERROR_WMI_ITEMID_NOT_FOUND',
          'The data item ID passed was not recognized as valid by a WMI data provider.'),
 '4203': ('ERROR_WMI_TRY_AGAIN',
          'The WMI request could not be completed and should be retried.'),
 '4204': ('ERROR_WMI_DP_NOT_FOUND',
          'The WMI data provider could not be located.'),
 '4205': ('ERROR_WMI_UNRESOLVED_INSTANCE_REF',
          'The WMI data provider references an instance set that has not been registered.'),
 '4206': ('ERROR_WMI_ALREADY_ENABLED',
          'The WMI data block or event notification has already been enabled.'),
 '4207': ('ERROR_WMI_GUID_DISCONNECTED',
          'The WMI data block is no longer available.'),
 '4208': ('ERROR_WMI_SERVER_UNAVAILABLE',
          'The WMI data service is not available.'),
 '4209': ('ERROR_WMI_DP_FAILED',
          'The WMI data provider failed to carry out the request.'),
 '4210': ('ERROR_WMI_INVALID_MOF', 'The WMI MOF information is not valid.'),
 '4211': ('ERROR_WMI_INVALID_REGINFO',
          'The WMI registration information is not valid.'),
 '4212': ('ERROR_WMI_ALREADY_DISABLED',
          'The WMI data block or event notification has already been disabled.'),
 '4213': ('ERROR_WMI_READ_ONLY',
          'The WMI data item or data block is read only.'),
 '4214': ('ERROR_WMI_SET_FAILURE',
          'The WMI data item or data block could not be changed.'),
 '4300': ('ERROR_INVALID_MEDIA',
          'The media identifier does not represent a valid medium.'),
 '4301': ('ERROR_INVALID_LIBRARY',
          'The library identifier does not represent a valid library.'),
 '4302': ('ERROR_INVALID_MEDIA_POOL',
          'The media pool identifier does not represent a valid media pool.'),
 '4303': ('ERROR_DRIVE_MEDIA_MISMATCH',
          'The drive and medium are not compatible or exist in different libraries.'),
 '4304': ('ERROR_MEDIA_OFFLINE',
          'The medium currently exists in an offline library and must be online to perform this operation.'),
 '4305': ('ERROR_LIBRARY_OFFLINE',
          'The operation cannot be performed on an offline library.'),
 '4306': ('ERROR_EMPTY', 'The library, drive, or media pool is empty.'),
 '4307': ('ERROR_NOT_EMPTY',
          'The library, drive, or media pool must be empty to perform this operation.'),
 '4308': ('ERROR_MEDIA_UNAVAILABLE',
          'No media is currently available in this media pool or library.'),
 '4309': ('ERROR_RESOURCE_DISABLED',
          'A resource required for this operation is disabled.'),
 '4310': ('ERROR_INVALID_CLEANER',
          'The media identifier does not represent a valid cleaner.'),
 '4311': ('ERROR_UNABLE_TO_CLEAN',
          'The drive cannot be cleaned or does not support cleaning.'),
 '4312': ('ERROR_OBJECT_NOT_FOUND',
          'The object identifier does not represent a valid object.'),
 '4313': ('ERROR_DATABASE_FAILURE',
          'Unable to read from or write to the database.'),
 '4314': ('ERROR_DATABASE_FULL', 'The database is full.'),
 '4315': ('ERROR_MEDIA_INCOMPATIBLE',
          'The medium is not compatible with the device or media pool.'),
 '4316': ('ERROR_RESOURCE_NOT_PRESENT',
          'The resource required for this operation does not exist.'),
 '4317': ('ERROR_INVALID_OPERATION', 'The operation identifier is not valid.'),
 '4318': ('ERROR_MEDIA_NOT_AVAILABLE',
          'The media is not mounted or ready for use.'),
 '4319': ('ERROR_DEVICE_NOT_AVAILABLE', 'The device is not ready for use.'),
 '4320': ('ERROR_REQUEST_REFUSED',
          'The operator or administrator has refused the request.'),
 '4321': ('ERROR_INVALID_DRIVE_OBJECT',
          'The drive identifier does not represent a valid drive.'),
 '4322': ('ERROR_LIBRARY_FULL',
          'Library is full. No slot is available for use.'),
 '4323': ('ERROR_MEDIUM_NOT_ACCESSIBLE',
          'The transport cannot access the medium.'),
 '4324': ('ERROR_UNABLE_TO_LOAD_MEDIUM',
          'Unable to load the medium into the drive.'),
 '4325': ('ERROR_UNABLE_TO_INVENTORY_DRIVE',
          'Unable to retrieve the drive status.'),
 '4326': ('ERROR_UNABLE_TO_INVENTORY_SLOT',
          'Unable to retrieve the slot status.'),
 '4327': ('ERROR_UNABLE_TO_INVENTORY_TRANSPORT',
          'Unable to retrieve status about the transport.'),
 '4328': ('ERROR_TRANSPORT_FULL',
          'Cannot use the transport because it is already in use.'),
 '4329': ('ERROR_CONTROLLING_IEPORT',
          'Unable to open or close the inject/eject port.'),
 '4330': ('ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA',
          'Unable to eject the medium because it is in a drive.'),
 '4331': ('ERROR_CLEANER_SLOT_SET', 'A cleaner slot is already reserved.'),
 '4332': ('ERROR_CLEANER_SLOT_NOT_SET', 'A cleaner slot is not reserved.'),
 '4333': ('ERROR_CLEANER_CARTRIDGE_SPENT',
          'The cleaner cartridge has performed the maximum number of drive cleanings.'),
 '4334': ('ERROR_UNEXPECTED_OMID', 'Unexpected on-medium identifier.'),
 '4335': ('ERROR_CANT_DELETE_LAST_ITEM',
          'The last remaining item in this group or resource cannot be deleted.'),
 '4336': ('ERROR_MESSAGE_EXCEEDS_MAX_SIZE',
          'The message provided exceeds the maximum size allowed for this parameter.'),
 '4337': ('ERROR_VOLUME_CONTAINS_SYS_FILES',
          'The volume contains system or paging files.'),
 '4338': ('ERROR_INDIGENOUS_TYPE',
          'The media type cannot be removed from this library since at least one drive in the library reports it can support this media type.'),
 '4339': ('ERROR_NO_SUPPORTING_DRIVES',
          'This offline media cannot be mounted on this system since no enabled drives are present which can be used.'),
 '4340': ('ERROR_CLEANER_CARTRIDGE_INSTALLED',
          'A cleaner cartridge is present in the tape library.'),
 '4341': ('ERROR_IEPORT_FULL',
          'Cannot use the ieport because it is not empty.'),
 '4350': ('ERROR_FILE_OFFLINE',
          'The file is currently not available for use on this computer.'),
 '4351': ('ERROR_REMOTE_STORAGE_NOT_ACTIVE',
          'The remote storage service is not operational at this time.'),
 '4352': ('ERROR_REMOTE_STORAGE_MEDIA_ERROR',
          'The remote storage service encountered a media error.'),
 '4390': ('ERROR_NOT_A_REPARSE_POINT',
          'The file or directory is not a reparse point.'),
 '4391': ('ERROR_REPARSE_ATTRIBUTE_CONFLICT',
          'The reparse point attribute cannot be set because it conflicts with an existing attribute.'),
 '4392': ('ERROR_INVALID_REPARSE_DATA',
          'The data present in the reparse point buffer is invalid.'),
 '4393': ('ERROR_REPARSE_TAG_INVALID',
          'The tag present in the reparse point buffer is invalid.'),
 '4394': ('ERROR_REPARSE_TAG_MISMATCH',
          'There is a mismatch between the tag specified in the request and the tag present in the reparse point.'),
 '4500': ('ERROR_VOLUME_NOT_SIS_ENABLED',
          'Single Instance Storage is not available on this volume.'),
 '487': ('ERROR_INVALID_ADDRESS', 'Attempt to access invalid address.'),
 '5': ('ERROR_ACCESS_DENIED', 'Access is denied.'),
 '50': ('ERROR_NOT_SUPPORTED', 'The request is not supported.'),
 '500': ('ERROR_USER_PROFILE_LOAD', 'User profile cannot be loaded.'),
 '5001': ('ERROR_DEPENDENT_RESOURCE_EXISTS',
          'The operation cannot be completed because other resources are dependent on this resource.'),
 '5002': ('ERROR_DEPENDENCY_NOT_FOUND',
          'The cluster resource dependency cannot be found.'),
 '5003': ('ERROR_DEPENDENCY_ALREADY_EXISTS',
          'The cluster resource cannot be made dependent on the specified resource because it is already dependent.'),
 '5004': ('ERROR_RESOURCE_NOT_ONLINE', 'The cluster resource is not online.'),
 '5005': ('ERROR_HOST_NODE_NOT_AVAILABLE',
          'A cluster node is not available for this operation.'),
 '5006': ('ERROR_RESOURCE_NOT_AVAILABLE',
          'The cluster resource is not available.'),
 '5007': ('ERROR_RESOURCE_NOT_FOUND',
          'The cluster resource could not be found.'),
 '5008': ('ERROR_SHUTDOWN_CLUSTER', 'The cluster is being shut down.'),
 '5009': ('ERROR_CANT_EVICT_ACTIVE_NODE',
          'A cluster node cannot be evicted from the cluster unless the node is down or it is the last node.'),
 '5010': ('ERROR_OBJECT_ALREADY_EXISTS', 'The object already exists.'),
 '5011': ('ERROR_OBJECT_IN_LIST', 'The object is already in the list.'),
 '5012': ('ERROR_GROUP_NOT_AVAILABLE',
          'The cluster group is not available for any new requests.'),
 '5013': ('ERROR_GROUP_NOT_FOUND', 'The cluster group could not be found.'),
 '5014': ('ERROR_GROUP_NOT_ONLINE',
          'The operation could not be completed because the cluster group is not online.'),
 '5015': ('ERROR_HOST_NODE_NOT_RESOURCE_OWNER',
          'The operation failed because either the specified cluster node is not the owner of the resource, or the node is not a possible owner of the resource.'),
 '5016': ('ERROR_HOST_NODE_NOT_GROUP_OWNER',
          'The operation failed because either the specified cluster node is not the owner of the group, or the node is not a possible owner of the group.'),
 '5017': ('ERROR_RESMON_CREATE_FAILED',
          'The cluster resource could not be created in the specified resource monitor.'),
 '5018': ('ERROR_RESMON_ONLINE_FAILED',
          'The cluster resource could not be brought online by the resource monitor.'),
 '5019': ('ERROR_RESOURCE_ONLINE',
          'The operation could not be completed because the cluster resource is online.'),
 '5020': ('ERROR_QUORUM_RESOURCE',
          'The cluster resource could not be deleted or brought offline because it is the quorum resource.'),
 '5021': ('ERROR_NOT_QUORUM_CAPABLE',
          'The cluster could not make the specified resource a quorum resource because it is not capable of being a quorum resource.'),
 '5022': ('ERROR_CLUSTER_SHUTTING_DOWN',
          'The cluster software is shutting down.'),
 '5023': ('ERROR_INVALID_STATE',
          'The group or resource is not in the correct state to perform the requested operation.'),
 '5024': ('ERROR_RESOURCE_PROPERTIES_STORED',
          'The properties were stored but not all changes will take effect until the next time the resource is brought online.'),
 '5025': ('ERROR_NOT_QUORUM_CLASS',
          'The cluster could not make the specified resource a quorum resource because it does not belong to a shared storage class.'),
 '5026': ('ERROR_CORE_RESOURCE',
          'The cluster resource could not be deleted since it is a core resource.'),
 '5027': ('ERROR_QUORUM_RESOURCE_ONLINE_FAILED',
          'The quorum resource failed to come online.'),
 '5028': ('ERROR_QUORUMLOG_OPEN_FAILED',
          'The quorum log could not be created or mounted successfully.'),
 '5029': ('ERROR_CLUSTERLOG_CORRUPT', 'The cluster log is corrupt.'),
 '5030': ('ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE',
          'The record could not be written to the cluster log since it exceeds the maximum size.'),
 '5031': ('ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE',
          'The cluster log exceeds its maximum size.'),
 '5032': ('ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND',
          'No checkpoint record was found in the cluster log.'),
 '5033': ('ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE',
          'The minimum required disk space needed for logging is not available.'),
 '5034': ('ERROR_QUORUM_OWNER_ALIVE',
          'The cluster node failed to take control of the quorum resource because the resource is owned by another active node.'),
 '5035': ('ERROR_NETWORK_NOT_AVAILABLE',
          'A cluster network is not available for this operation.'),
 '5036': ('ERROR_NODE_NOT_AVAILABLE',
          'A cluster node is not available for this operation.'),
 '5037': ('ERROR_ALL_NODES_NOT_AVAILABLE',
          'All cluster nodes must be running to perform this operation.'),
 '5038': ('ERROR_RESOURCE_FAILED', 'A cluster resource failed.'),
 '5039': ('ERROR_CLUSTER_INVALID_NODE', 'The cluster node is not valid.'),
 '5040': ('ERROR_CLUSTER_NODE_EXISTS', 'The cluster node already exists.'),
 '5041': ('ERROR_CLUSTER_JOIN_IN_PROGRESS',
          'A node is in the process of joining the cluster.'),
 '5042': ('ERROR_CLUSTER_NODE_NOT_FOUND', 'The cluster node was not found.'),
 '5043': ('ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND',
          'The cluster local node information was not found.'),
 '5044': ('ERROR_CLUSTER_NETWORK_EXISTS',
          'The cluster network already exists.'),
 '5045': ('ERROR_CLUSTER_NETWORK_NOT_FOUND',
          'The cluster network was not found.'),
 '5046': ('ERROR_CLUSTER_NETINTERFACE_EXISTS',
          'The cluster network interface already exists.'),
 '5047': ('ERROR_CLUSTER_NETINTERFACE_NOT_FOUND',
          'The cluster network interface was not found.'),
 '5048': ('ERROR_CLUSTER_INVALID_REQUEST',
          'The cluster request is not valid for this object.'),
 '5049': ('ERROR_CLUSTER_INVALID_NETWORK_PROVIDER',
          'The cluster network provider is not valid.'),
 '5050': ('ERROR_CLUSTER_NODE_DOWN', 'The cluster node is down.'),
 '5051': ('ERROR_CLUSTER_NODE_UNREACHABLE',
          'The cluster node is not reachable.'),
 '5052': ('ERROR_CLUSTER_NODE_NOT_MEMBER',
          'The cluster node is not a member of the cluster.'),
 '5053': ('ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS',
          'A cluster join operation is not in progress.'),
 '5054': ('ERROR_CLUSTER_INVALID_NETWORK',
          'The cluster network is not valid.'),
 '5056': ('ERROR_CLUSTER_NODE_UP', 'The cluster node is up.'),
 '5057': ('ERROR_CLUSTER_IPADDR_IN_USE',
          'The cluster IP address is already in use.'),
 '5058': ('ERROR_CLUSTER_NODE_NOT_PAUSED', 'The cluster node is not paused.'),
 '5059': ('ERROR_CLUSTER_NO_SECURITY_CONTEXT',
          'No cluster security context is available.'),
 '5060': ('ERROR_CLUSTER_NETWORK_NOT_INTERNAL',
          'The cluster network is not configured for internal cluster communication.'),
 '5061': ('ERROR_CLUSTER_NODE_ALREADY_UP', 'The cluster node is already up.'),
 '5062': ('ERROR_CLUSTER_NODE_ALREADY_DOWN',
          'The cluster node is already down.'),
 '5063': ('ERROR_CLUSTER_NETWORK_ALREADY_ONLINE',
          'The cluster network is already online.'),
 '5064': ('ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE',
          'The cluster network is already offline.'),
 '5065': ('ERROR_CLUSTER_NODE_ALREADY_MEMBER',
          'The cluster node is already a member of the cluster.'),
 '5066': ('ERROR_CLUSTER_LAST_INTERNAL_NETWORK',
          'The cluster network is the only one configured for internal cluster communication between two or more active cluster nodes. The internal communication capability cannot be removed from the network.'),
 '5067': ('ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS',
          'One or more cluster resources depend on the network to provide service to clients. The client access capability cannot be removed from the network.'),
 '5068': ('ERROR_INVALID_OPERATION_ON_QUORUM',
          'This operation cannot be performed on the cluster resource as it the quorum resource. You may not bring the quorum resource offline or modify its possible owners list.'),
 '5069': ('ERROR_DEPENDENCY_NOT_ALLOWED',
          'The cluster quorum resource is not allowed to have any dependencies.'),
 '5070': ('ERROR_CLUSTER_NODE_PAUSED', 'The cluster node is paused.'),
 '5071': ('ERROR_NODE_CANT_HOST_RESOURCE',
          'The cluster resource cannot be brought online. The owner node cannot run this resource.'),
 '5072': ('ERROR_CLUSTER_NODE_NOT_READY',
          'The cluster node is not ready to perform the requested operation.'),
 '5073': ('ERROR_CLUSTER_NODE_SHUTTING_DOWN',
          'The cluster node is shutting down.'),
 '5074': ('ERROR_CLUSTER_JOIN_ABORTED',
          'The cluster join operation was aborted.'),
 '5075': ('ERROR_CLUSTER_INCOMPATIBLE_VERSIONS',
          'The cluster join operation failed due to incompatible software versions between the joining node and its sponsor.'),
 '5076': ('ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED',
          'This resource cannot be created because the cluster has reached the limit on the number of resources it can monitor.'),
 '5077': ('ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED',
          'The system configuration changed during the cluster join or form operation. The join or form operation was aborted.'),
 '5078': ('ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND',
          'The specified resource type was not found.'),
 '5079': ('ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED',
          'The specified node does not support a resource of this type. This may be due to version inconsistencies or due to the absence of the resource DLL on this node.'),
 '5080': ('ERROR_CLUSTER_RESNAME_NOT_FOUND',
          'The specified resource name is not supported by this resource DLL. This may be due to a bad (or changed) name supplied to the resource DLL.'),
 '5081': ('ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED',
          'No authentication package could be registered with the RPC server.'),
 '5082': ('ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST',
          'You cannot bring the group online because the owner of the group is not in the preferred list for the group. To change the owner node for the group, move the group.'),
 '5083': ('ERROR_CLUSTER_DATABASE_SEQMISMATCH',
          'The join operation failed because the cluster database sequence number has changed or is incompatible with the locker node. This may happen during a join operation if the cluster database was changing during the join.'),
 '5084': ('ERROR_RESMON_INVALID_STATE',
          'The resource monitor will not allow the fail operation to be performed while the resource is in its current state. This may happen if the resource is in a pending state.'),
 '5085': ('ERROR_CLUSTER_GUM_NOT_LOCKER',
          'A non locker code got a request to reserve the lock for making global updates.'),
 '5086': ('ERROR_QUORUM_DISK_NOT_FOUND',
          'The quorum disk could not be located by the cluster service.'),
 '5087': ('ERROR_DATABASE_BACKUP_CORRUPT',
          'The backed up cluster database is possibly corrupt.'),
 '5088': ('ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT',
          'A DFS root already exists in this cluster node.'),
 '5089': ('ERROR_RESOURCE_PROPERTY_UNCHANGEABLE',
          'An attempt to modify a resource property failed because it conflicts with another existing property.'),
 '51': ('ERROR_REM_NOT_LIST',
        'Windows cannot find the network path. Verify that the network path is correct and the destination computer is not busy or turned off. If Windows still cannot find the network path, contact your network administrator.'),
 '52': ('ERROR_DUP_NAME',
        'You were not connected because a duplicate name exists on the network. If joining a domain, go to System in Control Panel to change the computer name and try again. If joining a workgroup, choose another workgroup name.'),
 '53': ('ERROR_BAD_NETPATH', 'The network path was not found.'),
 '534': ('ERROR_ARITHMETIC_OVERFLOW', 'Arithmetic result exceeded 32 bits.'),
 '535': ('ERROR_PIPE_CONNECTED',
         'There is a process on other end of the pipe.'),
 '536': ('ERROR_PIPE_LISTENING',
         'Waiting for a process to open the other end of the pipe.'),
 '537': ('ERROR_VERIFIER_STOP',
         'Application verifier has found an error in the current process.'),
 '538': ('ERROR_ABIOS_ERROR', 'An error occurred in the ABIOS subsystem.'),
 '539': ('ERROR_WX86_WARNING', 'A warning occurred in the WX86 subsystem.'),
 '54': ('ERROR_NETWORK_BUSY', 'The network is busy.'),
 '540': ('ERROR_WX86_ERROR', 'An error occurred in the WX86 subsystem.'),
 '541': ('ERROR_TIMER_NOT_CANCELED',
         'An attempt was made to cancel or set a timer that has an associated APC and the subject thread is not the thread that originally set the timer with an associated APC routine.'),
 '542': ('ERROR_UNWIND', 'Unwind exception code.'),
 '543': ('ERROR_BAD_STACK',
         'An invalid or unaligned stack was encountered during an unwind operation.'),
 '544': ('ERROR_INVALID_UNWIND_TARGET',
         'An invalid unwind target was encountered during an unwind operation.'),
 '545': ('ERROR_INVALID_PORT_ATTRIBUTES',
         'Invalid Object Attributes specified to NtCreatePort or invalid Port Attributes specified to NtConnectPort'),
 '546': ('ERROR_PORT_MESSAGE_TOO_LONG',
         'Length of message passed to NtRequestPort or NtRequestWaitReplyPort was longer than the maximum message allowed by the port.'),
 '547': ('ERROR_INVALID_QUOTA_LOWER',
         'An attempt was made to lower a quota limit below the current usage.'),
 '548': ('ERROR_DEVICE_ALREADY_ATTACHED',
         'An attempt was made to attach to a device that was already attached to another device.'),
 '549': ('ERROR_INSTRUCTION_MISALIGNMENT',
         'An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references.'),
 '55': ('ERROR_DEV_NOT_EXIST',
        'The specified network resource or device is no longer available.'),
 '550': ('ERROR_PROFILING_NOT_STARTED', 'Profiling not started.'),
 '551': ('ERROR_PROFILING_NOT_STOPPED', 'Profiling not stopped.'),
 '552': ('ERROR_COULD_NOT_INTERPRET',
         'The passed ACL did not contain the minimum required information.'),
 '553': ('ERROR_PROFILING_AT_LIMIT',
         'The number of active profiling objects is at the maximum and no more may be started.'),
 '554': ('ERROR_CANT_WAIT',
         'Used to indicate that an operation cannot continue without blocking for I/O.'),
 '555': ('ERROR_CANT_TERMINATE_SELF',
         'Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NULL) and it was the last thread in the current process.'),
 '556': ('ERROR_UNEXPECTED_MM_CREATE_ERR',
         'If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception.'),
 '557': ('ERROR_UNEXPECTED_MM_MAP_ERROR',
         'If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception.'),
 '558': ('ERROR_UNEXPECTED_MM_EXTEND_ERR',
         'If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception.'),
 '559': ('ERROR_BAD_FUNCTION_TABLE',
         'A malformed function table was encountered during an unwind operation.'),
 '56': ('ERROR_TOO_MANY_CMDS',
        'The network BIOS command limit has been reached.'),
 '560': ('ERROR_NO_GUID_TRANSLATION',
         'Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system. This causes the protection attempt to fail, which may cause a file creation attempt to fail.'),
 '561': ('ERROR_INVALID_LDT_SIZE',
         'Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors.'),
 '563': ('ERROR_INVALID_LDT_OFFSET',
         'Indicates that the starting value for the LDT information was not an integral multiple of the selector size.'),
 '564': ('ERROR_INVALID_LDT_DESCRIPTOR',
         'Indicates that the user supplied an invalid descriptor when trying to set up Ldt descriptors.'),
 '565': ('ERROR_TOO_MANY_THREADS',
         'Indicates a process has too many threads to perform the requested action. For example, assignment of a primary token may only be performed when a process has zero or one threads.'),
 '566': ('ERROR_THREAD_NOT_IN_PROCESS',
         'An attempt was made to operate on a thread within a specific process, but the thread specified is not in the process specified.'),
 '567': ('ERROR_PAGEFILE_QUOTA_EXCEEDED', 'Page file quota was exceeded.'),
 '568': ('ERROR_LOGON_SERVER_CONFLICT',
         'The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role.'),
 '569': ('ERROR_SYNCHRONIZATION_REQUIRED',
         'The SAM database on a Windows Server is significantly out of synchronization with the copy on the Domain Controller. A complete synchronization is required.'),
 '57': ('ERROR_ADAP_HDW_ERR', 'A network adapter hardware error occurred.'),
 '570': ('ERROR_NET_OPEN_FAILED',
         'The NtCreateFile API failed. This error should never be returned to an application, it is a place holder for the Windows Lan Manager Redirector to use in its internal error mapping routines.'),
 '571': ('ERROR_IO_PRIVILEGE_FAILED',
         '{Privilege Failed} The I/O permissions for the process could not be changed.'),
 '572': ('ERROR_CONTROL_C_EXIT',
         '{Application Exit by CTRL+C} The application terminated as a result of a CTRL+C.'),
 '573': ('ERROR_MISSING_SYSTEMFILE',
         '{Missing System File} The required system file %hs is bad or missing.'),
 '574': ('ERROR_UNHANDLED_EXCEPTION',
         '{Application Error} The exception %s (0x%08lx) occurred in the application at location 0x%08lx.'),
 '575': ('ERROR_APP_INIT_FAILURE',
         '{Application Error} The application failed to initialize properly (0x%lx). Click OK to terminate the application.'),
 '576': ('ERROR_PAGEFILE_CREATE_FAILED',
         '{Unable to Create Paging File} The creation of the paging file %hs failed (%lx). The requested size was %ld.'),
 '577': ('ERROR_INVALID_IMAGE_HASH',
         'Windows cannot verify the digital signature for this file. A recent hardware or software change might have installed a file that is signed incorrectly or damaged, or that might be malicious software from an unknown source.'),
 '578': ('ERROR_NO_PAGEFILE',
         '{No Paging File Specified} No paging file was specified in the system configuration.'),
 '579': ('ERROR_ILLEGAL_FLOAT_CONTEXT',
         '{EXCEPTION} A real-mode application issued a floating-point instruction and floating-point hardware is not present.'),
 '58': ('ERROR_BAD_NET_RESP',
        'The specified server cannot perform the requested operation.'),
 '580': ('ERROR_NO_EVENT_PAIR',
         'An event pair synchronization operation was performed using the thread specific client/server event pair object, but no event pair object was associated with the thread.'),
 '581': ('ERROR_DOMAIN_CTRLR_CONFIG_ERROR',
         'A Windows Server has an incorrect configuration.'),
 '582': ('ERROR_ILLEGAL_CHARACTER',
         'An illegal character was encountered. For a multi-byte character set this includes a lead byte without a succeeding trail byte. For the Unicode character set this includes the characters 0xFFFF and 0xFFFE.'),
 '583': ('ERROR_UNDEFINED_CHARACTER',
         'The Unicode character is not defined in the Unicode character set installed on the system.'),
 '584': ('ERROR_FLOPPY_VOLUME',
         'The paging file cannot be created on a floppy diskette.'),
 '585': ('ERROR_BIOS_FAILED_TO_CONNECT_INTERRUPT',
         'The system BIOS failed to connect a system interrupt to the device or bus for which the device is connected.'),
 '586': ('ERROR_BACKUP_CONTROLLER',
         'This operation is only allowed for the Primary Domain Controller of the domain.'),
 '587': ('ERROR_MUTANT_LIMIT_EXCEEDED',
         'An attempt was made to acquire a mutant such that its maximum count would have been exceeded.'),
 '588': ('ERROR_FS_DRIVER_REQUIRED',
         'A volume has been accessed for which a file system driver is required that has not yet been loaded.'),
 '589': ('ERROR_CANNOT_LOAD_REGISTRY_FILE',
         '{Registry File Failure} The registry cannot load the hive (file): %hs or its log or alternate. It is corrupt, absent, or not writable.'),
 '5890': ('ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE',
          'An operation was attempted that is incompatible with the current membership state of the node.'),
 '5891': ('ERROR_CLUSTER_QUORUMLOG_NOT_FOUND',
          'The quorum resource does not contain the quorum log.'),
 '5892': ('ERROR_CLUSTER_MEMBERSHIP_HALT',
          'The membership engine requested shutdown of the cluster service on this node.'),
 '5893': ('ERROR_CLUSTER_INSTANCE_ID_MISMATCH',
          'The join operation failed because the cluster instance ID of the joining node does not match the cluster instance ID of the sponsor node.'),
 '5894': ('ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP',
          'A matching cluster network for the specified IP address could not be found.'),
 '5895': ('ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH',
          'The actual data type of the property did not match the expected data type of the property.'),
 '5896': ('ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP',
          'The cluster node was evicted from the cluster successfully, but the node was not cleaned up. To determine what cleanup steps failed and how to recover, see the Failover Clustering application event log using Event Viewer.'),
 '5897': ('ERROR_CLUSTER_PARAMETER_MISMATCH',
          "Two or more parameter values specified for a resource's properties are in conflict."),
 '5898': ('ERROR_NODE_CANNOT_BE_CLUSTERED',
          'This computer cannot be made a member of a cluster.'),
 '5899': ('ERROR_CLUSTER_WRONG_OS_VERSION',
          'This computer cannot be made a member of a cluster because it does not have the correct version of Windows installed.'),
 '59': ('ERROR_UNEXP_NET_ERR', 'An unexpected network error occurred.'),
 '590': ('ERROR_DEBUG_ATTACH_FAILED',
         '{Unexpected Failure in DebugActiveProcess} An unexpected failure occurred while processing a DebugActiveProcess API request. You may choose OK to terminate the process, or Cancel to ignore the error.'),
 '5900': ('ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME',
          'A cluster cannot be created with the specified cluster name because that cluster name is already in use. Specify a different name for the cluster.'),
 '5901': ('ERROR_CLUSCFG_ALREADY_COMMITTED',
          'The cluster configuration action has already been committed.'),
 '5902': ('ERROR_CLUSCFG_ROLLBACK_FAILED',
          'The cluster configuration action could not be rolled back.'),
 '5903': ('ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT',
          'The drive letter assigned to a system disk on one node conflicted with the drive letter assigned to a disk on another node.'),
 '5904': ('ERROR_CLUSTER_OLD_VERSION',
          'One or more nodes in the cluster are running a version of Windows that does not support this operation.'),
 '5905': ('ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME',
          "The name of the corresponding computer account doesn't match the Network Name for this resource."),
 '5906': ('ERROR_CLUSTER_NO_NET_ADAPTERS',
          'No network adapters are available.'),
 '5907': ('ERROR_CLUSTER_POISONED', 'The cluster node has been poisoned.'),
 '5908': ('ERROR_CLUSTER_GROUP_MOVING',
          'The group is unable to accept the request since it is moving to another node.'),
 '5909': ('ERROR_CLUSTER_RESOURCE_TYPE_BUSY',
          'The resource type cannot accept the request since is too busy performing another operation.'),
 '591': ('ERROR_SYSTEM_PROCESS_TERMINATED',
         '{Fatal System Error} The %hs system process terminated unexpectedly with a status of 0x%08x (0x%08x 0x%08x). The system has been shut down.'),
 '5910': ('ERROR_RESOURCE_CALL_TIMED_OUT',
          'The call to the cluster resource DLL timed out.'),
 '5911': ('ERROR_INVALID_CLUSTER_IPV6_ADDRESS',
          'The address is not valid for an IPv6 Address resource. A global IPv6 address is required, and it must match a cluster network. Compatibility addresses are not permitted.'),
 '5912': ('ERROR_CLUSTER_INTERNAL_INVALID_FUNCTION',
          'An internal cluster error occurred. A call to an invalid function was attempted.'),
 '5913': ('ERROR_CLUSTER_PARAMETER_OUT_OF_BOUNDS',
          'A parameter value is out of acceptable range.'),
 '5914': ('ERROR_CLUSTER_PARTIAL_SEND',
          'A network error occurred while sending data to another node in the cluster. The number of bytes transmitted was less than required.'),
 '5915': ('ERROR_CLUSTER_REGISTRY_INVALID_FUNCTION',
          'An invalid cluster registry operation was attempted.'),
 '5916': ('ERROR_CLUSTER_INVALID_STRING_TERMINATION',
          'An input string of characters is not properly terminated.'),
 '5917': ('ERROR_CLUSTER_INVALID_STRING_FORMAT',
          'An input string of characters is not in a valid format for the data it represents.'),
 '5918': ('ERROR_CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS',
          'An internal cluster error occurred. A cluster database transaction was attempted while a transaction was already in progress.'),
 '5919': ('ERROR_CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS',
          'An internal cluster error occurred. There was an attempt to commit a cluster database transaction while no transaction was in progress.'),
 '592': ('ERROR_DATA_NOT_ACCEPTED',
         '{Data Not Accepted} The TDI client could not handle the data received during an indication.'),
 '5920': ('ERROR_CLUSTER_NULL_DATA',
          'An internal cluster error occurred. Data was not properly initialized.'),
 '5921': ('ERROR_CLUSTER_PARTIAL_READ',
          'An error occurred while reading from a stream of data. An unexpected number of bytes was returned.'),
 '5922': ('ERROR_CLUSTER_PARTIAL_WRITE',
          'An error occurred while writing to a stream of data. The required number of bytes could not be written.'),
 '5923': ('ERROR_CLUSTER_CANT_DESERIALIZE_DATA',
          'An error occurred while deserializing a stream of cluster data.'),
 '5924': ('ERROR_DEPENDENT_RESOURCE_PROPERTY_CONFLICT',
          'One or more property values for this resource are in conflict with one or more property values associated with its dependent resource(s).'),
 '5925': ('ERROR_CLUSTER_NO_QUORUM',
          'An quorum of cluster nodes was not present to form a cluster.'),
 '5926': ('ERROR_CLUSTER_INVALID_IPV6_NETWORK',
          'The cluster network is not valid for an IPv6 Address resource, or it does not match the configured address.'),
 '5927': ('ERROR_CLUSTER_INVALID_IPV6_TUNNEL_NETWORK',
          'The cluster network is not valid for an IPv6 Tunnel resource. Check the configuration of the IP Address resource on which the IPv6 Tunnel resource depends.'),
 '5928': ('ERROR_QUORUM_NOT_ALLOWED_IN_THIS_GROUP',
          'Quorum resource cannot reside in the Available Storage group.'),
 '5929': ('ERROR_DEPENDENCY_TREE_TOO_COMPLEX',
          'The dependencies for this resource are nested too deeply.'),
 '593': ('ERROR_VDM_HARD_ERROR', 'NTVDM encountered a hard error.'),
 '5930': ('ERROR_EXCEPTION_IN_RESOURCE_CALL',
          'The call into the resource DLL raised an unhandled exception.'),
 '5931': ('ERROR_CLUSTER_RHS_FAILED_INITIALIZATION',
          'The RHS process failed to initialize.'),
 '5932': ('ERROR_CLUSTER_NOT_INSTALLED',
          'The Failover Clustering feature is not installed on this node.'),
 '5933': ('ERROR_CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE',
          'The resources must be online on the same node for this operation.'),
 '5934': ('ERROR_CLUSTER_MAX_NODES_IN_CLUSTER',
          'A new node cannot be added since this cluster is already at its maximum number of nodes.'),
 '5935': ('ERROR_CLUSTER_TOO_MANY_NODES',
          'This cluster cannot be created since the specified number of nodes exceeds the maximum allowed limit.'),
 '5936': ('ERROR_CLUSTER_OBJECT_ALREADY_USED',
          'An attempt to use the specified cluster name failed because an enabled computer object with the given name already exists in the domain.'),
 '5937': ('ERROR_NONCORE_GROUPS_FOUND',
          'This cluster cannot be destroyed. It has non-core application groups which must be deleted before the cluster can be destroyed.'),
 '5938': ('ERROR_FILE_SHARE_RESOURCE_CONFLICT',
          'File share associated with file share witness resource cannot be hosted by this cluster or any of its nodes.'),
 '5939': ('ERROR_CLUSTER_EVICT_INVALID_REQUEST',
          'The last node in the cluster cannot evicted, the cluster can only be destroyed.'),
 '594': ('ERROR_DRIVER_CANCEL_TIMEOUT',
         '{Cancel Timeout} The driver %hs failed to complete a canceled I/O request in the allotted time.'),
 '5940': ('ERROR_CLUSTER_SINGLETON_RESOURCE',
          'Only one instance of this resource type is allowed in the cluster.'),
 '5941': ('ERROR_CLUSTER_GROUP_SINGLETON_RESOURCE',
          'Only one instance of this resource type is allowed per resource group.'),
 '5942': ('ERROR_CLUSTER_RESOURCE_PROVIDER_FAILED',
          'The resource failed to come online due to the failure of one or more provider resources.'),
 '595': ('ERROR_REPLY_MESSAGE_MISMATCH',
         '{Reply Message Mismatch} An attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message.'),
 '596': ('ERROR_LOST_WRITEBEHIND_DATA',
         '{Delayed Write Failed} Windows was unable to save all the data for the file %hs. The data has been lost. This error may be caused by a failure of your computer hardware or network connection. Please try to save this file elsewhere.'),
 '597': ('ERROR_CLIENT_SERVER_PARAMETERS_INVALID',
         'The parameter(s) passed to the server in the client/server shared memory window were invalid. Too much data may have been put in the shared memory window.'),
 '598': ('ERROR_NOT_TINY_STREAM', 'The stream is not a tiny stream.'),
 '599': ('ERROR_STACK_OVERFLOW_READ',
         'The request must be handled by the stack overflow code.'),
 '6': ('ERROR_INVALID_HANDLE', 'The handle is invalid.'),
 '60': ('ERROR_BAD_REM_ADAP', 'The remote adapter is not compatible.'),
 '600': ('ERROR_CONVERT_TO_LARGE',
         'Internal OFS status codes indicating how an allocation operation is handled. Either it is retried after the containing onode is moved or the extent stream is converted to a large stream.'),
 '6000': ('ERROR_ENCRYPTION_FAILED',
          'The specified file could not be encrypted.'),
 '6001': ('ERROR_DECRYPTION_FAILED',
          'The specified file could not be decrypted.'),
 '6002': ('ERROR_FILE_ENCRYPTED',
          'The specified file is encrypted and the user does not have the ability to decrypt it.'),
 '6003': ('ERROR_NO_RECOVERY_POLICY',
          'There is no valid encryption recovery policy configured for this system.'),
 '6004': ('ERROR_NO_EFS',
          'The required encryption driver is not loaded for this system.'),
 '6005': ('ERROR_WRONG_EFS',
          'The file was encrypted with a different encryption driver than is currently loaded.'),
 '6006': ('ERROR_NO_USER_KEYS', 'There are no EFS keys defined for the user.'),
 '6007': ('ERROR_FILE_NOT_ENCRYPTED', 'The specified file is not encrypted.'),
 '6008': ('ERROR_NOT_EXPORT_FORMAT',
          'The specified file is not in the defined EFS export format.'),
 '6009': ('ERROR_FILE_READ_ONLY', 'The specified file is read only.'),
 '601': ('ERROR_FOUND_OUT_OF_SCOPE',
         'The attempt to find the object found an object matching by ID on the volume but it is out of the scope of the handle used for the operation.'),
 '6010': ('ERROR_DIR_EFS_DISALLOWED',
          'The directory has been disabled for encryption.'),
 '6011': ('ERROR_EFS_SERVER_NOT_TRUSTED',
          'The server is not trusted for remote encryption operation.'),
 '6012': ('ERROR_BAD_RECOVERY_POLICY',
          'Recovery policy configured for this system contains invalid recovery certificate.'),
 '6013': ('ERROR_EFS_ALG_BLOB_TOO_BIG',
          'The encryption algorithm used on the source file needs a bigger key buffer than the one on the destination file.'),
 '6014': ('ERROR_VOLUME_NOT_SUPPORT_EFS',
          'The disk partition does not support file encryption.'),
 '6015': ('ERROR_EFS_DISABLED',
          'This machine is disabled for file encryption.'),
 '6016': ('ERROR_EFS_VERSION_NOT_SUPPORT',
          'A newer system is required to decrypt this encrypted file.'),
 '6017': ('ERROR_CS_ENCRYPTION_INVALID_SERVER_RESPONSE',
          'The remote server sent an invalid response for a file being opened with Client Side Encryption.'),
 '6018': ('ERROR_CS_ENCRYPTION_UNSUPPORTED_SERVER',
          'Client Side Encryption is not supported by the remote server even though it claims to support it.'),
 '6019': ('ERROR_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE',
          'File is encrypted and should be opened in Client Side Encryption mode.'),
 '602': ('ERROR_ALLOCATE_BUCKET',
         'The bucket array must be grown. Retry transaction after doing so.'),
 '6020': ('ERROR_CS_ENCRYPTION_NEW_ENCRYPTED_FILE',
          'A new encrypted file is being created and a $EFS needs to be provided.'),
 '6021': ('ERROR_CS_ENCRYPTION_FILE_NOT_CSE',
          'The SMB client requested a CSE FSCTL on a non-CSE file.'),
 '603': ('ERROR_MARSHALL_OVERFLOW',
         'The user/kernel marshalling buffer has overflowed.'),
 '604': ('ERROR_INVALID_VARIANT',
         'The supplied variant structure contains invalid data.'),
 '605': ('ERROR_BAD_COMPRESSION_BUFFER',
         'The specified buffer contains ill-formed data.'),
 '606': ('ERROR_AUDIT_FAILED',
         '{Audit Failed} An attempt to generate a security audit failed.'),
 '607': ('ERROR_TIMER_RESOLUTION_NOT_SET',
         'The timer resolution was not previously set by the current process.'),
 '608': ('ERROR_INSUFFICIENT_LOGON_INFO',
         'There is insufficient account information to log you on.'),
 '609': ('ERROR_BAD_DLL_ENTRYPOINT',
         '{Invalid DLL Entrypoint} The dynamic link library %hs is not written correctly. The stack pointer has been left in an inconsistent state. The entrypoint should be declared as WINAPI or STDCALL. Select YES to fail the DLL load. Select NO to continue execution. Selecting NO may cause the application to operate incorrectly.'),
 '61': ('ERROR_PRINTQ_FULL', 'The printer queue is full.'),
 '610': ('ERROR_BAD_SERVICE_ENTRYPOINT',
         '{Invalid Service Callback Entrypoint} The %hs service is not written correctly. The stack pointer has been left in an inconsistent state. The callback entrypoint should be declared as WINAPI or STDCALL. Selecting OK will cause the service to continue operation. However, the service process may operate incorrectly.'),
 '611': ('ERROR_IP_ADDRESS_CONFLICT1',
         'There is an IP address conflict with another system on the network'),
 '6118': ('ERROR_NO_BROWSER_SERVERS_FOUND',
          'The list of servers for this workgroup is not currently available'),
 '612': ('ERROR_IP_ADDRESS_CONFLICT2',
         'There is an IP address conflict with another system on the network'),
 '613': ('ERROR_REGISTRY_QUOTA_LIMIT',
         '{Low On Registry Space} The system has reached the maximum size allowed for the system part of the registry. Additional storage requests will be ignored.'),
 '614': ('ERROR_NO_CALLBACK_ACTIVE',
         'A callback return system service cannot be executed when no callback is active.'),
 '615': ('ERROR_PWD_TOO_SHORT',
         'The password provided is too short to meet the policy of your user account. Please choose a longer password.'),
 '616': ('ERROR_PWD_TOO_RECENT',
         'The policy of your user account does not allow you to change passwords too frequently. This is done to prevent users from changing back to a familiar, but potentially discovered, password. If you feel your password has been compromised then please contact your administrator immediately to have a new one assigned.'),
 '617': ('ERROR_PWD_HISTORY_CONFLICT',
         'You have attempted to change your password to one that you have used in the past. The policy of your user account does not allow this. Please select a password that you have not previously used.'),
 '618': ('ERROR_UNSUPPORTED_COMPRESSION',
         'The specified compression format is unsupported.'),
 '619': ('ERROR_INVALID_HW_PROFILE',
         'The specified hardware profile configuration is invalid.'),
 '62': ('ERROR_NO_SPOOL_SPACE',
        'Space to store the file waiting to be printed is not available on the server.'),
 '620': ('ERROR_INVALID_PLUGPLAY_DEVICE_PATH',
         'The specified Plug and Play registry device path is invalid.'),
 '6200': ('SCHED_E_SERVICE_NOT_LOCALSYSTEM',
          'The Task Scheduler service must be configured to run in the System account to function properly. Individual tasks may be configured to run in other accounts.'),
 '621': ('ERROR_QUOTA_LIST_INCONSISTENT',
         'The specified quota list is internally inconsistent with its descriptor.'),
 '622': ('ERROR_EVALUATION_EXPIRATION',
         '{Windows Evaluation Notification} The evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour. To restore access to this installation of Windows, please upgrade this installation using a licensed distribution of this product.'),
 '623': ('ERROR_ILLEGAL_DLL_RELOCATION',
         '{Illegal System DLL Relocation} The system DLL %hs was relocated in memory. The application will not run properly. The relocation occurred because the DLL %hs occupied an address range reserved for Windows system DLLs. The vendor supplying the DLL should be contacted for a new DLL.'),
 '624': ('ERROR_DLL_INIT_FAILED_LOGOFF',
         '{DLL Initialization Failed} The application failed to initialize because the window station is shutting down.'),
 '625': ('ERROR_VALIDATE_CONTINUE',
         'The validation process needs to continue on to the next step.'),
 '626': ('ERROR_NO_MORE_MATCHES',
         'There are no more matches for the current index enumeration.'),
 '627': ('ERROR_RANGE_LIST_CONFLICT',
         'The range could not be added to the range list because of a conflict.'),
 '628': ('ERROR_SERVER_SID_MISMATCH',
         'The server process is running under a SID different than that required by client.'),
 '629': ('ERROR_CANT_ENABLE_DENY_ONLY',
         'A group marked use for deny only cannot be enabled.'),
 '63': ('ERROR_PRINT_CANCELLED',
        'Your file waiting to be printed was deleted.'),
 '630': ('ERROR_FLOAT_MULTIPLE_FAULTS',
         '{EXCEPTION} Multiple floating point faults.'),
 '631': ('ERROR_FLOAT_MULTIPLE_TRAPS',
         '{EXCEPTION} Multiple floating point traps.'),
 '632': ('ERROR_NOINTERFACE', 'The requested interface is not supported.'),
 '633': ('ERROR_DRIVER_FAILED_SLEEP',
         '{System Standby Failed} The driver %hs does not support standby mode. Updating this driver may allow the system to go to standby mode.'),
 '634': ('ERROR_CORRUPT_SYSTEM_FILE',
         'The system file %1 has become corrupt and has been replaced.'),
 '635': ('ERROR_COMMITMENT_MINIMUM',
         '{Virtual Memory Minimum Too Low} Your system is low on virtual memory. Windows is increasing the size of your virtual memory paging file. During this process, memory requests for some applications may be denied. For more information, see Help.'),
 '636': ('ERROR_PNP_RESTART_ENUMERATION',
         'A device was removed so enumeration must be restarted.'),
 '637': ('ERROR_SYSTEM_IMAGE_BAD_SIGNATURE',
         '{Fatal System Error} The system image %s is not properly signed. The file has been replaced with the signed file. The system has been shut down.'),
 '638': ('ERROR_PNP_REBOOT_REQUIRED',
         'Device will not start without a reboot.'),
 '639': ('ERROR_INSUFFICIENT_POWER',
         'There is not enough power to complete the requested operation.'),
 '64': ('ERROR_NETNAME_DELETED',
        'The specified network name is no longer available.'),
 '640': ('ERROR_MULTIPLE_FAULT_VIOLATION', 'ERROR_MULTIPLE_FAULT_VIOLATION'),
 '641': ('ERROR_SYSTEM_SHUTDOWN',
         'The system is in the process of shutting down.'),
 '642': ('ERROR_PORT_NOT_SET',
         'An attempt to remove a processes DebugPort was made, but a port was not already associated with the process.'),
 '643': ('ERROR_DS_VERSION_CHECK_FAILURE',
         'This version of Windows is not compatible with the behavior version of directory forest, domain or domain controller.'),
 '644': ('ERROR_RANGE_NOT_FOUND',
         'The specified range could not be found in the range list.'),
 '646': ('ERROR_NOT_SAFE_MODE_DRIVER',
         'The driver was not loaded because the system is booting into safe mode.'),
 '647': ('ERROR_FAILED_DRIVER_ENTRY',
         "The driver was not loaded because it failed it's initialization call."),
 '648': ('ERROR_DEVICE_ENUMERATION_ERROR',
         'The "%hs" encountered an error while applying power or reading the device configuration. This may be caused by a failure of your hardware or by a poor connection.'),
 '649': ('ERROR_MOUNT_POINT_NOT_RESOLVED',
         'The create operation failed because the name contained at least one mount point which resolves to a volume to which the specified device object is not attached.'),
 '65': ('ERROR_NETWORK_ACCESS_DENIED', 'Network access is denied.'),
 '650': ('ERROR_INVALID_DEVICE_OBJECT_PARAMETER',
         'The device object parameter is either not a valid device object or is not attached to the volume specified by the file name.'),
 '651': ('ERROR_MCA_OCCURED',
         'A Machine Check Error has occurred. Please check the system eventlog for additional information.'),
 '652': ('ERROR_DRIVER_DATABASE_ERROR',
         'There was error [%2] processing the driver database.'),
 '653': ('ERROR_SYSTEM_HIVE_TOO_LARGE',
         'System hive size has exceeded its limit.'),
 '654': ('ERROR_DRIVER_FAILED_PRIOR_UNLOAD',
         'The driver could not be loaded because a previous version of the driver is still in memory.'),
 '655': ('ERROR_VOLSNAP_PREPARE_HIBERNATE',
         '{Volume Shadow Copy Service} Please wait while the Volume Shadow Copy Service prepares volume %hs for hibernation.'),
 '656': ('ERROR_HIBERNATION_FAILURE',
         'The system has failed to hibernate (The error code is %hs). Hibernation will be disabled until the system is restarted.'),
 '66': ('ERROR_BAD_DEV_TYPE', 'The network resource type is not correct.'),
 '6600': ('ERROR_LOG_SECTOR_INVALID',
          'Log service encountered an invalid log sector.'),
 '6601': ('ERROR_LOG_SECTOR_PARITY_INVALID',
          'Log service encountered a log sector with invalid block parity.'),
 '6602': ('ERROR_LOG_SECTOR_REMAPPED',
          'Log service encountered a remapped log sector.'),
 '6603': ('ERROR_LOG_BLOCK_INCOMPLETE',
          'Log service encountered a partial or incomplete log block.'),
 '6604': ('ERROR_LOG_INVALID_RANGE',
          'Log service encountered an attempt access data outside the active log range.'),
 '6605': ('ERROR_LOG_BLOCKS_EXHAUSTED',
          'Log service user marshalling buffers are exhausted.'),
 '6606': ('ERROR_LOG_READ_CONTEXT_INVALID',
          'Log service encountered an attempt read from a marshalling area with an invalid read context.'),
 '6607': ('ERROR_LOG_RESTART_INVALID',
          'Log service encountered an invalid log restart area.'),
 '6608': ('ERROR_LOG_BLOCK_VERSION',
          'Log service encountered an invalid log block version.'),
 '6609': ('ERROR_LOG_BLOCK_INVALID',
          'Log service encountered an invalid log block.'),
 '6610': ('ERROR_LOG_READ_MODE_INVALID',
          'Log service encountered an attempt to read the log with an invalid read mode.'),
 '6611': ('ERROR_LOG_NO_RESTART',
          'Log service encountered a log stream with no restart area.'),
 '6612': ('ERROR_LOG_METADATA_CORRUPT',
          'Log service encountered a corrupted metadata file.'),
 '6613': ('ERROR_LOG_METADATA_INVALID',
          'Log service encountered a metadata file that could not be created by the log file system.'),
 '6614': ('ERROR_LOG_METADATA_INCONSISTENT',
          'Log service encountered a metadata file with inconsistent data.'),
 '6615': ('ERROR_LOG_RESERVATION_INVALID',
          'Log service encountered an attempt to erroneous allocate or dispose reservation space.'),
 '6616': ('ERROR_LOG_CANT_DELETE',
          'Log service cannot delete log file or file system container.'),
 '6617': ('ERROR_LOG_CONTAINER_LIMIT_EXCEEDED',
          'Log service has reached the maximum allowable containers allocated to a log file.'),
 '6618': ('ERROR_LOG_START_OF_LOG',
          'Log service has attempted to read or write backward past the start of the log.'),
 '6619': ('ERROR_LOG_POLICY_ALREADY_INSTALLED',
          'Log policy could not be installed because a policy of the same type is already present.'),
 '6620': ('ERROR_LOG_POLICY_NOT_INSTALLED',
          'Log policy in question was not installed at the time of the request.'),
 '6621': ('ERROR_LOG_POLICY_INVALID',
          'The installed set of policies on the log is invalid.'),
 '6622': ('ERROR_LOG_POLICY_CONFLICT',
          'A policy on the log in question prevented the operation from completing.'),
 '6623': ('ERROR_LOG_PINNED_ARCHIVE_TAIL',
          'Log space cannot be reclaimed because the log is pinned by the archive tail.'),
 '6624': ('ERROR_LOG_RECORD_NONEXISTENT',
          'Log record is not a record in the log file.'),
 '6625': ('ERROR_LOG_RECORDS_RESERVED_INVALID',
          'The number of reserved log records or the adjustment of the number of reserved log records is invalid.'),
 '6626': ('ERROR_LOG_SPACE_RESERVED_INVALID',
          'Reserved log space or the adjustment of the log space is invalid.'),
 '6627': ('ERROR_LOG_TAIL_INVALID',
          'An new or existing archive tail or base of the active log is invalid.'),
 '6628': ('ERROR_LOG_FULL', 'Log space is exhausted.'),
 '6629': ('ERROR_COULD_NOT_RESIZE_LOG',
          'The log could not be set to the requested size.'),
 '6630': ('ERROR_LOG_MULTIPLEXED',
          'Log is multiplexed, no direct writes to the physical log is allowed.'),
 '6631': ('ERROR_LOG_DEDICATED',
          'The operation failed because the log is a dedicated log.'),
 '6632': ('ERROR_LOG_ARCHIVE_NOT_IN_PROGRESS',
          'The operation requires an archive context.'),
 '6633': ('ERROR_LOG_ARCHIVE_IN_PROGRESS', 'Log archival is in progress.'),
 '6634': ('ERROR_LOG_EPHEMERAL',
          'The operation requires a non-ephemeral log, but the log is ephemeral.'),
 '6635': ('ERROR_LOG_NOT_ENOUGH_CONTAINERS',
          'The log must have at least two containers before it can be read from or written to.'),
 '6636': ('ERROR_LOG_CLIENT_ALREADY_REGISTERED',
          'A log client has already registered on the stream.'),
 '6637': ('ERROR_LOG_CLIENT_NOT_REGISTERED',
          'A log client has not been registered on the stream.'),
 '6638': ('ERROR_LOG_FULL_HANDLER_IN_PROGRESS',
          'A request has already been made to handle the log full condition.'),
 '6639': ('ERROR_LOG_CONTAINER_READ_FAILED',
          'Log service encountered an error when attempting to read from a log container.'),
 '6640': ('ERROR_LOG_CONTAINER_WRITE_FAILED',
          'Log service enountered an error when attempting to write to a log container.'),
 '6641': ('ERROR_LOG_CONTAINER_OPEN_FAILED',
          'Log service enountered an error when attempting open a log container.'),
 '6642': ('ERROR_LOG_CONTAINER_STATE_INVALID',
          'Log service enountered an invalid container state when attempting a requested action.'),
 '6643': ('ERROR_LOG_STATE_INVALID',
          'Log service is not in the correct state to perform a requested action.'),
 '6644': ('ERROR_LOG_PINNED',
          'Log space cannot be reclaimed because the log is pinned.'),
 '6645': ('ERROR_LOG_METADATA_FLUSH_FAILED', 'Log metadata flush failed.'),
 '6646': ('ERROR_LOG_INCONSISTENT_SECURITY',
          'Security on the log and its containers is inconsistent.'),
 '6647': ('ERROR_LOG_APPENDED_FLUSH_FAILED',
          'Records were appended to the log or reservation changes were made, but the log could not be flushed.'),
 '6648': ('ERROR_LOG_PINNED_RESERVATION',
          'The log is pinned due to reservation consuming most of the log space. Free some reserved records to make space available.'),
 '665': ('ERROR_FILE_SYSTEM_LIMITATION',
         'The requested operation could not be completed due to a file system limitation'),
 '668': ('ERROR_ASSERTION_FAILURE', 'An assertion failure has occurred.'),
 '669': ('ERROR_ACPI_ERROR', 'An error occurred in the ACPI subsystem.'),
 '67': ('ERROR_BAD_NET_NAME', 'The network name cannot be found.'),
 '670': ('ERROR_WOW_ASSERTION', 'WOW Assertion Error.'),
 '6700': ('ERROR_INVALID_TRANSACTION',
          'The transaction handle associated with this operation is not valid.'),
 '6701': ('ERROR_TRANSACTION_NOT_ACTIVE',
          'The requested operation was made in the context of a transaction that is no longer active.'),
 '6702': ('ERROR_TRANSACTION_REQUEST_NOT_VALID',
          'The requested operation is not valid on the Transaction object in its current state.'),
 '6703': ('ERROR_TRANSACTION_NOT_REQUESTED',
          'The caller has called a response API, but the response is not expected because the TM did not issue the corresponding request to the caller.'),
 '6704': ('ERROR_TRANSACTION_ALREADY_ABORTED',
          'It is too late to perform the requested operation, since the Transaction has already been aborted.'),
 '6705': ('ERROR_TRANSACTION_ALREADY_COMMITTED',
          'It is too late to perform the requested operation, since the Transaction has already been committed.'),
 '6706': ('ERROR_TM_INITIALIZATION_FAILED',
          'The Transaction Manager was unable to be successfully initialized. Transacted operations are not supported.'),
 '6707': ('ERROR_RESOURCEMANAGER_READ_ONLY',
          'The specified ResourceManager made no changes or updates to the resource under this transaction.'),
 '6708': ('ERROR_TRANSACTION_NOT_JOINED',
          'The resource manager has attempted to prepare a transaction that it has not successfully joined.'),
 '6709': ('ERROR_TRANSACTION_SUPERIOR_EXISTS',
          'The Transaction object already has a superior enlistment, and the caller attempted an operation that would have created a new superior. Only a single superior enlistment is allow.'),
 '671': ('ERROR_PNP_BAD_MPS_TABLE',
         'A device is missing in the system BIOS MPS table. This device will not be used. Please contact your system vendor for system BIOS update.'),
 '6710': ('ERROR_CRM_PROTOCOL_ALREADY_EXISTS',
          'The RM tried to register a protocol that already exists.'),
 '6711': ('ERROR_TRANSACTION_PROPAGATION_FAILED',
          'The attempt to propagate the Transaction failed.'),
 '6712': ('ERROR_CRM_PROTOCOL_NOT_FOUND',
          'The requested propagation protocol was not registered as a CRM.'),
 '6713': ('ERROR_TRANSACTION_INVALID_MARSHALL_BUFFER',
          'The buffer passed in to PushTransaction or PullTransaction is not in a valid format.'),
 '6714': ('ERROR_CURRENT_TRANSACTION_NOT_VALID',
          'The current transaction context associated with the thread is not a valid handle to a transaction object.'),
 '6715': ('ERROR_TRANSACTION_NOT_FOUND',
          'The specified Transaction object could not be opened, because it was not found.'),
 '6716': ('ERROR_RESOURCEMANAGER_NOT_FOUND',
          'The specified ResourceManager object could not be opened, because it was not found.'),
 '6717': ('ERROR_ENLISTMENT_NOT_FOUND',
          'The specified Enlistment object could not be opened, because it was not found.'),
 '6718': ('ERROR_TRANSACTIONMANAGER_NOT_FOUND',
          'The specified TransactionManager object could not be opened, because it was not found.'),
 '6719': ('ERROR_TRANSACTIONMANAGER_NOT_ONLINE',
          'The specified ResourceManager was unable to create an enlistment, because its associated TransactionManager is not online.'),
 '672': ('ERROR_PNP_TRANSLATION_FAILED',
         'A translator failed to translate resources.'),
 '6720': ('ERROR_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION',
          'The specified TransactionManager was unable to create the objects contained in its logfile in the Ob namespace. Therefore, the TransactionManager was unable to recover.'),
 '6721': ('ERROR_TRANSACTION_NOT_ROOT',
          'The call to create a superior Enlistment on this Transaction object could not be completed, because the Transaction object specified for the enlistment is a subordinate branch of the Transaction. Only the root of the Transaction can be enlisted on as a superior.'),
 '6722': ('ERROR_TRANSACTION_OBJECT_EXPIRED',
          'Because the associated transaction manager or resource manager has been closed, the handle is no longer valid.'),
 '6723': ('ERROR_TRANSACTION_RESPONSE_NOT_ENLISTED',
          'The specified operation could not be performed on this Superior enlistment, because the enlistment was not created with the corresponding completion response in the NotificationMask.'),
 '6724': ('ERROR_TRANSACTION_RECORD_TOO_LONG',
          'The specified operation could not be performed, because the record that would be logged was too long. This can occur because of two conditions: either there are too many Enlistments on this Transaction, or the combined RecoveryInformation being logged on behalf of those Enlistments is too long.'),
 '6725': ('ERROR_IMPLICIT_TRANSACTION_NOT_SUPPORTED',
          'Implicit transactions are not supported.'),
 '6726': ('ERROR_TRANSACTION_INTEGRITY_VIOLATED',
          'The kernel transaction manager had to abort or forget the transaction because it blocked forward progress.'),
 '673': ('ERROR_PNP_IRQ_TRANSLATION_FAILED',
         'A IRQ translator failed to translate resources.'),
 '674': ('ERROR_PNP_INVALID_ID',
         'Driver %2 returned invalid ID for a child device (%3).'),
 '675': ('ERROR_WAKE_SYSTEM_DEBUGGER',
         '{Kernel Debugger Awakened} the system debugger was awakened by an interrupt.'),
 '676': ('ERROR_HANDLES_CLOSED',
         '{Handles Closed} Handles to objects have been automatically closed as a result of the requested operation.'),
 '677': ('ERROR_EXTRANEOUS_INFORMATION',
         '{Too Much Information} The specified access control list (ACL) contained more information than was expected.'),
 '678': ('ERROR_RXACT_COMMIT_NECESSARY',
         'This warning level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted. The commit has NOT been completed, but has not been rolled back either (so it may still be committed if desired).'),
 '679': ('ERROR_MEDIA_CHECK', '{Media Changed} The media may have changed.'),
 '68': ('ERROR_TOO_MANY_NAMES',
        'The name limit for the local computer network adapter card was exceeded.'),
 '680': ('ERROR_GUID_SUBSTITUTION_MADE',
         '{GUID Substitution} During the translation of a global identifier (GUID) to a Windows security ID (SID), no administratively-defined GUID prefix was found. A substitute prefix was used, which will not compromise system security. However, this may provide a more restrictive access than intended.'),
 '6800': ('ERROR_TRANSACTIONAL_CONFLICT',
          'The function attempted to use a name that is reserved for use by another transaction.'),
 '6801': ('ERROR_RM_NOT_ACTIVE',
          'Transaction support within the specified file system resource manager is not started or was shutdown due to an error.'),
 '6802': ('ERROR_RM_METADATA_CORRUPT',
          'The metadata of the RM has been corrupted. The RM will not function.'),
 '6803': ('ERROR_DIRECTORY_NOT_RM',
          'The specified directory does not contain a resource manager.'),
 '6805': ('ERROR_TRANSACTIONS_UNSUPPORTED_REMOTE',
          'The remote server or share does not support transacted file operations.'),
 '6806': ('ERROR_LOG_RESIZE_INVALID_SIZE',
          'The requested log size is invalid.'),
 '6807': ('ERROR_OBJECT_NO_LONGER_EXISTS',
          'The object (file, stream, link) corresponding to the handle has been deleted by a Transaction Savepoint Rollback.'),
 '6808': ('ERROR_STREAM_MINIVERSION_NOT_FOUND',
          'The specified file miniversion was not found for this transacted file open.'),
 '6809': ('ERROR_STREAM_MINIVERSION_NOT_VALID',
          'The specified file miniversion was found but has been invalidated. Most likely cause is a transaction savepoint rollback.'),
 '681': ('ERROR_STOPPED_ON_SYMLINK',
         'The create operation stopped after reaching a symbolic link'),
 '6810': ('ERROR_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION',
          'A miniversion may only be opened in the context of the transaction that created it.'),
 '6811': ('ERROR_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT',
          'It is not possible to open a miniversion with modify access.'),
 '6812': ('ERROR_CANT_CREATE_MORE_STREAM_MINIVERSIONS',
          'It is not possible to create any more miniversions for this stream.'),
 '6814': ('ERROR_REMOTE_FILE_VERSION_MISMATCH',
          'The remote server sent mismatching version number or Fid for a file opened with transactions.'),
 '6815': ('ERROR_HANDLE_NO_LONGER_VALID',
          'The handle has been invalidated by a transaction. The most likely cause is the presence of memory mapping on a file or an open handle when the transaction ended or rolled back to savepoint.'),
 '6816': ('ERROR_NO_TXF_METADATA',
          'There is no transaction metadata on the file.'),
 '6817': ('ERROR_LOG_CORRUPTION_DETECTED', 'The log data is corrupt.'),
 '6818': ('ERROR_CANT_RECOVER_WITH_HANDLE_OPEN',
          "The file can't be recovered because there is a handle still open on it."),
 '6819': ('ERROR_RM_DISCONNECTED',
          'The transaction outcome is unavailable because the resource manager responsible for it has disconnected.'),
 '682': ('ERROR_LONGJUMP', 'A long jump has been executed.'),
 '6820': ('ERROR_ENLISTMENT_NOT_SUPERIOR',
          'The request was rejected because the enlistment in question is not a superior enlistment.'),
 '6821': ('ERROR_RECOVERY_NOT_NEEDED',
          'The transactional resource manager is already consistent. Recovery is not needed.'),
 '6822': ('ERROR_RM_ALREADY_STARTED',
          'The transactional resource manager has already been started.'),
 '6823': ('ERROR_FILE_IDENTITY_NOT_PERSISTENT',
          'The file cannot be opened transactionally, because its identity depends on the outcome of an unresolved transaction.'),
 '6824': ('ERROR_CANT_BREAK_TRANSACTIONAL_DEPENDENCY',
          'The operation cannot be performed because another transaction is depending on the fact that this property will not change.'),
 '6825': ('ERROR_CANT_CROSS_RM_BOUNDARY',
          'The operation would involve a single file with two transactional resource managers and is therefore not allowed.'),
 '6826': ('ERROR_TXF_DIR_NOT_EMPTY',
          'The $Txf directory must be empty for this operation to succeed.'),
 '6827': ('ERROR_INDOUBT_TRANSACTIONS_EXIST',
          'The operation would leave a transactional resource manager in an inconsistent state and is therefore not allowed.'),
 '6828': ('ERROR_TM_VOLATILE',
          'The operation could not be completed because the transaction manager does not have a log.'),
 '6829': ('ERROR_ROLLBACK_TIMER_EXPIRED',
          'A rollback could not be scheduled because a previously scheduled rollback has already executed or been queued for execution.'),
 '683': ('ERROR_PLUGPLAY_QUERY_VETOED',
         'The Plug and Play query operation was not successful.'),
 '6830': ('ERROR_TXF_ATTRIBUTE_CORRUPT',
          'The transactional metadata attribute on the file or directory is corrupt and unreadable.'),
 '6831': ('ERROR_EFS_NOT_ALLOWED_IN_TRANSACTION',
          'The encryption operation could not be completed because a transaction is active.'),
 '6832': ('ERROR_TRANSACTIONAL_OPEN_NOT_ALLOWED',
          'This object is not allowed to be opened in a transaction.'),
 '6833': ('ERROR_LOG_GROWTH_FAILED',
          "An attempt to create space in the transactional resource manager's log failed. The failure status has been recorded in the event log."),
 '6834': ('ERROR_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE',
          'Memory mapping (creating a mapped section) a remote file under a transaction is not supported.'),
 '6835': ('ERROR_TXF_METADATA_ALREADY_PRESENT',
          'Transaction metadata is already present on this file and cannot be superseded.'),
 '6836': ('ERROR_TRANSACTION_SCOPE_CALLBACKS_NOT_SET',
          'A transaction scope could not be entered because the scope handler has not been initialized.'),
 '6837': ('ERROR_TRANSACTION_REQUIRED_PROMOTION',
          'Promotion was required in order to allow the resource manager to enlist, but the transaction was set to disallow it.'),
 '6838': ('ERROR_CANNOT_EXECUTE_FILE_IN_TRANSACTION',
          'This file is open for modification in an unresolved transaction and may be opened for execute only by a transacted reader.'),
 '6839': ('ERROR_TRANSACTIONS_NOT_FROZEN',
          'The request to thaw frozen transactions was ignored because transactions had not previously been frozen.'),
 '684': ('ERROR_UNWIND_CONSOLIDATE',
         'A frame consolidation has been executed.'),
 '6840': ('ERROR_TRANSACTION_FREEZE_IN_PROGRESS',
          'Transactions cannot be frozen because a freeze is already in progress.'),
 '6841': ('ERROR_NOT_SNAPSHOT_VOLUME',
          'The target volume is not a snapshot volume. This operation is only valid on a volume mounted as a snapshot.'),
 '6842': ('ERROR_NO_SAVEPOINT_WITH_OPEN_FILES',
          'The savepoint operation failed because files are open on the transaction. This is not permitted.'),
 '6843': ('ERROR_DATA_LOST_REPAIR',
          'Windows has discovered corruption in a file, and that file has since been repaired. Data loss may have occurred.'),
 '6844': ('ERROR_SPARSE_NOT_ALLOWED_IN_TRANSACTION',
          'The sparse operation could not be completed because a transaction is active on the file.'),
 '6845': ('ERROR_TM_IDENTITY_MISMATCH',
          'The call to create a TransactionManager object failed because the Tm Identity stored in the logfile does not match the Tm Identity that was passed in as an argument.'),
 '6846': ('ERROR_FLOATED_SECTION',
          'I/O was attempted on a section object that has been floated as a result of a transaction ending. There is no valid data.'),
 '6847': ('ERROR_CANNOT_ACCEPT_TRANSACTED_WORK',
          'The transactional resource manager cannot currently accept transacted work due to a transient condition such as low resources.'),
 '6848': ('ERROR_CANNOT_ABORT_TRANSACTIONS',
          'The transactional resource manager had too many transactions outstanding that could not be aborted. The transactional resource manager has been shut down.'),
 '6849': ('ERROR_BAD_CLUSTERS',
          'The operation could not be completed due to bad clusters on disk.'),
 '685': ('ERROR_REGISTRY_HIVE_RECOVERED',
         '{Registry Hive Recovered} Registry hive (file): %hs was corrupted and it has been recovered. Some data might have been lost.'),
 '6850': ('ERROR_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION',
          'The compression operation could not be completed because a transaction is active on the file.'),
 '6851': ('ERROR_VOLUME_DIRTY',
          'The operation could not be completed because the volume is dirty. Please run chkdsk and try again.'),
 '6852': ('ERROR_NO_LINK_TRACKING_IN_TRANSACTION',
          'The link tracking operation could not be completed because a transaction is active.'),
 '6853': ('ERROR_OPERATION_NOT_SUPPORTED_IN_TRANSACTION',
          'This operation cannot be performed in a transaction.'),
 '686': ('ERROR_DLL_MIGHT_BE_INSECURE',
         'The application is attempting to run executable code from the module %hs. This may be insecure. An alternative, %hs, is available. Should the application use the secure module %hs?'),
 '687': ('ERROR_DLL_MIGHT_BE_INCOMPATIBLE',
         'The application is loading executable code from the module %hs. This is secure, but may be incompatible with previous releases of the operating system. An alternative, %hs, is available. Should the application use the secure module %hs?'),
 '688': ('ERROR_DBG_EXCEPTION_NOT_HANDLED',
         'Debugger did not handle the exception.'),
 '689': ('ERROR_DBG_REPLY_LATER', 'Debugger will reply later.'),
 '69': ('ERROR_TOO_MANY_SESS', 'The network BIOS session limit was exceeded.'),
 '690': ('ERROR_DBG_UNABLE_TO_PROVIDE_HANDLE',
         'Debugger cannot provide handle.'),
 '691': ('ERROR_DBG_TERMINATE_THREAD', 'Debugger terminated thread.'),
 '692': ('ERROR_DBG_TERMINATE_PROCESS', 'Debugger terminated process.'),
 '693': ('ERROR_DBG_CONTROL_C', 'Debugger got control C.'),
 '694': ('ERROR_DBG_PRINTEXCEPTION_C',
         'Debugger printed exception on control C.'),
 '695': ('ERROR_DBG_RIPEXCEPTION', 'Debugger received RIP exception.'),
 '696': ('ERROR_DBG_CONTROL_BREAK', 'Debugger received control break.'),
 '697': ('ERROR_DBG_COMMAND_EXCEPTION',
         'Debugger command communication exception.'),
 '698': ('ERROR_OBJECT_NAME_EXISTS',
         '{Object Exists} An attempt was made to create an object and the object name already existed.'),
 '699': ('ERROR_THREAD_WAS_SUSPENDED',
         '{Thread Suspended} A thread termination occurred while the thread was suspended. The thread was resumed, and termination proceeded.'),
 '7': ('ERROR_ARENA_TRASHED', 'The storage control blocks were destroyed.'),
 '70': ('ERROR_SHARING_PAUSED',
        'The remote server has been paused or is in the process of being started.'),
 '700': ('ERROR_IMAGE_NOT_AT_BASE',
         '{Image Relocated} An image file could not be mapped at the address specified in the image file. Local fixups must be performed on this image.'),
 '7001': ('ERROR_CTX_WINSTATION_NAME_INVALID',
          'The specified session name is invalid.'),
 '7002': ('ERROR_CTX_INVALID_PD', 'The specified protocol driver is invalid.'),
 '7003': ('ERROR_CTX_PD_NOT_FOUND',
          'The specified protocol driver was not found in the system path.'),
 '7004': ('ERROR_CTX_WD_NOT_FOUND',
          'The specified terminal connection driver was not found in the system path.'),
 '7005': ('ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY',
          'A registry key for event logging could not be created for this session.'),
 '7006': ('ERROR_CTX_SERVICE_NAME_COLLISION',
          'A service with the same name already exists on the system.'),
 '7007': ('ERROR_CTX_CLOSE_PENDING',
          'A close operation is pending on the session.'),
 '7008': ('ERROR_CTX_NO_OUTBUF',
          'There are no free output buffers available.'),
 '7009': ('ERROR_CTX_MODEM_INF_NOT_FOUND',
          'The MODEM.INF file was not found.'),
 '701': ('ERROR_RXACT_STATE_CREATED',
         'This informational level status indicates that a specified registry sub-tree transaction state did not yet exist and had to be created.'),
 '7010': ('ERROR_CTX_INVALID_MODEMNAME',
          'The modem name was not found in MODEM.INF.'),
 '7011': ('ERROR_CTX_MODEM_RESPONSE_ERROR',
          'The modem did not accept the command sent to it. Verify that the configured modem name matches the attached modem.'),
 '7012': ('ERROR_CTX_MODEM_RESPONSE_TIMEOUT',
          'The modem did not respond to the command sent to it. Verify that the modem is properly cabled and powered on.'),
 '7013': ('ERROR_CTX_MODEM_RESPONSE_NO_CARRIER',
          'Carrier detect has failed or carrier has been dropped due to disconnect.'),
 '7014': ('ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE',
          'Dial tone not detected within the required time. Verify that the phone cable is properly attached and functional.'),
 '7015': ('ERROR_CTX_MODEM_RESPONSE_BUSY',
          'Busy signal detected at remote site on callback.'),
 '7016': ('ERROR_CTX_MODEM_RESPONSE_VOICE',
          'Voice detected at remote site on callback.'),
 '7017': ('ERROR_CTX_TD_ERROR', 'Transport driver error'),
 '702': ('ERROR_SEGMENT_NOTIFICATION',
         '{Segment Load} A virtual DOS machine (VDM) is loading, unloading, or moving an MS-DOS or Win16 program segment image. An exception is raised so a debugger can load, unload or track symbols and breakpoints within these 16-bit segments.'),
 '7022': ('ERROR_CTX_WINSTATION_NOT_FOUND',
          'The specified session cannot be found.'),
 '7023': ('ERROR_CTX_WINSTATION_ALREADY_EXISTS',
          'The specified session name is already in use.'),
 '7024': ('ERROR_CTX_WINSTATION_BUSY',
          'The requested operation cannot be completed because the terminal connection is currently busy processing a connect, disconnect, reset, or delete operation.'),
 '7025': ('ERROR_CTX_BAD_VIDEO_MODE',
          'An attempt has been made to connect to a session whose video mode is not supported by the current client.'),
 '703': ('ERROR_BAD_CURRENT_DIRECTORY',
         '{Invalid Current Directory} The process cannot switch to the startup current directory %hs. Select OK to set current directory to %hs, or select CANCEL to exit.'),
 '7035': ('ERROR_CTX_GRAPHICS_INVALID',
          'The application attempted to enable DOS graphics mode. DOS graphics mode is not supported.'),
 '7037': ('ERROR_CTX_LOGON_DISABLED',
          'Your interactive logon privilege has been disabled. Please contact your administrator.'),
 '7038': ('ERROR_CTX_NOT_CONSOLE',
          'The requested operation can be performed only on the system console. This is most often the result of a driver or system DLL requiring direct console access.'),
 '704': ('ERROR_FT_READ_RECOVERY_FROM_BACKUP',
         '{Redundant Read} To satisfy a read request, the NT fault-tolerant file system successfully read the requested data from a redundant copy. This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was unable to reassign the failing area of the device.'),
 '7040': ('ERROR_CTX_CLIENT_QUERY_TIMEOUT',
          'The client failed to respond to the server connect message.'),
 '7041': ('ERROR_CTX_CONSOLE_DISCONNECT',
          'Disconnecting the console session is not supported.'),
 '7042': ('ERROR_CTX_CONSOLE_CONNECT',
          'Reconnecting a disconnected session to the console is not supported.'),
 '7044': ('ERROR_CTX_SHADOW_DENIED',
          'The request to control another session remotely was denied.'),
 '7045': ('ERROR_CTX_WINSTATION_ACCESS_DENIED',
          'The requested session access is denied.'),
 '7049': ('ERROR_CTX_INVALID_WD',
          'The specified terminal connection driver is invalid.'),
 '705': ('ERROR_FT_WRITE_RECOVERY',
         '{Redundant Write} To satisfy a write request, the NT fault-tolerant file system successfully wrote a redundant copy of the information. This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was not able to reassign the failing area of the device.'),
 '7050': ('ERROR_CTX_SHADOW_INVALID',
          'The requested session cannot be controlled remotely. This may be because the session is disconnected or does not currently have a user logged on.'),
 '7051': ('ERROR_CTX_SHADOW_DISABLED',
          'The requested session is not configured to allow remote control.'),
 '7052': ('ERROR_CTX_CLIENT_LICENSE_IN_USE',
          'Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number is currently being used by another user. Please call your system administrator to obtain a unique license number.'),
 '7053': ('ERROR_CTX_CLIENT_LICENSE_NOT_SET',
          'Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number has not been entered for this copy of the Terminal Server client. Please contact your system administrator.'),
 '7054': ('ERROR_CTX_LICENSE_NOT_AVAILABLE',
          'The number of connections to this computer is limited and all connections are in use right now. Try connecting later or contact your system administrator.'),
 '7055': ('ERROR_CTX_LICENSE_CLIENT_INVALID',
          'The client you are using is not licensed to use this system. Your logon request is denied.'),
 '7056': ('ERROR_CTX_LICENSE_EXPIRED',
          'The system license has expired. Your logon request is denied.'),
 '7057': ('ERROR_CTX_SHADOW_NOT_RUNNING',
          'Remote control could not be terminated because the specified session is not currently being remotely controlled.'),
 '7058': ('ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE',
          'The remote control of the console was terminated because the display mode was changed. Changing the display mode in a remote control session is not supported.'),
 '7059': ('ERROR_ACTIVATION_COUNT_EXCEEDED',
          'Activation has already been reset the maximum number of times for this installation. Your activation timer will not be cleared.'),
 '706': ('ERROR_IMAGE_MACHINE_TYPE_MISMATCH',
         '{Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine. Select OK to continue, or CANCEL to fail the DLL load.'),
 '7060': ('ERROR_CTX_WINSTATIONS_DISABLED',
          'Remote logins are currently disabled.'),
 '7061': ('ERROR_CTX_ENCRYPTION_LEVEL_REQUIRED',
          'You do not have the proper encryption level to access this Session.'),
 '7062': ('ERROR_CTX_SESSION_IN_USE',
          'The user %s\\\\%s is currently logged on to this computer. Only the current user or an administrator can log on to this computer.'),
 '7063': ('ERROR_CTX_NO_FORCE_LOGOFF',
          'The user %s\\\\%s is already logged on to the console of this computer. You do not have permission to log in at this time. To resolve this issue, contact %s\\\\%s and have them log off.'),
 '7064': ('ERROR_CTX_ACCOUNT_RESTRICTION',
          'Unable to log you on because of an account restriction.'),
 '7065': ('ERROR_RDP_PROTOCOL_ERROR',
          'The RDP protocol component %2 detected an error in the protocol stream and has disconnected the client.'),
 '7066': ('ERROR_CTX_CDM_CONNECT',
          'The Client Drive Mapping Service Has Connected on Terminal Connection.'),
 '7067': ('ERROR_CTX_CDM_DISCONNECT',
          'The Client Drive Mapping Service Has Disconnected on Terminal Connection.'),
 '7068': ('ERROR_CTX_SECURITY_LAYER_ERROR',
          'The Terminal Server security layer detected an error in the protocol stream and has disconnected the client.'),
 '7069': ('ERROR_TS_INCOMPATIBLE_SESSIONS',
          'The target session is incompatible with the current session.'),
 '707': ('ERROR_RECEIVE_PARTIAL',
         '{Partial Data Received} The network transport returned partial data to its client. The remaining data will be sent later.'),
 '708': ('ERROR_RECEIVE_EXPEDITED',
         '{Expedited Data Received} The network transport returned data to its client that was marked as expedited by the remote system.'),
 '709': ('ERROR_RECEIVE_PARTIAL_EXPEDITED',
         '{Partial Expedited Data Received} The network transport returned partial data to its client and this data was marked as expedited by the remote system. The remaining data will be sent later.'),
 '71': ('ERROR_REQ_NOT_ACCEP',
        'No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept.'),
 '710': ('ERROR_EVENT_DONE',
         '{TDI Event Done} The TDI indication has completed successfully.'),
 '711': ('ERROR_EVENT_PENDING',
         '{TDI Event Pending} The TDI indication has entered the pending state.'),
 '712': ('ERROR_CHECKING_FILE_SYSTEM', 'Checking file system on %wZ'),
 '713': ('ERROR_FATAL_APP_EXIT', '{Fatal Application Exit} %hs'),
 '714': ('ERROR_PREDEFINED_HANDLE',
         'The specified registry key is referenced by a predefined handle.'),
 '715': ('ERROR_WAS_UNLOCKED',
         "{Page Unlocked} The page protection of a locked page was changed to 'No Access' and the page was unlocked from memory and from the process."),
 '716': ('ERROR_SERVICE_NOTIFICATION', '%hs'),
 '717': ('ERROR_WAS_LOCKED',
         '{Page Locked} One of the pages to lock was already locked.'),
 '718': ('ERROR_LOG_HARD_ERROR', 'Application popup: %1 : %2'),
 '719': ('ERROR_ALREADY_WIN32', 'ERROR_ALREADY_WIN32'),
 '72': ('ERROR_REDIR_PAUSED',
        'The specified printer or disk device has been paused.'),
 '720': ('ERROR_IMAGE_MACHINE_TYPE_MISMATCH_EXE',
         '{Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine.'),
 '721': ('ERROR_NO_YIELD_PERFORMED',
         'A yield execution was performed and no thread was available to run.'),
 '722': ('ERROR_TIMER_RESUME_IGNORED',
         'The resumable flag to a timer API was ignored.'),
 '723': ('ERROR_ARBITRATION_UNHANDLED',
         'The arbiter has deferred arbitration of these resources to its parent'),
 '724': ('ERROR_CARDBUS_NOT_SUPPORTED',
         'The inserted CardBus device cannot be started because of a configuration error on "%hs".'),
 '725': ('ERROR_MP_PROCESSOR_MISMATCH',
         'The CPUs in this multiprocessor system are not all the same revision level. To use all processors the operating system restricts itself to the features of the least capable processor in the system. Should problems occur with this system, contact the CPU manufacturer to see if this mix of processors is supported.'),
 '726': ('ERROR_HIBERNATED', 'The system was put into hibernation.'),
 '727': ('ERROR_RESUME_HIBERNATION',
         'The system was resumed from hibernation.'),
 '728': ('ERROR_FIRMWARE_UPDATED',
         'Windows has detected that the system firmware (BIOS) was updated [previous firmware date = %2, current firmware date %3].'),
 '729': ('ERROR_DRIVERS_LEAKING_LOCKED_PAGES',
         'A device driver is leaking locked I/O pages causing system degradation. The system has automatically enabled tracking code in order to try and catch the culprit.'),
 '730': ('ERROR_WAKE_SYSTEM', 'The system has awoken'),
 '731': ('ERROR_WAIT_1', 'ERROR_WAIT_1'),
 '732': ('ERROR_WAIT_2', 'ERROR_WAIT_2'),
 '733': ('ERROR_WAIT_3', 'ERROR_WAIT_3'),
 '734': ('ERROR_WAIT_63', 'ERROR_WAIT_63'),
 '735': ('ERROR_ABANDONED_WAIT_0', 'ERROR_ABANDONED_WAIT_0'),
 '736': ('ERROR_ABANDONED_WAIT_63', 'ERROR_ABANDONED_WAIT_63'),
 '737': ('ERROR_USER_APC', 'ERROR_USER_APC'),
 '738': ('ERROR_KERNEL_APC', 'ERROR_KERNEL_APC'),
 '739': ('ERROR_ALERTED', 'ERROR_ALERTED'),
 '740': ('ERROR_ELEVATION_REQUIRED',
         'The requested operation requires elevation.'),
 '741': ('ERROR_REPARSE',
         'A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.'),
 '742': ('ERROR_OPLOCK_BREAK_IN_PROGRESS',
         'An open/create operation completed while an oplock break is underway.'),
 '743': ('ERROR_VOLUME_MOUNTED',
         'A new volume has been mounted by a file system.'),
 '744': ('ERROR_RXACT_COMMITTED',
         'This success level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted. The commit has now been completed.'),
 '745': ('ERROR_NOTIFY_CLEANUP',
         'This indicates that a notify change request has been completed due to closing the handle which made the notify change request.'),
 '746': ('ERROR_PRIMARY_TRANSPORT_CONNECT_FAILED',
         '{Connect Failure on Primary Transport} An attempt was made to connect to the remote server %hs on the primary transport, but the connection failed. The computer WAS able to connect on a secondary transport.'),
 '747': ('ERROR_PAGE_FAULT_TRANSITION', 'Page fault was a transition fault.'),
 '748': ('ERROR_PAGE_FAULT_DEMAND_ZERO',
         'Page fault was a demand zero fault.'),
 '749': ('ERROR_PAGE_FAULT_COPY_ON_WRITE',
         'Page fault was a demand zero fault.'),
 '750': ('ERROR_PAGE_FAULT_GUARD_PAGE', 'Page fault was a demand zero fault.'),
 '751': ('ERROR_PAGE_FAULT_PAGING_FILE',
         'Page fault was satisfied by reading from a secondary storage device.'),
 '752': ('ERROR_CACHE_PAGE_LOCKED',
         'Cached page was locked during operation.'),
 '753': ('ERROR_CRASH_DUMP', 'Crash dump exists in paging file.'),
 '754': ('ERROR_BUFFER_ALL_ZEROS', 'Specified buffer contains all zeros.'),
 '755': ('ERROR_REPARSE_OBJECT',
         'A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.'),
 '756': ('ERROR_RESOURCE_REQUIREMENTS_CHANGED',
         'The device has succeeded a query-stop and its resource requirements have changed.'),
 '757': ('ERROR_TRANSLATION_COMPLETE',
         'The translator has translated these resources into the global space and no further translations should be performed.'),
 '758': ('ERROR_NOTHING_TO_TERMINATE',
         'A process being terminated has no threads to terminate.'),
 '759': ('ERROR_PROCESS_NOT_IN_JOB',
         'The specified process is not part of a job.'),
 '760': ('ERROR_PROCESS_IN_JOB', 'The specified process is part of a job.'),
 '761': ('ERROR_VOLSNAP_HIBERNATE_READY',
         '{Volume Shadow Copy Service} The system is now ready for hibernation.'),
 '762': ('ERROR_FSFILTER_OP_COMPLETED_SUCCESSFULLY',
         'A file system or file system filter driver has successfully completed an FsFilter operation.'),
 '763': ('ERROR_INTERRUPT_VECTOR_ALREADY_CONNECTED',
         'The specified interrupt vector was already connected.'),
 '764': ('ERROR_INTERRUPT_STILL_CONNECTED',
         'The specified interrupt vector is still connected.'),
 '765': ('ERROR_WAIT_FOR_OPLOCK',
         'An operation is blocked waiting for an oplock.'),
 '766': ('ERROR_DBG_EXCEPTION_HANDLED', 'Debugger handled exception'),
 '767': ('ERROR_DBG_CONTINUE', 'Debugger continued'),
 '768': ('ERROR_CALLBACK_POP_STACK',
         'An exception occurred in a user mode callback and the kernel callback frame should be removed.'),
 '769': ('ERROR_COMPRESSION_DISABLED',
         'Compression is disabled for this volume.'),
 '770': ('ERROR_CANTFETCHBACKWARDS',
         'The data provider cannot fetch backwards through a result set.'),
 '771': ('ERROR_CANTSCROLLBACKWARDS',
         'The data provider cannot scroll backwards through a result set.'),
 '772': ('ERROR_ROWSNOTRELEASED',
         'The data provider requires that previously fetched data is released before asking for more data.'),
 '773': ('ERROR_BAD_ACCESSOR_FLAGS',
         'The data provider was not able to interpret the flags set for a column binding in an accessor.'),
 '774': ('ERROR_ERRORS_ENCOUNTERED',
         'One or more errors occurred while processing the request.'),
 '775': ('ERROR_NOT_CAPABLE',
         'The implementation is not capable of performing the request.'),
 '776': ('ERROR_REQUEST_OUT_OF_SEQUENCE',
         'The client of a component requested an operation which is not valid given the state of the component instance.'),
 '777': ('ERROR_VERSION_PARSE_ERROR', 'A version number could not be parsed.'),
 '778': ('ERROR_BADSTARTPOSITION',
         "The iterator's start position is invalid."),
 '779': ('ERROR_MEMORY_HARDWARE',
         'The hardware has reported an uncorrectable memory error.'),
 '780': ('ERROR_DISK_REPAIR_DISABLED',
         'The attempted operation required self healing to be enabled.'),
 '781': ('ERROR_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE',
         'The Desktop heap encountered an error while allocating session memory. There is more information in the system event log.'),
 '782': ('ERROR_SYSTEM_POWERSTATE_TRANSITION',
         'The system power state is transitioning from %2 to %3.'),
 '783': ('ERROR_SYSTEM_POWERSTATE_COMPLEX_TRANSITION',
         'The system power state is transitioning from %2 to %3 but could enter %4.'),
 '784': ('ERROR_MCA_EXCEPTION',
         'A thread is getting dispatched with MCA EXCEPTION because of MCA.'),
 '785': ('ERROR_ACCESS_AUDIT_BY_POLICY',
         'Access to %1 is monitored by policy rule %2.'),
 '786': ('ERROR_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY',
         'Access to %1 has been restricted by your Administrator by policy rule %2.'),
 '787': ('ERROR_ABANDON_HIBERFILE',
         'A valid hibernation file has been invalidated and should be abandoned.'),
 '788': ('ERROR_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED',
         '{Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost. This error may be caused by network connectivity issues. Please try to save this file elsewhere.'),
 '789': ('ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR',
         '{Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost. This error was returned by the server on which the file exists. Please try to save this file elsewhere.'),
 '790': ('ERROR_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR',
         '{Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost. This error may be caused if the device has been removed or the media is write-protected.'),
 '791': ('ERROR_BAD_MCFG_TABLE',
         'The resources required for this device conflict with the MCFG table.'),
 '8': ('ERROR_NOT_ENOUGH_MEMORY',
       'Not enough storage is available to process this command.'),
 '80': ('ERROR_FILE_EXISTS', 'The file exists.'),
 '8001': ('FRS_ERR_INVALID_API_SEQUENCE',
          'The file replication service API was called incorrectly.'),
 '8002': ('FRS_ERR_STARTING_SERVICE',
          'The file replication service cannot be started.'),
 '8003': ('FRS_ERR_STOPPING_SERVICE',
          'The file replication service cannot be stopped.'),
 '8004': ('FRS_ERR_INTERNAL_API',
          'The file replication service API terminated the request. The event log may have more information.'),
 '8005': ('FRS_ERR_INTERNAL',
          'The file replication service terminated the request. The event log may have more information.'),
 '8006': ('FRS_ERR_SERVICE_COMM',
          'The file replication service cannot be contacted. The event log may have more information.'),
 '8007': ('FRS_ERR_INSUFFICIENT_PRIV',
          'The file replication service cannot satisfy the request because the user has insufficient privileges. The event log may have more information.'),
 '8008': ('FRS_ERR_AUTHENTICATION',
          'The file replication service cannot satisfy the request because authenticated RPC is not available. The event log may have more information.'),
 '8009': ('FRS_ERR_PARENT_INSUFFICIENT_PRIV',
          'The file replication service cannot satisfy the request because the user has insufficient privileges on the domain controller. The event log may have more information.'),
 '8010': ('FRS_ERR_PARENT_AUTHENTICATION',
          'The file replication service cannot satisfy the request because authenticated RPC is not available on the domain controller. The event log may have more information.'),
 '8011': ('FRS_ERR_CHILD_TO_PARENT_COMM',
          'The file replication service cannot communicate with the file replication service on the domain controller. The event log may have more information.'),
 '8012': ('FRS_ERR_PARENT_TO_CHILD_COMM',
          'The file replication service on the domain controller cannot communicate with the file replication service on this computer. The event log may have more information.'),
 '8013': ('FRS_ERR_SYSVOL_POPULATE',
          'The file replication service cannot populate the system volume because of an internal error. The event log may have more information.'),
 '8014': ('FRS_ERR_SYSVOL_POPULATE_TIMEOUT',
          'The file replication service cannot populate the system volume because of an internal timeout. The event log may have more information.'),
 '8015': ('FRS_ERR_SYSVOL_IS_BUSY',
          'The file replication service cannot process the request. The system volume is busy with a previous request.'),
 '8016': ('FRS_ERR_SYSVOL_DEMOTE',
          'The file replication service cannot stop replicating the system volume because of an internal error. The event log may have more information.'),
 '8017': ('FRS_ERR_INVALID_SERVICE_PARAMETER',
          'The file replication service detected an invalid parameter.'),
 '82': ('ERROR_CANNOT_MAKE', 'The directory or file cannot be created.'),
 '83': ('ERROR_FAIL_I24', 'Fail on INT 24.'),
 '84': ('ERROR_OUT_OF_STRUCTURES',
        'Storage to process this request is not available.'),
 '85': ('ERROR_ALREADY_ASSIGNED', 'The local device name is already in use.'),
 '86': ('ERROR_INVALID_PASSWORD',
        'The specified network password is not correct.'),
 '87': ('ERROR_INVALID_PARAMETER', 'The parameter is incorrect.'),
 '88': ('ERROR_NET_WRITE_FAULT', 'A write fault occurred on the network.'),
 '89': ('ERROR_NO_PROC_SLOTS',
        'The system cannot start another process at this time.'),
 '9': ('ERROR_INVALID_BLOCK', 'The storage control block address is invalid.'),
 '9001': ('DNS_ERROR_RCODE_FORMAT_ERROR',
          'DNS server unable to interpret format.'),
 '9002': ('DNS_ERROR_RCODE_SERVER_FAILURE', 'DNS server failure.'),
 '9003': ('DNS_ERROR_RCODE_NAME_ERROR', 'DNS name does not exist.'),
 '9004': ('DNS_ERROR_RCODE_NOT_IMPLEMENTED',
          'DNS request not supported by name server.'),
 '9005': ('DNS_ERROR_RCODE_REFUSED', 'DNS operation refused.'),
 '9006': ('DNS_ERROR_RCODE_YXDOMAIN',
          'DNS name that ought not exist, does exist.'),
 '9007': ('DNS_ERROR_RCODE_YXRRSET',
          'DNS RR set that ought not exist, does exist.'),
 '9008': ('DNS_ERROR_RCODE_NXRRSET',
          'DNS RR set that ought to exist, does not exist.'),
 '9009': ('DNS_ERROR_RCODE_NOTAUTH', 'DNS server not authoritative for zone.'),
 '9010': ('DNS_ERROR_RCODE_NOTZONE',
          'DNS name in update or prereq is not in zone.'),
 '9016': ('DNS_ERROR_RCODE_BADSIG', 'DNS signature failed to verify.'),
 '9017': ('DNS_ERROR_RCODE_BADKEY', 'DNS bad key.'),
 '9018': ('DNS_ERROR_RCODE_BADTIME', 'DNS signature validity expired.'),
 '9501': ('DNS_INFO_NO_RECORDS', 'No records found for given DNS query.'),
 '9502': ('DNS_ERROR_BAD_PACKET', 'Bad DNS packet.'),
 '9503': ('DNS_ERROR_NO_PACKET', 'No DNS packet.'),
 '9504': ('DNS_ERROR_RCODE', 'DNS error, check rcode.'),
 '9505': ('DNS_ERROR_UNSECURE_PACKET', 'Unsecured DNS packet.'),
 '9551': ('DNS_ERROR_INVALID_TYPE', 'Invalid DNS type.'),
 '9552': ('DNS_ERROR_INVALID_IP_ADDRESS', 'Invalid IP address.'),
 '9553': ('DNS_ERROR_INVALID_PROPERTY', 'Invalid property.'),
 '9554': ('DNS_ERROR_TRY_AGAIN_LATER', 'Try DNS operation again later.'),
 '9555': ('DNS_ERROR_NOT_UNIQUE',
          'Record for given name and type is not unique.'),
 '9556': ('DNS_ERROR_NON_RFC_NAME',
          'DNS name does not comply with RFC specifications.'),
 '9557': ('DNS_STATUS_FQDN', 'DNS name is a fully-qualified DNS name.'),
 '9558': ('DNS_STATUS_DOTTED_NAME', 'DNS name is dotted (multi-label).'),
 '9559': ('DNS_STATUS_SINGLE_PART_NAME', 'DNS name is a single-part name.'),
 '9560': ('DNS_ERROR_INVALID_NAME_CHAR',
          'DNS name contains an invalid character.'),
 '9561': ('DNS_ERROR_NUMERIC_NAME', 'DNS name is entirely numeric.'),
 '9562': ('DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER',
          'The operation requested is not permitted on a DNS root server.'),
 '9563': ('DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION',
          'The record could not be created because this part of the DNS namespace has been delegated to another server.'),
 '9564': ('DNS_ERROR_CANNOT_FIND_ROOT_HINTS',
          'The DNS server could not find a set of root hints.'),
 '9565': ('DNS_ERROR_INCONSISTENT_ROOT_HINTS',
          'The DNS server found root hints but they were not consistent across all adapters.'),
 '9566': ('DNS_ERROR_DWORD_VALUE_TOO_SMALL',
          'The specified value is too small for this parameter.'),
 '9567': ('DNS_ERROR_DWORD_VALUE_TOO_LARGE',
          'The specified value is too large for this parameter.'),
 '9568': ('DNS_ERROR_BACKGROUND_LOADING',
          'This operation is not allowed while the DNS server is loading zones in the background. Please try again later.'),
 '9569': ('DNS_ERROR_NOT_ALLOWED_ON_RODC',
          'The operation requested is not permitted on against a DNS server running on a read-only DC.'),
 '9570': ('DNS_ERROR_NOT_ALLOWED_UNDER_DNAME',
          'No data is allowed to exist underneath a DNAME record.'),
 '9601': ('DNS_ERROR_ZONE_DOES_NOT_EXIST', 'DNS zone does not exist.'),
 '9602': ('DNS_ERROR_NO_ZONE_INFO', 'DNS zone information not available.'),
 '9603': ('DNS_ERROR_INVALID_ZONE_OPERATION',
          'Invalid operation for DNS zone.'),
 '9604': ('DNS_ERROR_ZONE_CONFIGURATION_ERROR',
          'Invalid DNS zone configuration.'),
 '9605': ('DNS_ERROR_ZONE_HAS_NO_SOA_RECORD',
          'DNS zone has no start of authority (SOA) record.'),
 '9606': ('DNS_ERROR_ZONE_HAS_NO_NS_RECORDS',
          'DNS zone has no Name Server (NS) record.'),
 '9607': ('DNS_ERROR_ZONE_LOCKED', 'DNS zone is locked.'),
 '9608': ('DNS_ERROR_ZONE_CREATION_FAILED', 'DNS zone creation failed.'),
 '9609': ('DNS_ERROR_ZONE_ALREADY_EXISTS', 'DNS zone already exists.'),
 '9610': ('DNS_ERROR_AUTOZONE_ALREADY_EXISTS',
          'DNS automatic zone already exists.'),
 '9611': ('DNS_ERROR_INVALID_ZONE_TYPE', 'Invalid DNS zone type.'),
 '9612': ('DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP',
          'Secondary DNS zone requires master IP address.'),
 '9613': ('DNS_ERROR_ZONE_NOT_SECONDARY', 'DNS zone not secondary.'),
 '9614': ('DNS_ERROR_NEED_SECONDARY_ADDRESSES', 'Need secondary IP address.'),
 '9615': ('DNS_ERROR_WINS_INIT_FAILED', 'WINS initialization failed.'),
 '9616': ('DNS_ERROR_NEED_WINS_SERVERS', 'Need WINS servers.'),
 '9617': ('DNS_ERROR_NBSTAT_INIT_FAILED',
          'NBTSTAT initialization call failed.'),
 '9618': ('DNS_ERROR_SOA_DELETE_INVALID',
          'Invalid delete of start of authority (SOA)'),
 '9619': ('DNS_ERROR_FORWARDER_ALREADY_EXISTS',
          'A conditional forwarding zone already exists for that name.'),
 '9620': ('DNS_ERROR_ZONE_REQUIRES_MASTER_IP',
          'This zone must be configured with one or more master DNS server IP addresses.'),
 '9621': ('DNS_ERROR_ZONE_IS_SHUTDOWN',
          'The operation cannot be performed because this zone is shutdown.'),
 '9651': ('DNS_ERROR_PRIMARY_REQUIRES_DATAFILE',
          'Primary DNS zone requires datafile.'),
 '9652': ('DNS_ERROR_INVALID_DATAFILE_NAME',
          'Invalid datafile name for DNS zone.'),
 '9653': ('DNS_ERROR_DATAFILE_OPEN_FAILURE',
          'Failed to open datafile for DNS zone.'),
 '9654': ('DNS_ERROR_FILE_WRITEBACK_FAILED',
          'Failed to write datafile for DNS zone.'),
 '9655': ('DNS_ERROR_DATAFILE_PARSING',
          'Failure while reading datafile for DNS zone.'),
 '9701': ('DNS_ERROR_RECORD_DOES_NOT_EXIST', 'DNS record does not exist.'),
 '9702': ('DNS_ERROR_RECORD_FORMAT', 'DNS record format error.'),
 '9703': ('DNS_ERROR_NODE_CREATION_FAILED', 'Node creation failure in DNS.'),
 '9704': ('DNS_ERROR_UNKNOWN_RECORD_TYPE', 'Unknown DNS record type.'),
 '9705': ('DNS_ERROR_RECORD_TIMED_OUT', 'DNS record timed out.'),
 '9706': ('DNS_ERROR_NAME_NOT_IN_ZONE', 'Name not in DNS zone.'),
 '9707': ('DNS_ERROR_CNAME_LOOP', 'CNAME loop detected.'),
 '9708': ('DNS_ERROR_NODE_IS_CNAME', 'Node is a CNAME DNS record.'),
 '9709': ('DNS_ERROR_CNAME_COLLISION',
          'A CNAME record already exists for given name.'),
 '9710': ('DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT',
          'Record only at DNS zone root.'),
 '9711': ('DNS_ERROR_RECORD_ALREADY_EXISTS', 'DNS record already exists.'),
 '9712': ('DNS_ERROR_SECONDARY_DATA', 'Secondary DNS zone data error.'),
 '9713': ('DNS_ERROR_NO_CREATE_CACHE_DATA',
          'Could not create DNS cache data.'),
 '9714': ('DNS_ERROR_NAME_DOES_NOT_EXIST', 'DNS name does not exist.'),
 '9715': ('DNS_WARNING_PTR_CREATE_FAILED',
          'Could not create pointer (PTR) record.'),
 '9716': ('DNS_WARNING_DOMAIN_UNDELETED', 'DNS domain was undeleted.'),
 '9717': ('DNS_ERROR_DS_UNAVAILABLE', 'The directory service is unavailable.'),
 '9718': ('DNS_ERROR_DS_ZONE_ALREADY_EXISTS',
          'DNS zone already exists in the directory service.'),
 '9719': ('DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE',
          'DNS server not creating or reading the boot file for the directory service integrated DNS zone.'),
 '9720': ('DNS_ERROR_NODE_IS_DNAME', 'Node is a DNAME DNS record.'),
 '9721': ('DNS_ERROR_DNAME_COLLISION',
          'A DNAME record already exists for given name.'),
 '9722': ('DNS_ERROR_ALIAS_LOOP',
          'An alias loop has been detected with either CNAME or DNAME records.'),
 '9751': ('DNS_INFO_AXFR_COMPLETE', 'DNS AXFR (zone transfer) complete.'),
 '9752': ('DNS_ERROR_AXFR', 'DNS zone transfer failed.'),
 '9753': ('DNS_INFO_ADDED_LOCAL_WINS', 'Added local WINS server.'),
 '9801': ('DNS_STATUS_CONTINUE_NEEDED',
          'Secure update call needs to continue update request.'),
 '9851': ('DNS_ERROR_NO_TCPIP', 'TCP/IP network protocol not installed.'),
 '9852': ('DNS_ERROR_NO_DNS_SERVERS',
          'No DNS servers configured for local system.'),
 '9901': ('DNS_ERROR_DP_DOES_NOT_EXIST',
          'The specified directory partition does not exist.'),
 '9902': ('DNS_ERROR_DP_ALREADY_EXISTS',
          'The specified directory partition already exists.'),
 '9903': ('DNS_ERROR_DP_NOT_ENLISTED',
          'This DNS server is not enlisted in the specified directory partition.'),
 '9904': ('DNS_ERROR_DP_ALREADY_ENLISTED',
          'This DNS server is already enlisted in the specified directory partition.'),
 '9905': ('DNS_ERROR_DP_NOT_AVAILABLE',
          'The directory partition is not available at this time. Please wait a few minutes and try again.'),
 '9906': ('DNS_ERROR_DP_FSMO_ERROR',
          'The application directory partition operation failed. The domain controller holding the domain naming master role is down or unable to service the request or is not running Windows Server 2003.'),
 '994': ('ERROR_EA_ACCESS_DENIED',
         'Access to the extended attribute was denied.'),
 '995': ('ERROR_OPERATION_ABORTED',
         'The I/O operation has been aborted because of either a thread exit or an application request.'),
 '996': ('ERROR_IO_INCOMPLETE',
         'Overlapped I/O event is not in a signaled state.'),
 '997': ('ERROR_IO_PENDING', 'Overlapped I/O operation is in progress.'),
 '998': ('ERROR_NOACCESS', 'Invalid access to memory location.'),
 '999': ('ERROR_SWAPERROR', 'Error performing inpage operation.')}

